Package: doppelgangR
Title: Identify likely duplicate samples from genomic or meta-data
Version: 1.41.0
Authors@R: c(person("Levi", "Waldron", email = "lwaldron.research@gmail.com",
    role = c("aut", "cre")),
    person("Markus", "Reister", email = "markus.riester@novartis.com",
    role = c("aut", "ctb")),
    person("Marcel", "Ramos", email = "marcel.ramos@sph.cuny.edu",
    role = "ctb"))
Description: The main function is doppelgangR(), which takes as minimal
    input a list of ExpressionSet object, and searches all list
    pairs for duplicated samples.  The search is based on the
    genomic data (exprs(eset)), phenotype/clinical data
    (pData(eset)), and "smoking guns" - supposedly unique
    identifiers found in pData(eset).
Depends: R (>= 3.5.0), Biobase, BiocParallel
Imports: sva, impute, digest, mnormt, methods, grDevices, graphics,
        stats, SummarizedExperiment, utils
Suggests: BiocStyle, knitr, rmarkdown, curatedOvarianData, testthat
biocViews: ImmunoOncology, RNASeq, Microarray, GeneExpression,
        QualityControl
License: GPL (>=2.0)
Encoding: UTF-8
URL: https://github.com/lwaldron/doppelgangR,
        https://waldronlab.github.io/doppelgangR
BugReports: https://github.com/lwaldron/doppelgangR/issues
VignetteBuilder: knitr
RoxygenNote: 7.1.0
Date: 2025-05-12
git_url: https://git.bioconductor.org/packages/doppelgangR
git_branch: devel
git_last_commit: 039348e
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 22:24:41 UTC; biocbuild
Author: Levi Waldron [aut, cre],
  Markus Reister [aut, ctb],
  Marcel Ramos [ctb]
Maintainer: Levi Waldron <lwaldron.research@gmail.com>

# doppelgängR

## Introduction

*[doppelgangR](https://bioconductor.org/packages/3.23/doppelgangR)* is a
package for identifying duplicate samples within or between datasets of
transcriptome profiles. It is intended for microarray and RNA-seq gene
expression profiles where biological replicates are ordinarily more
distinct than technical replicates, as is the case for cancer types with
“noisy” genomes. It is intended for cases where per-gene summaries are
available but full genotypes are not, which is typical of public
databases such as the Gene Expression Omnibus.

Results from running `doppelgangR` on CRC, bladder, and ovarian [on
Dropbox](httpss://www.dropbox.com/sh/or3l7oo96x1ilm8/AAD1MVQVnoS6H7OExoYwOovSa?dl=0).

For the manuscript vignette, visit
<https://github.com/waldronlab/doppelgangR_paper>.

The `doppelgangR()` function identifies duplicates in three different
ways:

- **“expression”** doppelgängers have highly similar expression
  profiles, which are identified by default by having higher Pearson
  correlation than expected based on an empirical distribution of
  Pearson correlations between biological replicates. The type of
  correlation, and default use of ComBat batch correction, can be
  changed using the “corFinder.args” argument.

- **“phenotype”** doppelgängers have highly similar clinical or
  phenotype data, as contained in the phenoData slot of the
  `ExpressionSet`. In order to identify duplicates this way, it is
  required to curate the phenoData of each ExpressionSet they have
  identical column names, and encode phenotypes in the same way. For
  example, if each dataset provides information on age, this column of
  the phenoData could be called “age” in every dataset, and encoded as
  an integer number of years. If the phenoData slots are NULL then this
  type of checking will automatically be turned off. If they are not
  NULL but are also not curated, you should turn off phenotype checking
  by setting `phenoFinder.args=NULL`.

- **“smoking gun”** doppelgängers have the same value for an identifier
  that should be unique. You can enable this type of check by setting
  the argument “manual.smokingguns” to the names of columns containing
  supposedly unique identifiers, or setting “automatic.smokingguns” to
  TRUE, and the function will assume any column containing unique values
  within the column should also be unique across datasets.

This vignette focuses on the “expression” type of doppelgänger.

# Data types

Identification of doppelgängers is effective for both microarray and
**log-transformed** RNA-seq data, and even for matching samples that
have been profiled by microarray and RNA-seq.

# Case Study: Batch correction in Japanese datasets

We load for datasets by Yoshihara **et al.** that have been curated in
*[curatedOvarianData](https://bioconductor.org/packages/3.23/curatedOvarianData)*.
These are objects of class `ExpressionSet`.

``` r
library(curatedOvarianData)
data(GSE32062.GPL6480_eset)
data(GSE17260_eset)
```

The `doppelgangR` function requires a list of `ExpressionSet` objects as
input, which we create here:

``` r
testesets <- list(JapaneseA=GSE32062.GPL6480_eset,
                  Yoshihara2010=GSE17260_eset)
```

Now run `doppelgangR` with default arguments, except for setting
`phenoFinder.args=NULL`, which turns off checking for similar clinical
data in the `phenoData` slot of the ExpressionSet objects:

``` r
results1 <- doppelgangR(testesets, phenoFinder.args=NULL)
```

This creates an object of class `DoppelGang`, which has print, summary,
and plot methods. Summary method output not shown here due to voluminous
output:

``` r
summary(results1)
```

Plot creates a histogram of sample pairwise correlations within and
between each study:

``` r
par(mfrow=c(2,2), las=1)
plot(results1)
#> Warning in int_abline(a = a, b = b, h = h, v = v, untf = untf, ...): partial argument match of 'lw' to 'lwd'
#> Warning in int_abline(a = a, b = b, h = h, v = v, untf = untf, ...): partial argument match of 'lw' to 'lwd'
#> Warning in int_abline(a = a, b = b, h = h, v = v, untf = untf, ...): partial argument match of 'lw' to 'lwd'
```

<div class="figure">

<img src="/home/mramos/gh/doppelgangR/README_files/figure-gfm/plotdop-1.png" alt="Doppelgängers identified on the basis of similar expression profiles. The vertical red lines indicate samples that were flagged." width="100%" />
<p class="caption">

Doppelgängers identified on the basis of similar expression profiles.
The vertical red lines indicate samples that were flagged.
</p>

</div>

One of these histograms can be drawn using the plot.pair argument:

``` r
plot(results1, plot.pair=c("JapaneseA", "JapaneseA"))
#> Warning in int_abline(a = a, b = b, h = h, v = v, untf = untf, ...): partial argument match of 'lw' to 'lwd'
```

<div class="figure">

<img src="/home/mramos/gh/doppelgangR/README_files/figure-gfm/plotdop2-1.png" alt="Pair plot of JapaneseA:JapaneseA Doppelgängers identified. The vertical red lines indicate samples that were flagged." width="100%" />
<p class="caption">

Pair plot of JapaneseA:JapaneseA Doppelgängers identified. The vertical
red lines indicate samples that were flagged.
</p>

</div>

# Important options

## Changing sensitivity

If after inspecting the histograms, you see that some visible outliers
were not caught, or non-outliers exceeded the sensitivity threshold, you
can change the default sensitivity using the argument:

``` r
outlierFinder.expr.args =
    list(bonf.prob = 0.5, transFun = atanh, tail = "upper")
```

The default 0.5 is a reasonable but arbitrary trade-off between
sensitivity and specificity which we have found to often select dataset
pairs containing duplicates, but to often not find *all* the duplicate
samples. Sensitivity can be increased by changing the bonf.prob
argument, *i.e.*:

``` r
results1 <- doppelgangR(testesets, 
        outlierFinder.expr.args = list(bonf.prob = 1.0, transFun = atanh, 
                                       tail = "upper"))
```

## Use of the ExpressionSet

The `doppelgangR()` function takes as its main argument a list of
`ExpressionSet` objects. If you just have matrices, you can easily
convert these to the `ExpressionSet` objects, for example:

``` r
mat <- matrix(1:4, ncol=2)
library(Biobase)
eset <- ExpressionSet(mat)
class(eset)
#> [1] "ExpressionSet"
#> attr(,"package")
#> [1] "Biobase"
```

## Parallelizing

The `doppelgangR()` function checks all pairwise combinations of
datasets in a list of `ExpressionSet` objects, and these dataset pairs
can be checked in parallel using multiple processing cores using the
BPPARAM argument. This functionality is imported from the
(“BiocParallel”) package. Please see
“?BiocParallel::\`BiocParallelParam-class\`” documentation.

``` r
results2 <- doppelgangR(testesets, BPPARAM = MulticoreParam(workers = 8))
```

## Caching

By default, the `doppelgangR()` function caches intermediate results to
make re-running with different arguments faster. Turn caching off by
setting the argument `cache.dir=NULL`.

## TCGA.R should be run first, as this script uses its product suitability.table.csv.


if( !require(RTCGAToolbox) ){
    library(devtools)
    install_github("LiNk-NY/RTCGAToolbox")
    library(RTCGAToolbox)
}

all.dates <- getFirehoseRunningDates()
all.datasets <- getFirehoseDatasets()

data.path <- "."
data.file <- file.path(data.path, "TCGA.rda")
if(file.exists(data.file)){
    load(data.file)
}else{
    tcga.res <- list()
    for (i in 1:length(all.datasets)){
        (ds.name <- all.datasets[i])
        if(!ds.name %in% names(tcga.res)){
            res <- try(getFirehoseData(ds.name, runDate=all.dates[1], RNAseq_Gene=TRUE, RNAseq2_Gene_Norm=TRUE, mRNA_Array=TRUE))
        }
        if(!is(res, "try-error")){
            tcga.res[[ds.name]] <- res
        }
    }
    save(tcga.res, file=data.file)
}


library(Biobase)
if(file.exists(file.path(data.path, "tcga.microarray_RNAseq.rda"))){
  load(file.path(data.path, "tcga.microarray_RNAseq.rda"))
}else{
  eset.list <- list()
    for (i in 1:length(tcga.res)){
      print(names(tcga.res)[i])
      RNAseq <- list()
      arraydat <- try(extract(tcga.res[[i]], "mRNA_Array"))
      if(is(arraydat, "try-error")) next
      RNAseq[["rnaseq"]] <- try(extract(tcga.res[[i]], "RNAseq_Gene"))
      RNAseq[["rnaseq2"]] <- try(extract(tcga.res[[i]], "RNAseq2_Gene_Norm"))
      if(is(RNAseq[["rnaseq"]], "try-error") && is(RNAseq[["rnaseq2"]], "try-error")) next
      RNAseq <- RNAseq[sapply(RNAseq, function(x) !is(x, "try-error"))]
      pickplat <- which.max(sapply(RNAseq, ncol))
      print(paste(names(tcga.res)[i], ":", names(RNAseq)[pickplat]))
      eset.list[[names(tcga.res)[i]]] = list()
      ## use only primary tumors
      arraydat = arraydat[, substr(sampleNames(arraydat),14,15) %in% c( "01", "03", "09" )]
      seqdat = RNAseq[[pickplat]][ ,substr(sampleNames(RNAseq[[pickplat]]),14,15) %in% c( "01", "03", "09" )]
      eset.list[[ names(tcga.res)[i] ]][["microarray"]] = arraydat
      eset.list[[ names(tcga.res)[i] ]][[paste(names(tcga.res)[i], names(RNAseq)[pickplat])]] <- seqdat
    }
    save(eset.list, file=file.path(data.path, "tcga.microarray_RNAseq.rda"))
}



tcga.remove <- read.delim(system.file("extdata", "TCGA_remove.txt",
                                      package="doppelgangR"), as.is=TRUE)[, 1]
tcga.remove <- tolower(tcga.remove)
eset.list$OV$microarray <- eset.list$OV$microarray[, !make.names(substr(sampleNames(eset.list$OV$microarray), 1, 12)) %in% tcga.remove]

library(doppelgangR)
if(file.exists("doppelgangR.microarray_RNAseq_nolog2.rda")){
  load("doppelgangR.microarray_RNAseq_nolog2.rda")
}else{
  doppelgangR.microarray_RNAseq <- list()
  for (i in 1:length(eset.list)){
    print(names(eset.list)[i])
    eset.pair = eset.list[[i]]
#    exprs(eset.pair[[2]]) = log(exprs(eset.pair[[2]]) + 1)
    doppelgangR.microarray_RNAseq[[names(eset.list)[i]]] = doppelgangR(esets=eset.pair, phenoFinder.args = NULL, smokingGunFinder.args = NULL)
  }
  save( doppelgangR.microarray_RNAseq, file="doppelgangR.microarray_RNAseq_nolog2.rda")
}

doppelmelt <- function(obj, ds1, ds2){
  if(paste(ds1, ds2, sep=":") %in% names(obj@fullresults)){
    ds <- paste(ds1, ds2, sep=":")
  }else if(paste(ds2, ds1, sep=":") %in% names(obj@fullresults)){
    ds <- paste(ds2, ds1, sep=":")
  }else{
    return(NULL)
  }
  cormat <- obj@fullresults[[ds]]$correlations
  if(nrow(cormat) < ncol(cormat)) cormat <- t(cormat)
  idx <- sapply(rownames(cormat), function(x) which.max(cormat[x, ]))
  corvec <- sapply(1:nrow(cormat), function(i) cormat[i, idx[i]])
  output <- data.frame(sample1=rownames(cormat),
                       sample2=colnames(cormat)[idx],
                       cor=corvec, stringsAsFactors=FALSE)
  output$truepos <- sub(".+:", "", output[, 1]) == sub(".+:", "", output[, 2])
  return(output)
}
plotROC <- function(pred, labels, plot = TRUE, na.rm = TRUE, colorize = FALSE, addtext=TRUE, ...) {
  require(ROCR)
  require(pROC)
  if (na.rm) {
    idx <- !is.na(labels)
    pred <- pred[idx]
    labels <- labels[idx]
  }
  pred.rocr <- ROCR::prediction(pred, labels)
  perf.rocr <- ROCR::performance(pred.rocr, "tpr", "fpr")
  auc <- performance(pred.rocr, "auc")@y.values[[1]][[1]]
  roc.obj <- roc(labels, pred)
  auc.ci <- ci(roc.obj)
  significant <- ifelse(ci(roc.obj, conf.level=0.9)[1] > 0.5, "*", "")
  best <- coords(roc.obj,x="best", transpose = FALSE)
  if (plot) {
    plot(perf.rocr, colorize = colorize, cex.lab = 1.3, bty="n", lty=1:length(perf.rocr),...)
    abline(a = 0, b = 1, lty = 2)
    if(addtext){
      text(0, 0.9, paste("AUC = ", round(auc, digits = 2), significant,
                         sep=""), cex = 1.5, pos = 4)
      text(1, 0.1, paste("n =", length(labels)), cex = 1.5, pos = 2)
    }
  }
  invisible(list(auc,auc.ci,best))
}

pdf("microarray_RNAseq_nolog2.pdf", width=8, height=4)
par(mfrow=c(1, 2))
res <- list()
for (i in 1:length(doppelgangR.microarray_RNAseq)){
  exptnames <- names(doppelgangR.microarray_RNAseq[[i]]@fullresults)[[3]]
  exptnames <- strsplit(exptnames, ":")[[1]]
  roc1 <- doppelmelt(doppelgangR.microarray_RNAseq[[i]], exptnames[1], exptnames[2])
  res[[i]] <- plotROC(roc1$cor, roc1$truepos, main=names(doppelgangR.microarray_RNAseq)[[i]])
  plot(doppelgangR.microarray_RNAseq[[i]], plot.pair=exptnames)
}
names(res) <- names(doppelgangR.microarray_RNAseq)
dev.off()

pdf("microarray_RNAseq_doppelgangerout_nolog2.pdf", width=9, height=3)
par(mfrow=c(1, 3))
for (i in 1:length(doppelgangR.microarray_RNAseq)){
  plot(doppelgangR.microarray_RNAseq[[i]])
}
dev.off()

suitability.table <- read.csv("suitability.table.csv", row.names=1, as.is=TRUE)
suitability.table$AUC = NA
rocvec <- sapply(res, function(x) x[[1]])
suitability.table$AUC[match(names(rocvec), suitability.table$cancertype)] <- rocvec
write.csv(suitability.table[, c("cancertype", "Study.Name", "quantile999", "AUC")], file="TCGA_microarray_RNAseq_nolog2.csv")

.checkSameSets <- function(sets) {
    matrix.one <- SummarizedExperiment::assay(sets[[1]])
    dimnames(matrix.one) <- NULL
    matrix.two <- SummarizedExperiment::assay(sets[[2]])
    dimnames(matrix.two) <- NULL
    coldata.one <- SummarizedExperiment::colData(sets[[1]])
    rownames(coldata.one) <- NULL
    coldata.two <- SummarizedExperiment::colData(sets[[2]])
    rownames(coldata.two) <- NULL

    identical(matrix.one, matrix.two) && identical(coldata.one, coldata.two)
}

#' Calculate pairwise similarities of colData between samples for a list
#' containing two DataFrame
#'
#' This function acts as a wrapper to colData to handle cases of one
#' DataFrame, a list of two identical DataFrame, or a list of two
#' different DataFrame
#'
#'
#' @param summex.list input: a list of DataFrame with two elements, or a
#' DataFrame. If the two elements are identical, return the correlation
#' matrix for pairs of samples in the first element.  If not identical, return
#' pairs between the two elements.
#' @param \dots Extra arguments passed on to colFinder
#' @return A matrix of similarities between the colData of pairs of samples.
#' @author Fabio Da Col, Marcel Ramos
#'
#' @export colFinder
colFinder <- function(summex.list, ...) {
    if (!is(summex.list, "list") | length(summex.list) != 2)
        stop("list should be a list of length 2")

  if (!identical(colnames(colData(summex.list[[1]])), colnames(colData(summex.list[[2]])))) {
    stop(
      "Slots of list must have identical column names, e.g.
      identical(colnames(colData(summex.list[[1]])), colnames(colData(summex.list[[2]])))"
    )
  }
  matrix.one <- as.matrix(colData(summex.list[[1]]))
  if(is.null(rownames(matrix.one)))
    rownames(matrix.one) <- make.names(1:nrow(matrix.one))
  keep.col <- apply(matrix.one, 2, function(x){
    !all(is.na(x))
  })
  keep.col <- keep.col[names(keep.col) %in% colnames(matrix.one)]
  matrix.one <-
    subset(matrix.one, select = match(names(keep.col), colnames(matrix.one)))
  matrix.one <- subset(matrix.one, select = keep.col)
  if(.checkSameSets(summex.list)){
    similarity.mat <- 1 - phenoDist(matrix.one, ...)
    similarity.mat[!upper.tri(similarity.mat)] <- NA
  }else{
    matrix.two <- as.matrix(summex.list[[2]])
    matrix.two <-
      matrix.two[, match(colnames(matrix.one), colnames(matrix.two)), drop = FALSE]
    if(is.null(rownames(matrix.two)))
      rownames(matrix.two) <- make.names(1:nrow(matrix.two))
    similarity.mat <- 1 - phenoDist(matrix.one, matrix.two, ...)
  }
  return(similarity.mat)
}

#' Find doppelgangers based on "smoking gun" phenotypes - those that should be
#' unique to each patient.
#' 
#' Checks all pairwise combinations of samples for values of the "smoking" gun
#' phenotypes that are identical.
#' 
#' 
#' @param eset.pair a list of ExpressionSets, with two elements.  If the two
#' elements are identical, the function will check for duplicate IDs within one
#' element. If not identical, it will check for duplicate IDs between elements.
#' @param smokingguns phenoData column names found in multiple elements of
#' eset.pair that may contain "smoking guns" such as identifiers that should be
#' unique to each sample.
#' @param transFun a function to apply to IDs before comparing.  By default
#' apply no transformation.
#' @param separator Separator between dataset name and sample name.  Dataset
#' names are added to sample names to keep track of dataset of origin.
#' @return Returns an adjacency matrix for samples where matches have value 1,
#' non-matches have value zero.  Value for a sample against itself is NA.
#' @author Levi Waldron, Markus Riester, Marcel Ramos
#' @examples
#' 
#' example("phenoFinder")
#' 
#' smokingGunFinder(esets2, "days_to_death")
#' 
#' @export smokingGunFinder
smokingGunFinder <-
  function  #Find doppelgangers based on "smoking gun" phenotypes - those that should be unique to each patient.
### Checks all pairwise combinations of samples for values of the
### "smoking" gun phenotypes that are identical.
(eset.pair,
 ### a list of ExpressionSets, with two elements.  If the two elements
 ### are identical, the function will check for duplicate IDs within
 ### one element. If not identical, it will check for duplicate IDs
 ### between elements.
 smokingguns,
 ### phenoData column names found in multiple elements of eset.pair
 ### that may contain "smoking guns" such as identifiers that should be
 ### unique to each sample.
 transFun = I,
 ### a function to apply to IDs before comparing.  By default apply no transformation.
 separator = ":"
 ### Separator between dataset name and sample name.  Dataset names are
 ### added to sample names to keep track of dataset of origin.
) {
  if (!is(eset.pair, "list") | length(eset.pair) != 2)
    stop("eset.pair should be a list of two ExpressionSets")
  smokingmat <-
    matrix(0,
           nrow = ncol(eset.pair[[1]]),
           ncol = ncol(eset.pair[[2]]))
  rownames(smokingmat) <- sampleNames(eset.pair[[1]])
  colnames(smokingmat) <- sampleNames(eset.pair[[2]])
  for (x in smokingguns) {
    if (!(x %in% colnames(pData(eset.pair[[1]]))) |
        !(x %in% colnames(pData(eset.pair[[2]]))))
      next
    pdat.vec1 <- transFun(pData(eset.pair[[1]])[, x])
    pdat.vec2 <- transFun(pData(eset.pair[[2]])[, x])
    for (i in 1:length(pdat.vec1)) {
      if (is.na(pdat.vec1[i]))
        next
      matches <- pdat.vec2 %in% pdat.vec1[i]
      matches[is.na(pdat.vec2)] <- FALSE
      smokingmat[i, pdat.vec2 %in% pdat.vec1[i]] <-
        smokingmat[i, pdat.vec2 %in% pdat.vec1[i]] + 1
    }
  }
  if (.checkSameEsets(eset.pair)) {
    smokingmat[!upper.tri(smokingmat)] <-
      NA  ##NA for all but upper triangle.
  }
  return(smokingmat)
  ### Returns an adjacency matrix for samples where matches have value
  ### 1, non-matches have value zero.  Value for a sample against itself
  ### is NA.
}

#' Identify likely duplicate samples from genomic or meta-data
#'
#' The main function is doppelgangR(), which takes as minimal input a list of
#' ExpressionSet object, and searches all list pairs for duplicated samples.
#' The search is based on the genomic data (exprs(eset)), phenotype/clinical
#' data (pData(eset)), and "smoking guns" - supposedly unique identifiers found
#' in pData(eset).
#'
#' @importFrom Biobase exprs featureNames sampleNames pData "sampleNames<-"
#' "exprs<-" "pData<-"
#' @importFrom BiocParallel bplapply bpparam
#' @importFrom sva ComBat
#' @importFrom digest digest
#' @importFrom impute impute.knn
#' @importFrom mnormt pmt biv.nt.prob pmnorm
#' @import methods
#' @importFrom grDevices dev.interactive
#' @importFrom graphics abline contour curve hist legend lines pairs par points title
#' @importFrom stats coef complete.cases cor cov2cor
#'           dchisq dnorm dt integrate lm.fit
#'           model.matrix na.omit nlminb optim pchisq
#'           pf pnorm pt qchisq qf qnorm rchisq
#'           resid rnorm runif uniroot var
#'           weighted.mean
#' @importFrom utils combn
#' @importFrom SummarizedExperiment assay colData
#'
#' @name doppelgangR-package
#' @aliases NULL doppelgangR-package
#' @docType package
#' @author Levi Waldron, Markus Riester, Marcel Ramos
#'
#' @keywords package
"_PACKAGE"

#' Identifies outliers in a similarity matrix.
#' 
#' By default uses the Fisher z-transform for Pearson correlation (atanh), and
#' identifies outliers as those above the quantile of a skew-t distribution
#' with mean and standard deviation estimated from the z-transformed matrix.
#' The quantile is calculated from the Bonferroni-corrected cumulative
#' probability of the upper tail.
#' 
#' 
#' @param similarity.mat A matrix of similarities - larger values mean more
#' similar.
#' @param bonf.prob Bonferroni-corrected probability.  A raw.prob is calculated
#' by dividing this by the number of non-missing values in similarity.mat, and
#' the rejection threshold is qnorm(1-raw.prob, mean, sd) where mean and sd are
#' estimated from the transFun-transformed similarity.mat.
#' @param transFun A function applied to the numeric values of similarity.mat,
#' that should result in normally-distributed values.
#' @param normal.upper.thresh Instead of specifying bonf.prob and transFun, an
#' upper similarity threshold can be set, and values above this will be
#' considered likely duplicates.  If specified, this over-rides bonf.prob.
#' @param tail "upper" to look for samples with very high similarity values,
#' "lower" to look for very low values, or "both" to look for both.
#' @return Returns either NULL or a dataframe with three columns: sample1,
#' sample2, and similarity.
#' @author Levi Waldron, Markus Riester, Marcel Ramos
#' @examples
#' 
#' library(curatedOvarianData)
#' data(GSE32063_eset)
#' cormat <- cor(exprs(GSE32063_eset))
#' outlierFinder(cormat, bonf.prob = 0.05)
#' 
#' @export outlierFinder
outlierFinder <-
  function ###Identifies outliers in a similarity matrix.
### By default uses the
### Fisher z-transform for Pearson correlation (atanh), and
### identifies outliers as those above the quantile of a skew-t
### distribution with mean and standard deviation estimated from the
### z-transformed matrix.  The quantile is calculated from the
### Bonferroni-corrected cumulative probability of the upper tail.
(
  similarity.mat,
  ### A matrix of similarities - larger values mean more similar.
  bonf.prob = 0.05,
  ### Bonferroni-corrected probability.  A raw.prob is calculated by
  ### dividing this by the number of non-missing values in
  ### similarity.mat, and the rejection threshold is qnorm(1-raw.prob,
  ### mean, sd) where mean and sd are estimated from the
  ### transFun-transformed similarity.mat.
  transFun = atanh,
  ### A function applied to the numeric values of similarity.mat, that
  ### should result in normally-distributed values.
  normal.upper.thresh = NULL,
  ### Instead of specifying bonf.prob and transFun, an upper similarity
  ### threshold can be set, and values above this will be considered
  ### likely duplicates.  If specified, this over-rides bonf.prob.
  tail = "upper"
  ### "upper" to look for samples with very high similarity values,
  ### "lower" to look for very low values, or "both" to look for both.
) {
  if (is.null(transFun))
    transFun <- I
  trans.mat <- transFun(similarity.mat)
  if (!is.null(normal.upper.thresh))
    bonf.prob <- NULL
  if (!is.null(bonf.prob)) {
    znum <- na.omit(as.numeric(trans.mat))
    raw.prob <- bonf.prob / length(znum)
    ##        stfit <- st.mle(y=znum)
    stfit <- st.mle(y = znum[is.finite(znum)])
    if (identical(tail, "upper")) {
      z.cutoff <-
        qst(
          p = 1 - raw.prob,
          location = stfit$dp["location"],
          scale = stfit$dp["scale"],
          shape = stfit$dp["shape"],
          df = stfit$dp["df"]
        )
      outlier.mat <- trans.mat > z.cutoff
    } else if (identical(tail, "lower")) {
      z.cutoff <-
        qst(
          p = raw.prob,
          location = stfit$dp["location"],
          scale = stfit$dp["scale"],
          shape = stfit$dp["shape"],
          df = stfit$dp["df"]
        )
      outlier.mat <- trans.mat < z.cutoff
    } else if (identical(tail, "both")) {
      z.cutoff <-
        qst(
          p = c(raw.prob, 1 - raw.prob),
          location = stfit$dp["location"],
          scale = stfit$dp["scale"],
          shape = stfit$dp["shape"],
          df = stfit$dp["df"]
        )
      outlier.mat <-
        (trans.mat < z.cutoff[1]) | (trans.mat > z.cutoff[2])
    } else{
      stop("tail argument should be upper, lower, or both.")
    }
  } else if (!is.null(normal.upper.thresh)) {
    outlier.mat <- trans.mat > normal.upper.thresh
    stfit <- NULL
  } else{
    return(NULL)
  }
  output <-
    .outer2df(
      rownames(outlier.mat),
      colnames(outlier.mat),
      bidirectional = TRUE,
      diag = TRUE
    )
  output$similarity <-
    .outer2df(similarity.mat, bidirectional = TRUE, diag = TRUE)
  output$doppel <-
    .outer2df(outlier.mat, bidirectional = TRUE, diag = TRUE)
  output <- output[!is.na(output$similarity), ]
  output <- output[output[, 1] != output[, 2], ]
  colnames(output)[1:2] <- c("sample1", "sample2")
  return(list(outlierFinder.res = output, stfit = stfit))
  ### Returns either NULL or a dataframe with three columns: sample1, sample2, and similarity.
}

.outer2df <- function  #going from matrices to two columns
### Output rows contain all possible
### pairwise combinations of x and y
(x, y,
 ### If x is a vector and y is a vector, return all or subsets of
 ### outer(x, y) depending on the values of bidirectional and diag.  If
 ### x is a matrix and y is unspecified, return the elements of x in
 ### the same order as would be returned if x=rownames and y=colnames.
 bidirectional = TRUE,
 ### If TRUE, include separate rows for elements i, j and j, i
 diag = TRUE
 ### If TRUE, include i, i elements.
) {
  bizarre.and.unlikely.separator = " as3a2s5df5hjnm4qwe2rxcvb "
  if (is(x, "matrix")) {
    output.samples <- x
  } else if (is.vector(x) & is.vector(y)) {
    output.samples <-
      outer(x, y, paste, sep = bizarre.and.unlikely.separator)
  } else{
    stop("Require either x to be a matrix, or both x and y to be vectors.")
  }
  if (!bidirectional & !diag) {
    output.samples <- output.samples[upper.tri(output.samples)]
  } else if (!bidirectional & diag) {
    output.samples <- output.samples[!lower.tri(output.samples)]
  } else if (bidirectional & !diag) {
    output.samples <-
      output.samples[upper.tri(output.samples) |
                       lower.tri(output.samples)]
  } else if (bidirectional & diag) {
    output.samples <- as.vector(output.samples)
  }
  if (any(grepl(bizarre.and.unlikely.separator, output.samples, fixed =
                TRUE))) {
    output <-
      data.frame(do.call(
        rbind,
        strsplit(output.samples, split = bizarre.and.unlikely.separator)
      ),
      stringsAsFactors = FALSE)
  } else{
    output <- output.samples
  }
  return(output)
  ### A two-column dataframe if x and y are vectors, or a vector if x is
  ### a matrix and y is NULL.
}

library(Biobase)

if(file.exists("ovarian_esets.rda")){
    load("ovarian_esets.rda")
}else{
    library(curatedOvarianData)
    library(logging)
    source(system.file("extdata",
                       "patientselection_all.config",package="curatedOvarianData"))
    min.number.of.genes <- 2000
    source(system.file("extdata", "createEsetList.R", package =
                       "curatedOvarianData"))
    rm(list=ls(pattern="_eset"))
    save(esets, file="ovarian_esets.rda")
}
table(table(unlist(lapply(esets, sampleNames))))

library(doppelgangR)

if(!file.exists("ovarian_dop.rda")){
  dop <- doppelgangR(esets, phenoFinder.args=NULL, smokingGunFinder.args=NULL,
                   outlierFinder.expr.args=list(bonf.prob = 1.0, transFun = atanh, tail = "upper"))
  warnings()
  save(dop, file="ovarian_dop.rda")
}else{
  load("ovarian_dop.rda")
}

##Look for smoking guns only:
dop.gun <- doppelgangR(esets, manual.smokingguns="alt_sample_name", phenoFinder.args=NULL,
                       corFinder.args=NULL, impute.knn.args=NULL, cache.dir = NULL)
save(dop.gun, file="ovarian_dopgun.rda")
write.csv(summary(dop.gun), file="ovarian_dopgun.csv")

##Look for smoking guns only:
for (i in 1:length(esets))
    esets[[i]]$samplenames <- sampleNames(esets[[i]])
dop.gun <- doppelgangR(esets, manual.smokingguns=c("alt_sample_name", "unique_patient_ID", "samplenames"),
                       phenoFinder.args=NULL, corFinder.args=NULL, impute.knn.args=NULL)
save(dop.gun, file="ovarian_dopgun.rda")
write.csv(summary(dop.gun), file="ovarian_dopgun.csv")

load("ovarian_dop.rda")
write.csv(dop@summaryresults, file="ovarian_dop.csv")
pdf("ovarian_dop.pdf")
plot(dop, skip.no.doppels=TRUE)
dev.off()

wuetal <- doppelgangR(esets[["GSE44104_eset"]], outlierFinder.expr.args = list(bonf.prob = 40, transFun = atanh, tail = "upper"))
wuetaltable <- summary(wuetal); rownames(wuetaltable) <- NULL
wuetaltable[, 1] <- paste0("GSE41044_eset:", wuetaltable[, 1])
wuetaltable[, 2] <- paste0("GSE41044_eset:", wuetaltable[, 2])
write.csv(wuetaltable, file="wuetal.csv")


library(pheatmap)
cormat <- wuetal@fullresults[[1]][[1]]
rownames(cormat) <- sub("ExpressionSet1:", "", rownames(cormat))
colnames(cormat) <- sub("ExpressionSet2:", "", colnames(cormat))

pdf("GSE44104.pdf", width=6.5, height=6.5)
plot(wuetal)
pheatmap(cormat, fontsize_row=6, fontsize_col=6)
dev.off()

library(GEOquery)
eset=getGEO("GSE44104")[[1]]
wuetal2 <- doppelgangR(eset, outlierFinder.expr.args = list(bonf.prob = 40, transFun = atanh, tail = "upper"))
plot(wuetal2)

#' Calculate a weighted distance between two vectors, using pairwise complete
#' observations.
#' 
#' Simple function to count the fraction of different elements (in the same
#' position) between two vectors of the same length, after removing elements
#' from both vectors corresponding to positions that are NA in either vector.
#' Distance is the probability for observing the matches and mismatches in two
#' random patients.
#' 
#' 
#' @param x a matrix
#' @param y a matrix with the same number of columns as x
#' @param k row in x to test for differences
#' @param l row in y to test for differences
#' @return Returns a numeric value, the log of the probability of observing the
#' matches in x and y
#' @author Levi Waldron, Markus Riester, Marcel Ramos
#' @examples
#' 
#' mymat1 <- matrix(rnorm(20), ncol = 5)
#' mymat1[1, 4] <- NA
#' mymat2 <- matrix(rnorm(20), ncol = 5)
#' vectorWeightedDist(mymat1, mymat2, 1, 2)
#' 
#' @export vectorWeightedDist
vectorWeightedDist <-
  function #Calculate a weighted distance between two vectors, using pairwise complete observations.
### Simple function to count the fraction of different elements (in
### the same position) between two vectors of the same length, after
### removing elements from both vectors corresponding to positions
### that are NA in either vector. Distance is the probability for observing
### the matches and mismatches in two random patients.
(x,
 ### a matrix
 y,
 ### a matrix with the same number of columns as x
 k,
 ### row in x to test for differences
 l
 ### row in y to test for differences
) {
  idx <- !(is.na(x[k, ]) | is.na(y[l, ]))
  
  if (sum(idx) < 2)
    return(1)
  
  x <- x[, idx, drop = FALSE]
  y <- y[, idx, drop = FALSE]
  
  p.x <- sapply(1:ncol(x), function(i)
    sum(x[k, i] == x[, i],
        na.rm = TRUE) / nrow(x[!is.na(x[, i]), ]))
  p.y <- sapply(1:ncol(y), function(i)
    sum(y[l, i] == y[, i],
        na.rm = TRUE) / nrow(y[!is.na(y[, i]), ]))
  
  idx <- x[k, ] != y[l, ]
  w <- 1 - p.x * p.y
  if (sum(w) < 2)
    return(1)
  1 - (sum(ifelse(idx, -1, 1) * w) / sum(w) + 1) / 2
  ### Returns a numeric value, the log of the probability of observing the
  ### matches in x and y
}

msn.mle <- function(X,
                    y,
                    freq,
                    start,
                    trace = FALSE,
                    algorithm = c("nlminb", "Nelder-Mead", "BFGS", "CG",  "SANN"),
                    control = list())
{
  y <- data.matrix(y)
  if (missing(X))
    X <- rep(1, nrow(y))
  else {
    if (!is.numeric(X))
      stop("X must be numeric")
  }
  if (missing(freq))
    freq <- rep(1, nrow(y))
  algorithm <- match.arg(algorithm)
  X <- data.matrix(X)
  k <- ncol(y)
  n <- sum(freq)
  m <- ncol(X)
  y.names <- dimnames(y)[[2]]
  x.names <- dimnames(X)[[2]]
  if (missing(start)) {
    fit0  <- lm.fit(X, y, method = "qr")
    beta  <- as.matrix(coef(fit0))
    res   <- resid(fit0)
    a     <- msn.moment.fit(res)
    Omega <- a$Omega
    omega <- a$omega
    alpha <- a$alpha
    if (!a$admissible)
      alpha <- alpha / (1 + max(abs(alpha)))
    beta[1,] <- beta[1,] - omega * a$delta * sqrt(2 / pi)
  }
  else{
    beta  <- start$beta
    Omega <- start$Omega
    alpha <- start$alpha
    omega <- sqrt(diag(Omega))
  }
  al.om <- alpha / omega
  if (trace) {
    cat("Initial parameters:\n")
    print(cbind(t(beta), al.om, Omega))
  }
  param <- c(beta, al.om)
  dev <- msn.dev(param, X, y, freq)
  if (algorithm == "nlminb") {
    opt <- nlminb(
      param,
      msn.dev,
      msn.dev.grad,
      control = control,
      X = X,
      y = y,
      freq = freq,
      trace = trace
    )
    opt$value <- opt$objective
  }
  else{
    opt <- optim(
      param,
      fn = msn.dev,
      gr = msn.dev.grad,
      method = algorithm,
      control = control,
      X = X,
      y = y,
      freq = freq,
      trace = trace
    )
  }
  if (trace)
    cat(paste("Message from optimization routine:", opt$message, "\n"))
  logL <- opt$value / (-2)
  beta <- matrix(opt$par[1:(m * k)], m, k)
  dimnames(beta)[2] <- list(y.names)
  dimnames(beta)[1] <- list(x.names)
  al.om  <- opt$par[(m * k + 1):(m * k + k)]
  xi    <- X %*% beta
  Omega <- t(y - xi) %*% (freq * (y - xi)) / n
  omega <- sqrt(diag(Omega))
  alpha <- al.om * omega
  param <- cbind(omega, alpha)
  dimnames(Omega) <- list(y.names, y.names)
  dimnames(param)[1] <- list(y.names)
  info <-
    num.deriv2(
      opt$par,
      FUN = "msn.dev.grad",
      X = X,
      y = y,
      freq = freq
    ) / 2
  if (all(is.finite(info))) {
    qr.info <- qr(info)
    info.ok <- (qr.info$rank == length(param))
  }
  else
    info.ok <- FALSE
  if (info.ok) {
    se2 <- diag(solve(qr.info))
    if (min(se2) < 0)
      se <- NA
    else {
      se <- sqrt(se2)
      se      <- sqrt(diag(solve(info)))
      se.beta <- matrix(se[1:(m * k)], m, k)
      se.alpha <- se[(m * k + 1):(m * k + k)] * omega
      dimnames(se.beta)[2] <- list(y.names)
      dimnames(se.beta)[1] <- list(x.names)
      se  <- list(beta = se.beta,
                  alpha = se.alpha,
                  info = info)
    }
  }
  else
    se <- NA
  dp  <- list(beta = beta,
              Omega = Omega,
              alpha = alpha)
  opt$name <- algorithm
  list(
    call = match.call(),
    dp = dp,
    logL = logL,
    se = se,
    algorithm = opt
  )
}

sn.cumulants <-
  function(location = 0,
           scale = 1,
           shape = 0,
           dp = NULL,
           n = 4)
  {
    cumulants.half.norm <- function(n = 4) {
      n <- max(n, 2)
      n <- as.integer(2 * ceiling(n / 2))
      half.n  <-  as.integer(n / 2)
      m <- 0:(half.n - 1)
      a <- sqrt(2 / pi) / (gamma(m + 1) * 2 ^ m * (2 * m + 1))
      signs <- rep(c(1,-1), half.n)[1:half.n]
      a <- as.vector(rbind(signs * a, rep(0, half.n)))
      coeff <- rep(a[1], n)
      for (k in 2:n) {
        ind <- 1:(k - 1)
        coeff[k] <- a[k] - sum(ind * coeff[ind] * a[rev(ind)] /
                                 k)
      }
      kappa <- coeff * gamma((1:n) + 1)
      kappa[2] <- 1 + kappa[2]
      return(kappa)
    }
    if (!is.null(dp)) {
      if (!missing(shape))
        stop("You cannot set both component parameters and dp")
      location <- dp[1]
      scale <- dp[2]
      shape <- dp[3]
    }
    par <- cbind(location, scale, shape)
    delta <- par[, 3] / sqrt(1 + par[, 3] ^ 2)
    n0 <- n
    n <- max(n, 2)
    kv <- cumulants.half.norm(n)
    if (length(kv) > n)
      kv <- kv[-(n + 1)]
    kv[2] <- kv[2] - 1
    kappa <-
      outer(delta, 1:n, "^") * matrix(rep(kv, nrow(par)), ncol = n, byrow = TRUE)
    kappa[, 2] <- kappa[, 2] + 1
    kappa <- kappa * outer(par[, 2], (1:n), "^")
    kappa[, 1] <- kappa[, 1] + par[, 1]
    kappa[, 1:n0, drop = TRUE]
  }


T.Owen <- function(h,
                   a,
                   jmax = 50,
                   cut.point = 6)
{
  T.int <- function(h, a, jmax, cut.point)
  {
    fui <- function(h, i)
      (h ^ (2 * i)) / ((2 ^ i) * gamma(i + 1))
    seriesL <- seriesH <- NULL
    i  <- 0:jmax
    low <- (h <= cut.point)
    hL <- h[low]
    hH <- h[!low]
    L  <- length(hL)
    if (L > 0) {
      b    <- outer(hL, i, fui)
      cumb <- apply(b, 1, cumsum)
      b1   <- exp(-0.5 * hL ^ 2) * t(cumb)
      matr <- matrix(1, jmax + 1, L) - t(b1)
      jk   <- rep(c(1,-1), jmax)[1:(jmax + 1)] / (2 * i + 1)
      matr <- t(matr * jk) %*%  a ^ (2 * i + 1)
      seriesL  <- (atan(a) - as.vector(matr)) / (2 * pi)
    }
    if (length(hH) > 0)
      seriesH <- atan(a) * exp(-0.5 * (hH ^ 2) * a / atan(a)) *
      (1 + 0.00868 * (hH ^ 4) * a ^ 4) / (2 * pi)
    series <- c(seriesL, seriesH)
    id <- c((1:length(h))[low], (1:length(h))[!low])
    series[id] <- series  # re-sets in original order
    series
  }
  if (!is.vector(a) |
      length(a) > 1)
    stop("a must be a vector of length 1")
  if (!is.vector(h))
    stop("h must be a vector")
  aa <- abs(a)
  ah <- abs(h)
  if (is.na(aa))
    stop("parameter 'a' is NA")
  if (aa == Inf)
    return(0.5 * pnorm(-ah))
  if (aa == 0)
    return(rep(0, length(h)))
  na  <- is.na(h)
  inf <- (ah == Inf)
  ah  <- replace(ah, (na | inf), 0)
  if (aa <= 1)
    owen <- T.int(ah, aa, jmax, cut.point)
  else
    owen <- 0.5 * pnorm(ah) + pnorm(aa * ah) * (0.5 - pnorm(ah)) -
    T.int(aa * ah, (1 / aa), jmax, cut.point)
  owen <- replace(owen, na, NA)
  owen <- replace(owen, inf, 0)
  return(owen * sign(a))
}


cp.to.dp <- function(param) {
  ## converts centred parameters cp=(mu,sigma,gamma1)
  ## to direct parameters dp=(xi,omega,lambda)
  ## Note:  mu can be m-dimensional, the other must be scalars
  b <- sqrt(2 / pi)
  m <- length(param) - 2
  gamma1 <- param[m + 2]
  if (abs(gamma1) > 0.995271746431)
    stop("abs(gamma1)> 0.995271746431")
  A <- sign(gamma1) * (abs(2 * gamma1 / (4 - pi))) ^ (1 / 3)
  delta <- A / (b * sqrt(1 + A ^ 2))
  lambda <- delta / sqrt(1 - delta ^ 2)
  E.Z  <- b * delta
  sd.Z <- sqrt(1 - E.Z ^ 2)
  location    <- param[1:m]
  location[1] <- param[1] - param[m + 1] * E.Z / sd.Z
  scale <- param[m + 1] / sd.Z
  dp    <- c(location, scale, lambda)
  names(dp)[(m + 1):(m + 2)] <- c("scale", "shape")
  if (m == 1)
    names(dp)[1] <- "location"
  dp
}

dp.to.cp <- function(param) {
  ## converts 'direct' dp=(xi,omega,lambda) to 'centred' cp=(mu,sigma,gamma1)
  m <- length(param) - 2
  omega <- param[m + 1]
  lambda <- param[m + 2]
  mu.Z  <- lambda * sqrt(2 / (pi * (1 + lambda ^ 2)))
  s.Z   <- sqrt(1 - mu.Z ^ 2)
  gamma1 <- 0.5 * (4 - pi) * (mu.Z / s.Z) ^ 3
  sigma <- omega * s.Z
  mu    <- param[1:m]
  mu[1] <- param[1] + sigma * mu.Z / s.Z
  cp    <- c(mu, sigma, gamma1)
  names(cp)[(m + 1):(m + 2)] <- c("s.d.", "skewness")
  if (m == 1)
    names(cp)[1] <- "mean"
  cp
}


zeta <- function(k, x) {
  # k integer in (0,5)
  if (k < 0 | k > 5 | k != round(k))
    return(NULL)
  k <- round(k)
  na <- is.na(x)
  x <- replace(x, na, 0)
  x2 <- x ^ 2
  z <- switch(
    k + 1,
    pnorm(x, log.p = TRUE) + log(2),
    ifelse(x > (-50), exp(
      dnorm(x, log = TRUE) - pnorm(x, log.p = TRUE)
    ), -x / (
      1 - 1 / (x2 + 2) + 1 / ((x2 + 2) * (x2 + 4))
      - 5 / ((x2 + 2) * (x2 + 4) * (x2 + 6))
      + 9 / ((x2 + 2) * (x2 + 4) * (x2 + 6) * (x2 +
                                                 8))
      - 129 / ((x2 + 2) * (x2 + 4) * (x2 + 6) * (x2 +
                                                   8) * (x2 + 10))
    )),
    (-zeta(1, x) * (x + zeta(1, x))),
    (-zeta(2, x) * (x + zeta(1, x)) - zeta(1, x) * (1 + zeta(2, x))),
    (-zeta(3, x) * (x + 2 * zeta(1, x)) - 2 * zeta(2, x) * (1 +
                                                              zeta(2, x))),
    (
      -zeta(4, x) * (x + 2 * zeta(1, x)) - zeta(3, x) * (3 + 4 * zeta(2, x))
      - 2 * zeta(2, x) * zeta(3, x)
    ),
    NULL
  )
  neg.inf <- (x == -Inf)
  if (any(neg.inf))
    z <- switch(
      k + 1,
      z,
      replace(z, neg.inf, Inf),
      replace(z, neg.inf, -1),
      replace(z, neg.inf, 0),
      replace(z, neg.inf, 0),
      replace(z, neg.inf, 0),
      NULL
    )
  if (k > 1)
    z <- replace(z, x == Inf, 0)
  replace(z, na, NA)
}

sn.em <-
  function(X,
           y,
           fixed,
           p.eps = 1e-4,
           l.eps = 1.e-2,
           trace = FALSE,
           data = FALSE)
  {
    n <- length(y)
    if (missing(X))
      X <- matrix(rep(1, n), n, 1)
    nc <- ncol(X)
    if (missing(fixed))
      fixed <- rep(NA, 3)
    if (all(!is.na(fixed)))
      stop("all parameter are fixed")
    if (is.na(fixed[3]))
      iter <- (1 - log(l.eps, 10))
    else
      iter <- 1
    qrX <- qr(X)
    beta <- qr.coef(qrX, y)
    xi  <- m <- qr.fitted(qrX, y)
    omega  <- fixed[2]
    lambda <- fixed[3]
    delta <- lambda / sqrt(1 + lambda ^ 2)
    s <- sqrt(sum((y - xi) ^ 2) / n)
    if (is.na(fixed[3])) {
      gamma1 <- sum((y - m) ^ 3) / (n * s ^ 3)
      a  <- sign(gamma1) * (2 * abs(gamma1) / (4 - pi)) ^ 0.33333
      delta <- sqrt(pi / 2) * a / sqrt(1 + a ^ 2)
      if (abs(delta) >= 1)
        delta <- sign(delta) / (1 + 1 / n)
      lambda <- delta / sqrt(1 - delta ^ 2)
    }
    mean.Z <- sqrt(2 / pi) * delta
    sd.Z <- sqrt(1 - mean.Z ^ 2)
    if (is.na(fixed[2]))
      omega  <- s / sd.Z
    if (is.na(fixed[1]))
      xi     <- m - s * mean.Z / sd.Z
    old.par   <- c(beta, omega, lambda)
    diverge   <- 1
    incr.logL <- Inf
    logL      <- -Inf
    while (diverge > p.eps | incr.logL > l.eps) {
      ## E-step
      v  <- (y - xi) / omega
      p  <- zeta(1, lambda * v)
      u1 <- omega * (delta * v + p * sqrt(1 - delta ^ 2))
      u2 <-
        omega ^ 2 * ((delta * v) ^ 2 + (1 - delta ^ 2) + p * v * delta * sqrt(1 -
                                                                                delta ^ 2))
      ## M-step
      for (i in 1:iter) {
        beta <- qr.coef(qrX, y - delta * u1)
        xi <- qr.fitted(qrX, y - delta * u1)
        d  <- y - xi
        Q  <- sum(d ^ 2 - 2 * delta * d * u1 + u2)
        if (is.na(fixed[2]))
          omega <- sqrt(Q / (2 * n * (1 - delta ^ 2)))
        r  <- 2 * sum(d * u1) / Q
        if (is.na(fixed[3]))
          delta <- (sqrt((2 * r) ^ 2 + 1) - 1) / (2 * r)
      }
      ## convergence?    # lambda<-lambda.of(delta)
      lambda <- delta / sqrt(1 - delta ^ 2)
      param <- c(beta, omega, lambda)
      names(param)[(nc + 1):(nc + 2)] <- c("scale", "shape")
      if (nc == 1 & all(X == 1))
        names(param)[1] <- "location"
      else
        names(param)[1:nc] <- colnames(X)
      diverge <-
        sum(abs(param - old.par) / (1 + abs(old.par))) / (nc +
                                                            2)
      old.par <- param
      new.logL <- sum(dsn(y, xi, omega, lambda, log = TRUE))
      incr.logL <- new.logL - logL
      logL <- new.logL
      if (trace)
        print(c(param, logL), digits = 5)
    }
    cp <- dp.to.cp(param)
    result <- list(dp = param, cp = cp, logL = logL)
    if (data)
      result$data <- list(X = X,
                          y = y,
                          residuals = d / omega)
    result
  }

##-------------------

gamma1.to.lambda <- function(gamma1) {
  max.gamma1 <- 0.5 * (4 - pi) * (2 / (pi - 2)) ^ 1.5
  na <- (abs(gamma1) > max.gamma1)
  if (any(na))
    warning("NAs generated")
  gamma1 <- replace(gamma1, na, NA)
  a    <- sign(gamma1) * (2 * abs(gamma1) / (4 - pi)) ^ 0.33333
  delta <- sqrt(pi / 2) * a / sqrt(1 + a ^ 2)
  lambda <- delta / sqrt(1 - delta ^ 2)
  as.vector(lambda)
}


sn.2logL.profile <- function(X = matrix(rep(1, n)),
                             y,
                             param.range = c(sqrt(var(y)) * c(2 / 3, 3 / 2), -0.95, 0.95),
                             use.cp = TRUE,
                             npts = 51 %/% d,
                             plot.it = TRUE,
                             ...)
{
  # plot 1D or 2D profile deviance (=-2logL) using either parameters
  ## if(plot.it & !exists(.Device)) stop("Device not active")
  n <- length(y)
  d <- round(length(param.range) / 2)
  if ((d != 1) &
      (d != 2))
    stop(" length(param.range) must be either 2 or 4")
  if (d == 1) {
    param1 <- seq(param.range[1], param.range[2], length = npts)
    llik <- param2 <- rep(NA, npts)
  }
  else{
    param1 <- seq(param.range[1], param.range[2], length = npts)
    param2 <- seq(param.range[3], param.range[4], length = npts)
    llik   <- matrix(NA, npts, npts)
  }
  if (use.cp) {
    if (d == 1) {
      gamma1 <- param1
      sigma <- param2
      xlab <- "gamma1"
      ylab <- ""
    }
    else {
      sigma <- param1
      gamma1 <- param2
      xlab <- "sigma"
      ylab <- "gamma1"
    }
    if (max(abs(gamma1)) > 0.9952717)
      stop("abs(gamma1)>0.9952717")
    lambda <- gamma1.to.lambda(gamma1)
    sc <- sqrt(1 - (2 / pi) * lambda ^ 2 / (1 + lambda ^ 2))
  }
  else{
    # use dp
    if (d == 1) {
      lambda <- param1
      omega <- param2
      xlab <- "alpha"
      ylab <- ""
    }
    else {
      omega <- param1
      sc <- rep(1, npts)
      lambda <- param2
      xlab <- "omega"
      ylab <- "alpha"
    }
  }
  cat(c("Running until", npts, ":"))
  for (i in 1:npts) {
    cat(" ")
    cat(i)
    if (d == 1) {
      a <- sn.em(X, y, fixed = c(NA, NA, lambda[i]), ...)
      llik[i] <- a$logL
    }
    else{
      for (j in 1:npts) {
        a <- sn.em(X, y, fixed = c(NA, param1[i] / sc[j], lambda[j]), ...)
        llik[i, j] <- a$logL
      }
    }
  }
  cat("\n")
  ##if(plot)
  f <- 2 * (llik - max(llik))
  if (plot.it) {
    if (d == 1)
      plot(param1,
           f,
           type = "l",
           xlab = xlab,
           ylab = "profile deviance")
    else
      contour(
        param1,
        param2,
        f,
        labcex = 0.5,
        xlab = xlab,
        ylab = ylab,
        levels = -c(0.57, 1.37, 2.77, 4.6, 5.99, 9.2),
        labels = c(0.25, 0.5,  0.75, 0.90, 0.95, 0.99)
      )
    title(main = paste(
      "Dataset:",
      deparse(substitute(y)),
      "\nProfile deviance function",
      sep = " "
    ))
  }
  invisible(list(
    param1 = param1,
    param2 = param2,
    param.names = c(xlab, ylab),
    two.logL = f,
    maximum = 2 * max(llik)
  ))
}


sn.mle <-
  function(X,
           y,
           cp,
           plot.it = TRUE,
           trace = FALSE,
           method = "L-BFGS-B",
           control = list(maxit = 100))
  {
    xlab <- deparse(substitute(y))
    if (!is.null(dim(y))) {
      if (min(dim(y)) == 1)
        y <- as.vector(y)
      else
        stop("y must be a vector")
    }
    n <- length(y)
    if (missing(X)) {
      X <- as.matrix(rep(1, n))
      cp.names <- "mean"
    }
    else{
      if (is.null(colnames(X)))
        cp.names <-
          outer(deparse(substitute(X)), as.character(1:ncol(X)),
                paste, sep = ".")
      else
        cp.names <- colnames(X)
    }
    cp.names <- c(cp.names, "s.d.", "skewness")
    m <- ncol(X)
    if (missing(cp)) {
      qrX <- qr(X)
      s <- sqrt(sum(qr.resid(qrX, y) ^ 2) / n)
      gamma1 <- sum(qr.resid(qrX, y) ^ 3) / (n * s ^ 3)
      if (abs(gamma1) > 0.99527)
        gamma1 <- sign(gamma1) * 0.95
      cp <- c(qr.coef(qrX, y), s, gamma1)
    }
    else{
      if (length(cp) != (m + 2))
        stop("ncol(X)+2 != length(cp)")
    }
    opt <- optim(
      cp,
      fn = sn.dev,
      gr = sn.dev.gh,
      method = method,
      lower = c(-rep(Inf, m), 10 * .Machine$double.eps, -0.99527),
      upper = c(rep(Inf, m), Inf, 0.99527),
      control = control,
      X = X,
      y = y,
      trace = trace,
      hessian = FALSE
    )
    cp <- opt$par
    if (trace) {
      cat(paste("Message from optimization routine:", opt$message, "\n"))
      cat("estimates (cp): ", cp, "\n")
    }
    if (abs(cp[m + 2]) > 0.9952717) {
      if (trace)
        cat("optim searched outside admissible range - restarted\n")
      cp[m + 2] <- sign(cp[m + 2]) * runif(1)
      mle <- sn.mle(X, y, cp, plot.it, trace, method, control)
      cp  <- mle$cp
    }
    logL <- (-opt$value) / 2
    info <-
      attr(sn.dev.gh(cp, X, y, trace = FALSE, hessian = TRUE), "hessian") / 2
    ## se <- sqrt(diag(solve(info)))
    if (all(is.finite(info)))
    {
      qr.info <- qr(info)
      info.ok <- (qr.info$rank == length(cp))
    }
    else
      info.ok <- FALSE
    if (info.ok) {
      se2 <- diag(solve.qr(qr.info))
      se <- sqrt(ifelse(se2 >= 0, se2, NA))
    }
    else
      se <- rep(NA, length(cp))
    if (plot.it) {
      dp0 <- cp.to.dp(cp)
      if (all(X == rep(1, n)))
        y0 <- y
      else {
        y0 <- as.vector(y - X %*% dp0[1:m])
        dp0 <- c(0, dp0[m + 1], dp0[m + 2])
        xlab <- "residuals"
      }
      x <-
        seq(min(pretty(y0, 10)), max(pretty(y0, 10)), length = 200)
      pdf.sn <- dsn(x, dp0[1], dp0[2], dp0[3])
      h <- hist(y0,  breaks = "FD", plot = FALSE)
      hist(
        y0,
        freq = FALSE,
        breaks = "FD",
        xlim = c(min(x), max(x)),
        xlab = xlab,
        main = xlab,
        ylim = c(0, max(pdf.sn, h$density))
      )
      if (n < 101)
        points(y0, rep(0, n), pch = 1)
      curve(dsn(x, dp0[1], dp0[2], dp0[3]), add = TRUE, col = 2)
    }
    names(cp) <-  names(se) <- cp.names
    list(
      call = match.call(),
      cp = cp,
      se = se,
      info = info,
      logL = logL,
      optim = opt
    )
  }


sn.dev <- function(cp, X, y, trace = FALSE)
{
  # -2*logL for centred parameters
  m <- ncol(X)
  if (abs(cp[m + 2]) > 0.9952717) {
    warning("optim search in abs(cp[m+2])> 0.9952717, value adjusted")
    cp[m + 2] <- 0.9952717 * sign(cp[m + 2])
  }
  dp <- as.vector(cp.to.dp(cp))
  location <- as.vector(X %*% as.matrix(dp[1:m]))
  logL <- sum(dsn(y, location, dp[m + 1], dp[m + 2], log = TRUE))
  if (trace) {
    cat("sn.dev: (cp,dev) =", format(c(cp, -2 * logL)))
  }
  return(-2 * logL)
}

sn.dev.gh <- function(cp,
                      X,
                      y,
                      trace = FALSE,
                      hessian = FALSE)
{
  ## computes gradient and hessian of dev=-2*logL for centred parameters
  ## (and observed information matrix);
  m  <- ncol(X)
  n  <- nrow(X)
  np <- m + 2
  if (abs(cp[m + 2]) > 0.9952717) {
    warning("optim search in abs(cp[m+2])> 0.9952717, value adjusted")
    cp[m + 2] <- 0.9952717 * sign(cp[m + 2])
  }
  score <- rep(NA, np)
  info  <- matrix(NA, np, np)
  beta  <- cp[1:m]
  sigma <- cp[m + 1]
  gamma1 <- cp[m + 2]
  lambda <- gamma1.to.lambda(gamma1)
  ## dp<-cp.to.dp(c(beta,sigma,gamma1))
  ## info.dp <- sn.info(dp,y)$info.dp
  mu <- as.vector(X %*% as.matrix(beta))
  d  <- y - mu
  r  <- d / sigma
  E.Z <- lambda * sqrt(2 / (pi * (1 + lambda ^ 2)))
  s.Z <- sqrt(1 - E.Z ^ 2)
  z  <- E.Z + s.Z * r
  p1 <- as.vector(zeta(1, lambda * z))
  p2 <- as.vector(zeta(2, lambda * z))
  omega <- sigma / s.Z
  w    <- lambda * p1 - E.Z
  DE.Z <- sqrt(2 / pi) / (1 + lambda ^ 2) ^ 1.5
  Ds.Z <- (-E.Z / s.Z) * DE.Z
  Dz   <- DE.Z + r * Ds.Z
  DDE.Z <- (-3) * E.Z / (1 + lambda ^ 2) ^ 2
  DDs.Z <-
    -((DE.Z * s.Z - E.Z * Ds.Z) * DE.Z / s.Z ^ 2 + E.Z * DDE.Z /
        s.Z)
  DDz  <- DDE.Z + r * DDs.Z
  score[1:m] <-
    omega ^ (-2) * t(X) %*% as.matrix(y - mu - omega * w)
  score[m + 1] <-
    (-n) / sigma + s.Z * sum(d * (z - p1 * lambda)) / sigma ^
    2
  score[m + 2] <-
    score.l <-
    n * Ds.Z / s.Z - sum(z * Dz) + sum(p1 * (z + lambda * Dz))
  Dg.Dl <-
    1.5 * (4 - pi) * E.Z ^ 2 * (DE.Z * s.Z - E.Z * Ds.Z) / s.Z ^
    4
  R <- E.Z / s.Z
  Te <- sqrt(2 / pi - (1 - 2 / pi) * R ^ 2)
  Dl.Dg <-
    2 * (Te / (Te * R) ^ 2 + (1 - 2 / pi) / Te ^ 3) / (3 * (4 -
                                                              pi))
  R. <- 2 / (3 * R ^ 2 * (4 - pi))
  T. <- (-R) * R. * (1 - 2 / pi) / Te
  DDl.Dg <-
    (-2 / (3 * (4 - pi))) * (T. / (R * Te) ^ 2 + 2 * R. / (Te * R ^ 3) + 3 *
                               (1 - 2 / pi) * T. / Te ^ 4)
  score[m + 2] <-
    score[m + 2] / Dg.Dl  # convert deriv wrt lamda to gamma1
  gradient <- (-2) * score
  if (hessian) {
    info[1:m, 1:m] <-
      omega ^ (-2) * t(X) %*% ((1 - lambda ^ 2 * p2) * X)
    info[1:m, m + 1] <- info[m + 1, 1:m] <-
      s.Z * t(X) %*% as.matrix((z - lambda * p1) + d * (1 - lambda ^
                                                          2 * p2) *
                                 s.Z / sigma) / sigma ^ 2
    info[m + 1, m + 1] <-
      (-n) / sigma ^ 2 + 2 * s.Z * sum(d * (z - lambda * p1)) / sigma ^ 3 +
      s.Z ^ 2 * sum(d * (1 - lambda ^ 2 * p2) * d) / sigma ^ 4
    info[1:m, m + 2] <- info[m + 2, 1:m] <-
      t(X) %*% (-2 * Ds.Z * d / omega + Ds.Z * w + s.Z * (p1 + lambda *
                                                            p2 * (z + lambda * Dz)
                                                          - DE.Z)) / sigma
    info[m + 1, m + 2] <- info[m + 2, m + 1] <-
      -sum(d * (Ds.Z * (z - lambda * p1) + s.Z * (Dz - p1 - p2 * lambda *
                                                    (z + lambda * Dz)))) / sigma ^ 2
    info[m + 2, m + 2] <-
      (n * (-DDs.Z * s.Z + Ds.Z ^ 2) / s.Z ^ 2 + sum(Dz ^ 2 + z * DDz) -
         sum(p2 * (z + lambda * Dz) ^ 2) - sum(p1 * (2 *
                                                       Dz + lambda * DDz)))
    info[np,] <-
      info[np,] / Dg.Dl # convert info wrt lamda to gamma1
    info[, np] <-
      info[, np] * Dl.Dg # an equivalent form of the above
    info[np, np] <- info[np, np] - score.l * DDl.Dg
    attr(gradient, "hessian") <- 2 * info
  }
  if (trace) {
    cat("sn.dev.gh: gradient=")
    print(-2 * score)
  }
  return(gradient)
}

##

dmsn <-
  function(x,
           xi = rep(0, length(alpha)),
           Omega,
           alpha,
           dp = NULL,
           log = FALSE)
  {
    if (!(missing(alpha) & missing(Omega)) && !is.null(dp))
      stop("You cannot set both component parameters and dp")
    if (!is.null(dp)) {
      if (!is.null(dp$xi))
        xi <- dp$xi
      else {
        if (!is.null(dp$beta))
          xi <- as.vector(dp$beta)
      }
      Omega <- dp$Omega
      alpha <- dp$alpha
    }
    d <- length(alpha)
    Omega <- matrix(Omega, d, d)
    x <- if (is.vector(x))
      matrix(x, 1, d)
    else
      data.matrix(x)
    if (is.vector(xi))
      xi <- outer(rep(1, nrow(x)), xi)
    X <- t(x - xi)
    Q <- apply((solvePD(Omega) %*% X) * X, 2, sum)
    L <- as.vector(t(X / sqrt(diag(Omega))) %*% as.matrix(alpha))
    logDet <- sum(logb(abs(diag(qr(
      Omega
    )$qr))))
    logPDF <- (logb(2) - 0.5 * Q + pnorm(L, log.p = TRUE)
               - 0.5 * (d * logb(2 * pi) + logDet))
    if (log)
      logPDF
    else
      exp(logPDF)
  }


rmsn <-
  function(n = 1,
           xi = rep(0, length(alpha)),
           Omega,
           alpha,
           dp = NULL)
  {
    # generates SN_d(xi,Omega,alpha) variates using transformation method
    if (!(missing(alpha) & missing(Omega)) && !is.null(dp))
      stop("You cannot set both component parameters and dp")
    if (!is.null(dp)) {
      if (!is.null(dp$xi))
        xi <- dp$xi
      else
        if (!is.null(dp$beta))
          xi <- as.vector(dp$beta)
        Omega <- dp$Omega
        alpha <- dp$alpha
    }
    d <- length(alpha)
    Z <- msn.quantities(xi, Omega, alpha)
    y <- matrix(rnorm(n * d), n, d) %*% chol(Z$Psi)
    ## each row of y is N_d(0,Psi)
    abs.y0 <- abs(rnorm(n))
    abs.y0 <- matrix(rep(abs.y0, d), ncol = d)
    delta  <- Z$delta
    z <- delta * t(abs.y0) + sqrt(1 - delta ^ 2) * t(y)
    y <- t(xi + Z$omega * z)
    attr(y, "parameters") <- list(xi = xi,
                                  Omega = Omega,
                                  alpha = alpha)
    return(y)
  }

pmsn <-
  function(x,
           xi = rep(0, length(alpha)),
           Omega,
           alpha,
           dp = NULL,
           ...)
  {
    if (!(missing(alpha) & missing(Omega)) && !is.null(dp))
      stop("You cannot set both component parameters and dp")
    if (!is.null(dp)) {
      if (!is.null(dp$xi))
        xi <- dp$xi
      else
        if (!is.null(dp$beta))
          xi <- as.vector(dp$beta)
        Omega <- dp$Omega
        alpha <- dp$alpha
    }
    pmst(
      x,
      xi = xi,
      Omega = Omega,
      alpha = alpha,
      df = Inf,
      ...
    )
  }


dsn2.plot <- function(x, y, xi, Omega, alpha, dp = NULL, ...)
{
  # plot bivariate density SN_2(xi,Omega,alpha) computed at (x,y) grid
  if (!is.null(dp)) {
    if (!is.null(dp$xi))
      xi <- dp$xi
    else
      if (!is.null(dp$beta))
        xi <- as.vector(dp$beta)
      Omega <- dp$Omega
      alpha <- dp$alpha
      df <- dp$df
  }
  if (any(dim(Omega) != c(2, 2)))
    stop("dim(Omega) != c(2,2)")
  nx <- length(x)
  ny <- length(y)
  xoy <-
    cbind(rep(x, ny), as.vector(matrix(y, nx, ny, byrow = TRUE)))
  X <- matrix(xoy, nx * ny, 2, byrow = FALSE)
  pdf <- dmsn(X, xi, Omega, alpha)
  pdf <- matrix(pdf, nx, ny)
  contour(x, y, pdf, ...)
  invisible(list(
    x = x,
    y = y,
    density = pdf,
    xi = xi,
    Omega = Omega,
    alpha = alpha
  ))
}

msn.quantities <-
  function(xi = rep(0, length(alpha)),
           Omega,
           alpha,
           dp = NULL)
  {
    # 21-12-1997; computes various quantities related to SN_d(xi,Omega,alpha)
    if (!is.null(dp)) {
      if (any(!missing(xi) | !missing(Omega) | !missing(alpha)))
        stop("you cat set either dp or its components, but not both")
      xi <- as.vector(dp$xi)
      if (is.null(dp$xi))
        xi <- as.vector(dp$beta)
      Omega <- dp$Omega
      alpha <- dp$alpha
    }
    d <- length(alpha)
    Omega <- as.matrix(Omega)
    if (length(xi) != d | any(dim(Omega) != c(d, d)))
      stop("dimensions of arguments do not match")
    omega <- sqrt(diag(Omega))
    O.cor <- cov2cor(Omega)
    tmp <-
      as.vector(sqrt(1 + t(as.matrix(alpha)) %*% O.cor %*% alpha))
    delta <- as.vector(O.cor %*% alpha) / tmp
    lambda <- delta / sqrt(1 - delta ^ 2)
    D   <- diag(sqrt(1 + lambda ^ 2), d, d)
    Psi <- D %*% (O.cor - outer(delta, delta)) %*% D
    Psi <- (Psi + t(Psi)) / 2
    O.inv <- solvePD(Omega)
    O.pcor <- -cov2cor(O.inv)
    O.pcor[cbind(1:d, 1:d)] <- 1
    muZ <- delta * sqrt(2 / pi)
    muY <- xi + omega * muZ
    Sigma <-
      diag(omega, d, d) %*% (O.cor - outer(muZ, muZ)) %*% diag(omega, d, d)
    Sigma <- (Sigma + t(Sigma)) / 2
    cv <- muZ / sqrt(1 - muZ ^ 2)
    gamma1 <- 0.5 * (4 - pi) * cv ^ 3
    list(
      xi = xi,
      Omega = Omega,
      alpha = alpha,
      omega = omega,
      mean = muY,
      variance = Sigma,
      Omega.conc = O.inv,
      Omega.cor = O.cor,
      Omega.pcor = O.pcor,
      lambda = lambda,
      Psi = Psi,
      delta = delta,
      skewness = gamma1
    )
  }

msn.conditional <- function(xi = rep(0, length(alpha)),
                            Omega,
                            alpha,
                            fixed.comp,
                            fixed.values,
                            dp = NULL)
{
  ## conditional Multivariate SN  (6/11/1997).
  ## Given a rv Y ~ SN_d(xi,Omega,alpha), this function computes cumulants of
  ## conditrional distribution, given that the fixed.com take on fixed.values;
  ## then it finds MSN with matching cumulants.
  Diag <- function(x)
    diag(x, nrow = length(x), ncol = length(x))
  msqrt <- function(A)
    Diag(sqrt(diag(as.matrix(A))))
  imsqrt <- function(A)
    Diag(1 / sqrt(diag(as.matrix(A))))
  if (!is.null(dp)) {
    if (!is.null(dp$xi))
      xi <- dp$xi
    else
      if (!is.null(dp$beta))
        xi <- as.vector(dp$beta)
      Omega <- dp$Omega
      alpha <- dp$alpha
  }
  d <- length(alpha)
  h <- length(fixed.comp)
  if (any(dim(Omega) != c(d, d)) |
      length(xi) != d | h != length(fixed.values))
    stop("dimensions of parameters do not match")
  fc <- fixed.comp
  O  <- as.matrix(Omega)
  O11 <- O[fc, fc, drop = FALSE]
  O12 <- O[fc,-fc, drop = FALSE]
  O21 <- O[-fc, fc, drop = FALSE]
  O22 <- O[-fc,-fc, drop = FALSE]
  o22 <- sqrt(diag(O22))
  inv.O11 <- solvePD(O11)
  xi1 <- xi[fc, drop = FALSE]
  xi2 <- xi[-fc, drop = FALSE]
  alpha1 <- matrix(alpha[fc])
  alpha2 <- matrix(alpha[-fc])
  O22.1 <- O22 - O21 %*% inv.O11 %*% O12
  O22.b <- imsqrt(O22) %*% O22.1 %*% imsqrt(O22)
  xi.c  <-
    xi2 + as.vector(O21 %*% inv.O11 %*% matrix(fixed.values - xi1))
  a     <- sqrt(1 + as.vector(t(alpha2) %*% O22.b %*% alpha2))
  alpha.b <-
    (alpha1 + msqrt(O11) %*% inv.O11 %*% O12 %*% (alpha2 / o22)) / a
  d2    <- as.vector(O22.b %*% alpha2) / a
  x0    <- sum(alpha.b * (fixed.values - xi1) / sqrt(diag(O11)))
  E.c   <- xi.c + zeta(1, x0) * o22 * d2
  var.c <- O22.1 + zeta(2, x0) * outer(o22 * d2, o22 * d2)
  gamma1 <-
    zeta(3, x0) * d2 ^ 3 / diag(O22.b + zeta(2, x0) * d2 ^ 2) ^
    1.5
  cum   <- list(as.vector(E.c), var.c, gamma1)
  ## cumulants are computed; now choose SN distn to fit them
  a     <- sign(gamma1) * (2 * abs(gamma1) / (4 - pi)) ^ 0.33333
  E.z   <- a / sqrt(1 + a ^ 2)
  delta <- E.z * sqrt(pi / 2)
  omega <- sqrt(diag(var.c) / (1 - E.z ^ 2))
  O.new <- var.c + outer(omega * E.z, omega * E.z)
  xi.new <- E.c - omega * E.z
  B   <- diag(1 / omega, d - h, d - h)
  m   <-
    as.vector(solvePD(B %*% O.new %*% B) %*% as.matrix(delta))
  a   <- m / sqrt(1 - sum(delta * m))
  ## cum2<- msn.cumulants(xi.new,O.new,a)
  list(
    cumulants = cum,
    fit = list(
      xi = xi.new,
      Omega = O.new,
      alpha = a,
      delta = delta
    )
  )
}


msn.marginal <- function(xi = rep(0, length(alpha)),
                         Omega,
                         alpha,
                         comp = 1:d,
                         dp = NULL)
  
{
  # calcola parametri della marginale associata a comp di un SN_d
  ## cfr SJS 2003, p.131-2
  if (!is.null(dp)) {
    if (!is.null(dp$xi))
      xi <- dp$xi
    else
      if (!is.null(dp$beta))
        xi <- as.vector(dp$beta)
      Omega <- dp$Omega
      alpha <- dp$alpha
  }
  alpha <- as.vector(alpha)
  d <- length(alpha)
  xi <- as.vector(xi)
  comp <- as.integer(comp)
  if (length(xi) != d)
    stop("parameter size not compatible")
  if (all(dim(Omega) != c(d, d)))
    stop("parameter size not compatible")
  if (length(comp) < d) {
    if (any(comp > d | comp < 1))
      stop("comp makes no sense")
    O   <- cov2cor(Omega)
    O11 <- O[comp, comp, drop = FALSE]
    O12 <- O[comp,-comp, drop = FALSE]
    O21 <- O[-comp, comp, drop = FALSE]
    O22 <- O[-comp,-comp, drop = FALSE]
    alpha1 <- matrix(alpha[comp], ncol = 1)
    alpha2 <- matrix(alpha[-comp], ncol = 1)
    O11_inv <- solvePD(O11)
    O22.1 <- O22 - O21 %*% O11_inv %*% O12
    a.sum <- as.vector(t(alpha2) %*% O22.1 %*% alpha2)
    a.new <-
      as.vector(alpha1 + O11_inv %*% O12 %*% alpha2) / sqrt(1 + a.sum)
    result <-
      list(xi = xi[comp],
           Omega = Omega[comp, comp],
           alpha = a.new)
  }
  else {
    if (any(sort(comp) != (1:d)))
      stop("comp makes no sense")
    result <-
      list(xi = xi[comp],
           Omega = Omega[comp, comp],
           alpha = alpha[comp])
  }
  if (!is.null(dp$tau))
    result$tau <- dp$tau
  result
}




msn.cond.plot <-
  function(xi,
           Omega,
           alpha,
           fixed.comp,
           fixed.values,
           n = 35)
  {
    # fa il grafico di Y_2|Y_1; assumiamo che dim(Y_2)= 2
    msn.pdf2.aux <- function(x, y, xi, Omega, alpha, fc, fv)
    {
      nx <- length(x)
      ny <- length(y)
      FV <-
        matrix(rep(fv, nx * ny), nx * ny, length(fv), byrow = TRUE)
      X <- matrix(NA, nx * ny, length(alpha))
      X[, fc] <- FV
      xoy <-
        cbind(rep(x, ny), as.vector(matrix(y, nx, ny, byrow = TRUE)))
      X[,-fc] <- matrix(xoy, nx * ny, 2, byrow = FALSE)
      pdf <- dmsn(X, xi, Omega, alpha)
      matrix(pdf, nx, ny)
    }
    dsn2 <- function(x, y, d1, d2, omega)
    {
      u <- (x * (d1 - omega * d2) + y * (d2 - omega * d1)) /
        sqrt((1 - omega ^ 2 - d1 ^ 2 - d2 ^ 2 + 2 * omega * d1 *
                d2) * (1 - omega ^ 2))
      pdfn2 <- exp(-0.5 * (x ^ 2 - 2 * omega * x * y + y ^ 2) / (1 -
                                                                   omega ^ 2)) /
        (2 * pi * sqrt(1 - omega ^ 2))
      2 * pdfn2 * pnorm(u)
    }
    fc <- fixed.comp
    fv <- fixed.values
    cond <- msn.conditional(xi, Omega, alpha, fc, fv)
    xi.c <- cond$fit$xi
    O.c  <- cond$fit$Omega
    a.c  <- cond$fit$alpha
    if (any(dim(O.c) != c(2, 2)))
      stop("length(alpha)-length(fixed.com)!=2")
    scale1 <- sqrt(as.vector(O.c[1, 1]))
    scale2 <- sqrt(as.vector(O.c[2, 2]))
    delta <- cond$fit$delta
    omega <- as.vector(O.c[1, 2]) / (scale1 * scale2)
    x <- seq(xi.c[1] - 3 * scale1, xi.c[1] + 3 * scale1, length = n)
    y <- seq(xi.c[2] - 3 * scale2, xi.c[2] + 3 * scale2, length = n)
    plot(x, y, type = "n", main = "Conditional multivariate SN pdf")
    z1 <- (x - xi.c[1]) / scale1
    z2 <- (y - xi.c[2]) / scale2
    pdf.fit <- outer(z1,
                     z2,
                     dsn2,
                     d1 = delta[1],
                     d2 = delta[2],
                     omega = omega) /
      (scale1 * scale2)
    cond$pdf <- list(x = x, y = y, f.fitted = pdf.fit)
    levels <- pretty(pdf.fit, 5)
    contour(x,
            y,
            pdf.fit,
            levels = levels,
            add = TRUE,
            col = 2)
    numer <- msn.pdf2.aux(x, y, xi, Omega, alpha, fc, fv)
    marg  <- msn.marginal(xi, Omega, alpha, fc)
    denom <- dmsn(fv, marg$xi, marg$Omega, marg$alpha)
    pdf.exact <- numer / as.vector(denom)
    contour(
      x,
      y,
      pdf.exact,
      add = TRUE,
      levels = levels,
      col = 1,
      lty = 4,
      labcex = 0
    )
    legend(x[1],
           y[length(y)],
           c("approx", "exact"),
           lty = c(1, 4),
           col = c(2, 1))
    cond$pdf$f.exact <- pdf.exact
    cond$rel.error <- summary((pdf.fit - pdf.exact) / pdf.exact)
    cond$abs.error <- summary(abs(pdf.fit - pdf.exact))
    invisible(cond)
  }


msn.moment.fit <- function(y)
{
  # 31-12-1997: simple fit of MSN distribution usign moments
  y     <- as.matrix(y)
  k     <- ncol(y)
  m.y   <- apply(y, 2, mean)
  var.y <- var(y)
  y0    <- (t(y) - m.y) / sqrt(diag(var.y))
  gamma1 <- apply(y0 ^ 3, 1, mean)
  out   <- (abs(gamma1) > 0.99527)
  gamma1[out] <- sign(gamma1[out]) * 0.995
  a     <- sign(gamma1) * (2 * abs(gamma1) / (4 - pi)) ^ 0.33333
  delta <- sqrt(pi / 2) * a / sqrt(1 + a ^ 2)
  m.z   <- delta * sqrt(2 / pi)
  omega <- sqrt(diag(var.y) / (1 - m.z ^ 2))
  Omega <- var.y + outer(omega * m.z, omega * m.z)
  xi    <- m.y - omega * m.z
  O.cor <- cov2cor(Omega)
  O.inv <- solvePD(O.cor)
  tmp   <- as.vector(1 - t(delta) %*% O.inv %*% delta)
  if (tmp <= 0) {
    tmp <- 0.0001
    admissible <- FALSE
  }
  else
    admissible <- TRUE
  alpha <- as.vector(O.inv %*% delta) / sqrt(tmp)
  list(
    xi = xi,
    Omega = Omega,
    alpha = alpha,
    Omega.cor = O.cor,
    omega = omega,
    delta = delta,
    skewness = gamma1,
    admissible = admissible
  )
}

msn.fit <- function(X,
                    y,
                    freq,
                    plot.it = TRUE,
                    trace = FALSE,
                    ...)
{
  y.name <- deparse(substitute(y))
  y.names <- dimnames(y)[[2]]
  y <- as.matrix(y)
  colnames(y) <- y.names
  k <- ncol(y)
  if (missing(freq))
    freq <- rep(1, nrow(y))
  n <- sum(freq)
  if (missing(X)) {
    X <- rep(1, nrow(y))
    missing.X <- TRUE
  }
  else
    missing.X <- FALSE
  X <- as.matrix(X)
  m <- ncol(X)
  if (length(dimnames(y)[[2]]) == 0) {
    dimnames(y) <-
      list(NULL, outer("V", as.character(1:k), paste, sep = ""))
    y.names <- as.vector(dimnames(y)[[2]])
  }
  qrX <- qr(X)
  mle <- msn.mle(
    X = X,
    y = y,
    freq = freq,
    trace = trace,
    ...
  )
  mle$call <- match.call()
  ## print(mle$nlminb$message)
  beta  <- mle$dp$beta
  Omega <- mle$dp$Omega
  alpha <- mle$dp$alpha
  omega <- sqrt(diag(Omega))
  xi    <- X %*% beta
  if (plot.it & all(freq == rep(1, length(y)))) {
    if (missing.X) {
      y0  <- y
      xi0 <- apply(xi, 2, mean)
    }
    else  {
      y0  <- y - xi
      xi0 <- rep(0, k)
    }
    if (k > 1) {
      opt <- options()
      options(warn = -1)
      pairs(
        y0,
        labels = y.names,
        panel = function(x, y, Y, y.names, xi, Omega, alpha)
        {
          for (i in 1:length(alpha)) {
            ## if(y.names[i]==deparse(substitute(x))) Ix<-i
            ## if(y.names[i]==deparse(substitute(y))) Iy<-i
            if (all(Y[, i] == x))
              Ix <- i
            if (all(Y[, i] == y))
              Iy <- i
          }
          points(x, y)
          marg <- msn.marginal(xi, Omega, alpha, c(Ix, Iy))
          xi.marg <- marg$xi
          Omega.marg <- marg$Omega
          alpha.marg <- marg$alpha
          x1 <- seq(min(x), max(x), length = 30)
          x2 <- seq(min(y), max(y), length = 30)
          dsn2.plot(x1,
                    x2,
                    xi.marg,
                    Omega.marg,
                    alpha.marg,
                    add = TRUE,
                    col = 2)
        },
        ## end "panel" function
        Y = y0,
        y.names = y.names,
        xi = xi0,
        Omega = Omega,
        alpha = alpha
      )
      options(opt)
    }
    else{
      # plot for case k=1
      y0 <- as.vector(y0)
      x <- seq(min(pretty(y0, 10)), max(pretty(y0, 10)), length =
                 100)
      if (missing.X) {
        dp0 <- c(xi0, omega, alpha)
        xlab <- y.name
      }
      else {
        dp0 <- c(0, omega, alpha)
        xlab <- "residuals"
      }
      hist(
        y0,
        prob = TRUE,
        breaks = "FD",
        xlab = xlab,
        ylab = "density"
      )
      lines(x, dsn(x, dp0[1], dp0[2], dp0[3]))
      if (length(y) < 101)
        points(y0, rep(0, n), pch = 1)
      title(y.name)
    }
    cat("Press <Enter> to continue...")
    readline()
    par(mfrow = c(1, 2))
    pp <- qchisq((1:n) / (n + 1), k)
    ## Xb <- qr.fitted(qrX,y)
    res <- qr.resid(qrX, y)
    rad.n  <-
      apply(res    * (res    %*% solvePD(var(res))), 1, sum)
    rad.sn <-
      apply((y - xi) * ((y - xi) %*% solvePD(Omega)), 1, sum)
    plot(
      pp,
      sort(rad.n),
      pch = 1,
      ylim = c(0, max(rad.n, rad.sn)),
      xlab = "Percentiles of chi-square distribution",
      ylab = "Mahalanobis distances"
    )
    abline(0, 1, lty = 2)
    title(main = "QQ-plot for normal distribution", sub = y.name)
    plot(
      pp,
      sort(rad.sn),
      pch = 1,
      ylim = c(0, max(rad.n, rad.sn)),
      xlab = "Percentiles of chi-square distribution",
      ylab = "Mahalanobis distances"
    )
    abline(0, 1, lty = 2)
    title(main = "QQ-plot for skew-normal distribution", sub = y.name)
    prob <- pchisq(rad.sn, k)
    mle$mahalanobis <- list(distance = rad.sn,
                            prob = prob,
                            df = k)
    cat("Press <Enter> to continue, 'q' to quit...")
    m <- readline()
    if (tolower(m) != "q") {
      plot((1:n) / (n + 1),
           sort(pchisq(rad.n, k)),
           xlab = "",
           ylab = "")
      abline(0, 1, lty = 3)
      title(main = "PP-plot for normal distribution", sub = y.name)
      plot((1:n) / (n + 1),
           sort(prob),
           xlab = "",
           ylab = "")
      abline(0, 1, lty = 3)
      title(main = "PP-plot for skew-normal distribution", sub = y.name)
    }
    par(mfrow = c(1, 1))
  } # end ploting
  dev.norm <- msn.dev(c(qr.coef(qrX, y), rep(0, k)), X, y, freq)
  test <- dev.norm + 2 * mle$logL
  p.value <-  1 - pchisq(test, k)
  if (trace) {
    cat("LRT for normality (test-function, p-value): ")
    print(c(test, p.value))
  }
  mle$test.normality <- list(LRT = test, p.value = p.value)
  invisible(mle)
}



msn.dev <- function(param, X, y, freq, trace = FALSE)
{
  d <- ncol(y)
  if (missing(freq))
    freq <- rep(1, nrow(y))
  n <- sum(freq)
  m <- ncol(X)
  beta <- matrix(param[1:(m * d)], m, d)
  al.om <- param[(m * d + 1):(m * d + d)]
  y0 <- y - X %*% beta
  Omega <- (t(y0) %*% (y0 * freq)) / n
  D <- diag(qr(2 * pi * Omega)[[1]])
  logDet <- sum(log(abs(D)))
  dev <- n * logDet - 2 * sum(zeta(0, y0 %*% al.om) * freq) + n * d
  if (trace) {
    cat("\nmsn.dev:", dev, "\n", "parameters:")
    
    print(rbind(beta, al.om))
  }
  dev
}

msn.dev.grad <- function(param, X, y, freq, trace = FALSE) {
  d <- ncol(y)
  if (missing(freq))
    freq <- rep(1, nrow(y))
  n <- sum(freq)
  m <- ncol(X)
  beta <- matrix(param[1:(m * d)], m, d)
  al.om <- param[(m * d + 1):(m * d + d)]
  y0 <- y - X %*% beta
  Omega <- (t(y0) %*% (freq * y0)) / n
  p1 <- zeta(1, as.vector(y0 %*% al.om))
  Dbeta <- t(X) %*% (y0 * freq) %*% solvePD(Omega) -
    outer(as.vector(t(X * freq) %*% p1), al.om)
  Dal.om <- as.vector(t(y0 * freq) %*% p1)
  if (trace) {
    cat("gradient:\n")
    print(rbind(Dbeta, Dal.om))
  }
  - 2 * c(Dbeta, Dal.om)
}

num.deriv1 <- function(x, FUN, ...)
{
  # calcola gradiente in modo numerico, se FUN calcola la funzione
  FUN <- get(FUN, inherits = TRUE)
  value <- FUN(x, ...)
  p <- length(x)
  grad <- numeric(p)
  delta <- cbind((abs(x) + 1e-10) * 1e-5, rep(1e-06, p))
  delta <- apply(delta, 1, max)
  for (i in 1:p) {
    x1 <- x
    x1[i] <- x1[i] + delta[i]
    grad[i] <- (FUN(x1, ...) - value) / delta[i]
  }
  grad
}

num.deriv2 <- function(x, FUN, ...)
{
  # derivate seconde numeriche, se FUN calcola il gradiente
  FUN <- get(FUN, inherits = TRUE)
  values <- FUN(x, ...)
  p <- length(values)
  H <- matrix(0, p, p)
  delta <- cbind((abs(x) + 1e-10) * 1e-5, rep(1e-06, p))
  delta <- apply(delta, 1, max)
  for (i in 1:p) {
    x1 <- x
    x1[i] <- x1[i] + delta[i]
    H[, i] <- (FUN(x1, ...) - values) / delta[i]
  }
  (H + t(H)) / 2
}

dsn <- function(x,
                location = 0,
                scale = 1,
                shape = 0,
                dp = NULL,
                log = FALSE)
{
  if (!is.null(dp)) {
    if (!missing(shape))
      stop("You cannot set both component parameters and dp")
    location <- dp[1]
    scale <- dp[2]
    shape <- dp[3]
  }
  z <- (x - location) / scale
  if (log)
    y <-
    (-0.9189385332046727 - logb(scale) - z ^ 2 / 2 + zeta(0, shape * z))
  else
    y <- 2 * dnorm(z) * pnorm(z * shape) / scale
  replace(y, scale <= 0, NaN)
}

psn <-
  function(x,
           location = 0,
           scale = 1,
           shape = 0,
           dp = NULL,
           engine,
           ...)
  {
    if (!is.null(dp)) {
      if (!missing(shape))
        stop("You cannot set both component parameters and dp")
      location <- dp[1]
      scale <- dp[2]
      shape <- dp[3]
      ## h.mean <- if(length(dp)>3) dp[4] else 0
    }
    z <- as.numeric((x - location) / scale)
    if (missing(engine))
      engine <-
      if (length(shape) == 1 &
          length(x) > 3)
        "T.Owen"
    else
      "biv.nt.prob"
    if (engine == "T.Owen")
      p <- pnorm(z) - 2 * T.Owen(z, shape, ...)
    else {
      zd <- cbind(z, shape / sqrt(1 + shape ^ 2))
      np <- nrow(zd)
      p <- numeric(np)
      for (k in 1:np) {
        R <- matrix(c(1, -zd[k, 2], -zd[k, 2], 1), 2, 2)
        p[k] <-
          2 * biv.nt.prob(0, rep(-Inf, 2), c(0, zd[k, 1]), rep(0, 2), R)
      }
    }
    p <- pmin(1, pmax(0, p))
    replace(p, scale <= 0, NaN)
  }

rsn <- function(n = 1,
                location = 0,
                scale = 1,
                shape = 0,
                dp = NULL)
{
  if (!is.null(dp)) {
    if (!missing(shape))
      stop("You cannot set both component parameters and dp")
    location <- dp[1]
    scale <- dp[2]
    shape <- dp[3]
  }
  u1 <- rnorm(n)
  u2 <- rnorm(n)
  id <- (u2 > shape * u1)
  u1[id] <- (-u1[id])
  y <- location + scale * u1
  attr(y, "parameters") <- c(location, scale, shape)
  return(y)
}

qsn <- function (p,
                 location = 0,
                 scale = 1,
                 shape = 0,
                 dp = NULL,
                 tol = 1e-8,
                 engine,
                 ...)
{
  if (!is.null(dp)) {
    if (!missing(shape))
      stop("You cannot set both component parameters and dp")
    location <- dp[1]
    scale <- dp[2]
    shape <- dp[3]
  }
  max.q <- sqrt(qchisq(p, 1))
  min.q <- -sqrt(qchisq(1 - p, 1))
  if (shape >  1e5)
    return(location + scale * max.q)
  if (shape < -1e5)
    return(location + scale * min.q)
  na <- is.na(p) | (p < 0) | (p > 1)
  zero <- (p == 0)
  one <- (p == 1)
  p <- replace(p, (na | zero | one), 0.5)
  cum <- sn.cumulants(0, 1, shape, n = 4)
  g1 <- cum[3] / cum[2] ^ (3 / 2)
  g2 <- cum[4] / cum[2] ^ 2
  x <- qnorm(p)
  x <- (x + (x ^ 2 - 1) * g1 / 6 + x * (x ^ 2 - 3) * g2 / 24 -
          x * (2 * x ^ 2 - 5) * g1 ^ 2 / 36)
  x <- cum[1] + sqrt(cum[2]) * x
  if (missing(engine))
    engine <-
    if (length(shape) == 1 &
        length(x) > 3)
      "T.Owen"
  else
    "biv.nt.prob"
  max.err <- 1
  dp <- c(0, 1, shape)
  while (max.err > tol) {
    x1 <-
      x - (psn(x, dp = dp, engine = engine, ...) - p) / dsn(x, dp = dp)
    x1 <- pmin(x1, max.q)
    x1 <- pmax(x1, min.q)
    max.err <- max(abs(x1 - x) / (1 + abs(x)))
    x <- x1
  }
  x <- replace(x, na, NA)
  x <- replace(x, zero, -Inf)
  x <- replace(x, one, Inf)
  return(location + scale * x)
}


st.cumulants <-
  function(location = 0,
           scale = 1,
           shape = 0,
           df = Inf,
           dp = NULL,
           n = 4)
  {
    if (!is.null(dp)) {
      if (!missing(shape))
        stop("You cannot set both component parameters and dp")
      location <- dp[1]
      scale <- dp[2]
      shape <- dp[3]
      df <- dp[4]
    }
    if (df == Inf)
      return(sn.cumulants(location, scale, shape, n = n))
    n <- min(as.integer(n), 4)
    if (df <= n)
      stop("need df>n")
    par <- cbind(location, scale, shape)
    delta <- par[, 3] / sqrt(1 + par[, 3] ^ 2)
    mu <-
      delta * sqrt(df / pi) * exp(lgamma((df - 1) / 2) - lgamma(df /
                                                                  2))
    cum <- matrix(NA, nrow = nrow(par), ncol = n)
    cum[, 1] <- mu
    if (n > 1)
      cum[, 2] <- df / (df - 2) - mu ^ 2
    if (n > 2)
      cum[, 3] <-
      mu * (df * (3 - delta ^ 2) / (df - 3) - 3 * df / (df - 2) +
              2 * mu ^ 2)
    if (n > 3)
      cum[, 4] <-
      (3 * df ^ 2 / ((df - 2) * (df - 4)) - 4 * mu ^ 2 * df * (3 -
                                                                 delta ^ 2) / (df - 3)
       + 6 * mu ^ 2 * df / (df - 2) - 3 * mu ^ 4) - 3 *
      cum[, 2] ^ 2
    cum <- cum * outer(par[, 2], 1:n, "^")
    cum[, 1] <- cum[, 1] + par[, 1]
    cum[, , drop = TRUE]
  }


dmst <- function(x,
                 xi = rep(0, length(alpha)),
                 Omega,
                 alpha,
                 df = Inf,
                 dp = NULL,
                 log = FALSE)
{
  if (!(missing(alpha) & missing(Omega)) && !is.null(dp))
    stop("You cannot set both component parameters and dp")
  if (!is.null(dp)) {
    if (!is.null(dp$xi))
      xi <- dp$xi
    else
      if (!is.null(dp$beta))
        xi <- as.vector(dp$beta)
      Omega <- dp$Omega
      alpha <- dp$alpha
      df <- dp$df
  }
  if (df == Inf)
    return(dmsn(
      x,
      xi = xi,
      Omega = Omega,
      alpha = alpha,
      log = log
    ))
  d <- length(alpha)
  Omega <- matrix(Omega, d, d)
  x <- if (is.vector(x))
    matrix(x, 1, d)
  else
    data.matrix(x)
  if (is.vector(xi))
    xi <- outer(rep(1, nrow(x)), xi)
  X <- t(x - xi)
  Q <- apply((solvePD(Omega) %*% X) * X, 2, sum)
  L <- as.vector(t(X / sqrt(diag(Omega))) %*% as.matrix(alpha))
  logDet <- sum(logb(abs(diag(qr(
    Omega
  )$qr))))
  if (df < 10000)  {
    const <- lgamma((df + d) / 2) - lgamma(df / 2) - 0.5 * d * logb(df)
    log1Q <- logb(1 + Q / df)
  }
  else {
    const <- (-0.5 * d * logb(2) + log1p((d / 2) * (d / 2 - 1) / df))
    log1Q <- log1p(Q / df)
  }
  log.dmt <-
    const - 0.5 * (d * logb(pi) + logDet + (df + d) * log1Q)
  log.pt <-
    pt(L * sqrt((df + d) / (Q + df)), df = df + d, log.p = TRUE)
  logPDF <-  logb(2) + log.dmt + log.pt
  if (log)
    logPDF
  else
    exp(logPDF)
}

rmst <-
  function(n = 1,
           xi = rep(0, length(alpha)),
           Omega,
           alpha,
           df = Inf,
           dp = NULL)
  {
    if (!(missing(alpha) & missing(Omega)) && !is.null(dp))
      stop("You cannot set both component parameters and dp")
    if (!is.null(dp)) {
      if (!is.null(dp$xi))
        xi <- dp$xi
      else
        if (!is.null(dp$beta))
          xi <- as.vector(dp$beta)
        Omega <- dp$Omega
        alpha <- dp$alpha
        df <- dp$df
    }
    d <- length(alpha)
    x <- if (df == Inf)
      1
    else
      rchisq(n, df) / df
    z <- rmsn(n, rep(0, d), Omega, alpha)
    y <- t(xi + t(z / sqrt(x)))
    attr(y, "parameters") <-
      list(
        xi = xi,
        Omega = Omega,
        alpha = alpha,
        df = df
      )
    return(y)
  }

pmst <- function(x,
                 xi = rep(0, length(alpha)),
                 Omega,
                 alpha,
                 df = Inf,
                 dp = NULL,
                 ...)
{
  if (!(missing(alpha) & missing(Omega)) && !is.null(dp))
    stop("You cannot set both component parameters and dp")
  if (!is.null(dp)) {
    if (!is.null(dp$xi))
      xi <- dp$xi
    else
      if (!is.null(dp$beta))
        xi <- as.vector(dp$beta)
      Omega <- dp$Omega
      alpha <- dp$alpha
      df <- dp$df
  }
  d <- length(alpha)
  Omega <- matrix(Omega, d, d)
  omega <- sqrt(diag(Omega))
  Ocor <- cov2cor(Omega)
  O.alpha <- as.vector(Ocor %*% alpha)
  delta <- O.alpha / sqrt(1 + sum(alpha * O.alpha))
  Obig <-
    matrix(rbind(c(1,-delta), cbind(-delta, Ocor)), d + 1, d +
             1)
  x <- c(0, (x - xi) / omega)
  if (df > .Machine$integer.max)
    2 * pmnorm(x, mean = rep(0, d + 1), varcov = Obig, ...)
  else
    2 * pmt(x,
            mean = rep(0, d + 1),
            S = Obig,
            df = df,
            ...)
}




dst2.plot <- function(x, y, xi, Omega, alpha, df, dp = NULL, ...)
{
  # plot bivariate density ST_2(xi,Omega,alpha,df) computed at (x,y) grid
  if (!(missing(alpha) & missing(Omega)) && !is.null(dp))
    stop("You cannot set both component parameters and dp")
  if (!is.null(dp)) {
    if (!is.null(dp$xi))
      xi <- dp$xi
    else
      if (!is.null(dp$beta))
        xi <- as.vector(dp$beta)
      Omega <- dp$Omega
      alpha <- dp$alpha
      df <- dp$df
  }
  if (any(dim(Omega) != c(2, 2)))
    stop("dim(Omega) != c(2,2)")
  nx <- length(x)
  ny <- length(y)
  xoy <-
    cbind(rep(x, ny), as.vector(matrix(y, nx, ny, byrow = TRUE)))
  X <- matrix(xoy, nx * ny, 2, byrow = FALSE)
  pdf <- dmst(X, xi, Omega, alpha, df)
  pdf <- matrix(pdf, nx, ny)
  contour(x, y, pdf, ...)
  invisible(list(
    x = x,
    y = y,
    density = pdf,
    xi = xi,
    Omega = Omega,
    alpha = alpha,
    df = df
  ))
}

mst.fit <- function(X,
                    y,
                    freq,
                    start,
                    fixed.df = NA,
                    plot.it = TRUE,
                    trace = FALSE,
                    ...)
{
  y.name <- deparse(substitute(y))
  y.names <- dimnames(y)[[2]]
  y <- as.matrix(y)
  d <- ncol(y)
  if (is.null(d))
    d <- 1
  if (d > 1) {
    if (length(y.names) == 0) {
      dimnames(y) <-
        list(dimnames(y)[[1]], outer("V", as.character(1:d), paste, sep =
                                       ""))
      y.names <- as.vector(dimnames(y)[[2]])
    }
  }
  else
    colnames(y) <- y.name
  if (missing(freq))
    freq <- rep(1, nrow(y))
  n <- sum(freq)
  if (missing(X)) {
    X <- rep(1, nrow(y))
    missing.X <- TRUE
  }
  else
    missing.X <- FALSE
  X   <- as.matrix(X)
  qrX <- qr(X)
  m   <- ncol(X)
  mle <-
    mst.mle(
      X = X,
      y = y,
      freq = freq,
      fixed.df = fixed.df,
      start = start,
      trace = trace,
      ...
    )
  mle$call <- match.call()
  beta  <- mle$dp$beta
  Omega <- mle$dp$Omega
  alpha <- mle$dp$alpha
  omega <- sqrt(diag(Omega))
  df    <- mle$dp$df
  xi    <- X %*% beta
  if (plot.it & all(freq == rep(1, length(y)))) {
    if (missing.X) {
      y0  <- y
      xi0 <- apply(xi, 2, mean)
    }
    else  {
      y0  <- y - xi
      xi0 <- rep(0, d)
    }
    if (d > 1) {
      opt <- options()
      options(warn = -1)
      pairs(
        y0,
        labels = y.names,
        panel = function(x, y, Y, y.names, xi, Omega, alpha)
        {
          for (i in 1:length(alpha)) {
            if (all(Y[, i] == x))
              Ix <- i
            if (all(Y[, i] == y))
              Iy <- i
          }
          points(x, y)
          marg <-
            msn.marginal(xi, Omega , alpha, c(Ix, Iy))
          xi.marg <- marg$xi
          Omega.marg <- marg$Omega
          alpha.marg <- marg$alpha
          x1 <- seq(min(x), max(x), length = 30)
          x2 <- seq(min(y), max(y), length = 30)
          dst2.plot(x1,
                    x2,
                    xi.marg,
                    Omega.marg,
                    alpha.marg,
                    df,
                    add = TRUE,
                    col = 2)
        },
        # end "panel" function
        Y = y0,
        y.names = y.names,
        xi = xi0,
        Omega = Omega,
        alpha = alpha
      )
      options(opt)
    }
    else{
      # plot for case d=1
      y0 <- as.vector(y0)
      x <- seq(min(pretty(y0, 10)), max(pretty(y0, 10)), length =
                 100)
      if (missing.X) {
        dp0 <- c(xi0, omega, alpha, df)
        xlab <- y.name
      }
      else {
        dp0 <- c(0, omega, alpha, df)
        xlab <- "residuals"
      }
      hist(
        y0,
        prob = TRUE,
        breaks = "FD",
        xlab = xlab,
        ylab = "density",
        main = ""
      )
      lines(x, dst(x, dp0[1], dp0[2], dp0[3], dp0[4]),  col = 2)
      if (length(y) < 101)
        points(y0, rep(0, n), pch = 1)
      title(y.name)
    }
    cat("Press <Enter> to continue...")
    readline()
    par(mfrow = c(1, 2))
    pp  <- d * qf((1:n) / (n + 1), d, df)
    pp2 <- qchisq((1:n) / (n + 1), d)
    ## Xb  <- qr.fitted(qrX,y)
    res <- qr.resid(qrX, y)
    rad.n  <-
      apply(res    * (res %*% solvePD(var(res))), 1, sum)
    rad.st <-
      apply((y - xi) * ((y - xi) %*% solvePD(Omega)), 1, sum)
    plot(
      pp2,
      sort(rad.n),
      pch = 1,
      ylim = c(0, max(rad.n, rad.st)),
      xlab = "Percentiles of chi-square distribution",
      ylab = "Mahalanobis distances"
    )
    abline(0, 1, lty = 3)
    title(main = "QQ-plot for normal distribution", sub = y.name)
    plot(
      pp,
      sort(rad.st),
      pch = 1,
      ylim = c(0, max(rad.n, rad.st)),
      xlab = "Percentiles of scaled F distribution",
      ylab = "Mahalanobis distances"
    )
    abline(0, 1, lty = 3)
    title(main = "QQ-plot for skew-t distribution", sub = y.name)
    prob <- pf(rad.st / d, d, df)
    mle$mahalanobis <-
      list(distance = rad.st,
           prob = prob,
           df = c(d, df))
    cat("Press <Enter> to continue, 'q' to quit...")
    m <- readline()
    if (tolower(m) != "q") {
      plot((1:n) / (n + 1),
           sort(pchisq(rad.n, d)),
           xlab = "",
           ylab = "")
      abline(0, 1, lty = 3)
      title(main = "PP-plot for normal distribution", sub = y.name)
      plot((1:n) / (n + 1),
           sort(prob),
           xlab = "",
           ylab = "")
      abline(0, 1, lty = 3)
      title(main = "PP-plot for skew-t distribution", sub = y.name)
    }
    par(mfrow = c(1, 1))
    
  } # end ploting
  dev.norm <-
    msn.dev(c(qr.coef(qrX, y), rep(0, d)), as.matrix(X), y, freq)
  test <- dev.norm + 2 * mle$logL
  p.value <-  1 - pchisq(test, d + 1)
  if (trace) {
    cat("LRT for normality (test-function, p-value): ")
    print(c(test, p.value))
  }
  mle$test.normality <- list(
    LRT = test,
    df = d + 1,
    p.value = p.value,
    normal.logL = dev.norm / (-2)
  )
  invisible(mle)
}




mst.dev <-
  function(param,
           X,
           y,
           freq = rep(1, nrow(X)),
           fixed.df = NA,
           trace = FALSE)
  {
    ## Diag <- function(x) diag(x, nrow=length(x), ncol=length(x))
    d <- ncol(y)
    ## if(missing(freq)) freq<-rep(1,nrow(y))
    n <- sum(freq)
    m <- ncol(X)
    beta <- matrix(param[1:(m * d)], m, d)
    D <- exp(-2 * param[(m * d + 1):(m * d + d)])
    i0 <- m * d + d * (d + 1) / 2
    A <- diag(d)
    if (d > 1)
      A[!lower.tri(A, diag = TRUE)] <- param[(m * d + d + 1):i0]
    eta <- param[(i0 + 1):(i0 + d)]
    if (is.na(fixed.df))
      df <- exp(param[i0 + d + 1])
    else
      df <- fixed.df
    Oinv <- t(A) %*% diag(D, d, d) %*% A
    ## Omega <- solvePD(Oinv)
    u <-  y - X %*% beta
    Q <- apply((u %*% Oinv) * u, 1, sum)
    L <- as.vector(u %*% eta)
    logDet <- sum(-log(D))
    if (df < 10000)  {
      const <- lgamma((df + d) / 2) - lgamma(df / 2) - 0.5 * d * logb(df)
      DQ <-  (df + d) * sum(freq * logb(1 + Q / df))
      L. <- L * sqrt((df + d) / (Q + df))
    }
    else {
      const <- (-0.5 * d * logb(2) + log1p((d / 2) * (d / 2 - 1) / df))
      DQ <-
        if (df < Inf)
          (df + d) * sum(freq * log1p(Q / df))
      else
        sum(freq * Q)
      L. <- L * sqrt((1 + d / df) / (1 + Q / df))
    }
    dev <- (n * (logDet - 2 * const + d * logb(pi)) + DQ
            - 2 * sum(freq * (log(2) + log.pt(L., df + d))))
    if (trace)
      cat("mst.dev: ", dev, "\n")
    dev
  }


mst.dev.grad <-
  function(param,
           X,
           y,
           freq = rep(1, nrow(X)),
           fixed.df = NA,
           trace = FALSE)
  {
    ## Diag <- function(x) diag(x, nrow=length(x), ncol=length(x))
    d <- ncol(y)
    n   <- sum(freq)
    m   <- ncol(X)
    beta <- matrix(param[1:(m * d)], m, d)
    D  <- exp(-2 * param[(m * d + 1):(m * d + d)])
    A  <- diag(d)
    i0 <- m * d + d * (d + 1) / 2
    if (d > 1)
      A[!lower.tri(A, diag = TRUE)] <- param[(m * d + d + 1):i0]
    eta   <- param[(i0 + 1):(i0 + d)]
    if (is.na(fixed.df))
      df <- exp(param[i0 + d + 1])
    else
      df <- fixed.df
    Oinv  <- t(A) %*% diag(D, d, d) %*% A
    u     <- y - X %*% beta
    Q     <- as.vector(apply((u %*% Oinv) * u, 1, sum))
    L     <- as.vector(u %*% eta)
    sf    <-
      if (df < 10000)
        sqrt((df + d) / (Q + df))
    else
      sqrt((1 + d / df) / (1 + Q / df))
    t.    <- L * sf
    dlogft <- (-0.5) * (1 + d / df) / (1 + Q / df)
    dt.dL <- sf
    dt.dQ <- (-0.5) * L * sf / (Q + df)
    logT. <- log.pt(t., df + d)
    dlogT. <- exp(dt(t., df + d, log = TRUE) - logT.)
    u.freq <- u * freq
    Dbeta <- (
      -2 * t(X) %*% (u.freq * dlogft) %*% Oinv
      - outer(as.vector(t(X) %*% (
        dlogT. * dt.dL * freq
      )), eta)
      - 2 * t(X) %*% (dlogT. * dt.dQ * u.freq) %*% Oinv
    )
    Deta  <- apply(dlogT. * sf * u.freq, 2, sum)
    if (d > 1) {
      M  <- 2 * (diag(D, d, d) %*% A %*% t(u * dlogft
                                           + u * dlogT. * dt.dQ) %*% u.freq)
      DA <- M[!lower.tri(M, diag = TRUE)]
    }
    else
      DA <- NULL
    M     <-
      (A %*% t(u * dlogft + u * dlogT. * dt.dQ) %*% u.freq %*% t(A))
    if (d > 1)
      DD <- diag(M) + 0.5 * n / D
    else
      DD <- as.vector(M + 0.5 * n / D)
    grad <- (-2) * c(Dbeta, DD * (-2 * D), DA, Deta)
    if (is.na(fixed.df)) {
      df0 <- if (df < Inf)
        df
      else
        1e8
      if (df0 < 10000) {
        diff.digamma <-  digamma((df0 + d) / 2) - digamma(df0 / 2)
        log1Q <- log(1 + Q / df0)
      }
      else
      {
        diff.digamma <- log1p(d / df0)
        log1Q <- log1p(Q / df0)
      }
      dlogft.ddf <- 0.5 * (diff.digamma - d / df0
                           + (1 + d / df0) * Q / ((1 + Q / df0) * df0) - log1Q)
      eps   <- 1.0e-4
      df1 <- df0 + eps
      sf1 <-
        if (df0 < 10000)
          sqrt((df1 + d) / (Q + df1))
      else
        sqrt((1 + d / df1) / (1 + Q / df1))
      logT.eps <- log.pt(L * sf1, df1 + d)
      dlogT.ddf <- (logT.eps - logT.) / eps
      Ddf   <- sum((dlogft.ddf + dlogT.ddf) * freq)
      grad <- c(grad, -2 * Ddf * df0)
    }
    if (trace)
      cat("mst.dev.grad: norm is ", sqrt(sum(grad ^ 2)), "\n")
    return(grad)
  }
##-------------

st.2logL.profile <- function(X = matrix(rep(1, n)),
                             y,
                             freq,
                             trace = FALSE,
                             fixed.comp = c(ncol(X) + 2, ncol(X) + 3),
                             fixed.values = cbind(c(-4, 4), log(c(1, 25))),
                             npts = 51 / length(fixed.comp),
                             plot.it = TRUE,
                             ...)
{
  ## plot2D profile deviance (=2(max.logL-logL)) using either parameters
  ## if(plot.it & !exists(.Device)) stop("Device not active")
  ##
  if (missing(freq))
    freq <- rep(1, length(y))
  n <- sum(freq)
  m <- ncol(X)
  npts <- as.integer(npts)
  if (length(fixed.comp) == 1) {
    param1 <- seq(fixed.values[1], fixed.values[2], length = npts)
    logL <- param2 <- rep(NA, npts)
  }
  else{
    param1 <- seq(fixed.values[1, 1], fixed.values[2, 1], length = npts)
    param2 <-
      seq(fixed.values[1, 2], fixed.values[2, 2], length = npts)
    logL   <- matrix(NA, npts, npts)
  }
  ls <- lm.fit(X, y)
  omega <- sqrt(var(resid(ls)))
  param <- c(coef(ls), log(omega), 0, log(20))[-fixed.comp]
  max.logL <- (-Inf)
  if (trace)
    cat(c("Running up to", npts, ":"))
  for (i in 1:npts) {
    if (trace)
      cat(" ", i)
    if (length(fixed.comp) == 1) {
      opt  <- optim(
        param,
        fn = st.dev.fixed,
        method = "Nelder-Mead",
        X = X,
        y = y,
        freq = freq,
        trace = trace,
        fixed.comp = fixed.comp,
        fixed.values = param1[i]
      )
      logL[i] <- opt$value / (-2)
      param <- opt$par
      if (logL[i] > max.logL) {
        max.logL <- logL[i]
        param <- numeric(m + 3)
        param[fixed.comp]  <- param1[i]
        param[-fixed.comp] <- opt$par
        dp <-
          c(param[1:m], exp(param[m + 1]), param[m + 2], exp(param[m + 3]))
        best <- list(
          fixed.comp1 = param1[i],
          fixed.comp2 = NA,
          dp = dp,
          logL = max.logL,
          opt = opt
        )
        param <- param[-fixed.comp]
      }
    }
    else{
      for (j in 1:npts) {
        opt  <- optim(
          param,
          fn = st.dev.fixed,
          method = "Nelder-Mead",
          X = X,
          y = y,
          freq = freq,
          trace = trace,
          fixed.comp = fixed.comp,
          fixed.values = c(param1[i], param2[j])
        )
        logL[i, j] <- opt$value / (-2)
        if (j == 1)
          param0 <- opt$par
        if (j < npts)
          param <- opt$par
        else
          param <- param0
        if (logL[i, j] > max.logL) {
          max.logL <- logL[i, j]
          param <- numeric(m + 3)
          param[fixed.comp]  <- c(param1[i], param2[j])
          param[-fixed.comp] <- opt$par
          dp <-
            c(param[1:m], exp(param[m + 1]), param[m + 2], exp(param[m + 3]))
          best <-
            list(
              fixed.comp1 = param1[i],
              fixed.comp2 = param2[j],
              dp = dp,
              logL = max.logL,
              opt = opt
            )
          param <- param[-fixed.comp]
        }
      }
    }
  }
  if (trace)
    cat("\n")
  dev <- 2 * (max(logL) - logL)
  if (plot.it) {
    if (length(fixed.comp) == 1) {
      plot(param1, dev, type = "l", ...)
      points(x = best$fixed.comp1,
             y = 0,
             pch = 1)
    }
    else{
      contour(
        param1,
        param2,
        dev,
        labcex = 0.5,
        levels = c(0.57, 1.37, 2.77, 4.6, 5.99, 9.2),
        labels = c(0.25, 0.5,  0.75, 0.90, 0.95, 0.99),
        ...
      )
      points(
        x = best$fixed.comp1,
        y = best$fixed.comp2,
        pch = 1,
        cex = 0.5
      )
    }
  }
  title(main = paste("Dataset:", deparse(substitute(y)),
                     "\nProfile deviance", sep = " "))
  invisible(
    list(
      call = match.call(),
      param1 = param1,
      param2 = param2,
      deviance = dev,
      max.logL = max.logL,
      best = best
    )
  )
}


st.dev.fixed <- function(free.param,
                         X,
                         y,
                         freq,
                         trace = FALSE,
                         fixed.comp = NA,
                         fixed.values = NA)
{
  ## param components: beta, log(omega), alpha, log(df)
  n <- sum(freq)
  m <- ncol(X)
  param <- numeric(length(free.param) + length(fixed.comp))
  param[fixed.comp]  <- fixed.values
  param[-fixed.comp] <- free.param
  beta  <- param[1:m]
  omega <- exp(param[m + 1])
  eta <- param[m + 2] / omega
  df  <- exp(param[m + 3])
  u <-  y - X %*% beta
  Q <- freq * (u / omega) ^ 2
  L <- u * eta
  logDet <- 2 * log(omega)
  if (df < 10000)  {
    const <- lgamma((df + 1) / 2) - lgamma(df / 2) - 0.5 * logb(df)
    log1Q <- logb(1 + Q / df)
  }
  else {
    const <- (-0.5 * logb(2) + log1p((1 / 2) * (-1 / 2) / df))
    log1Q <- log1p(Q / df)
  }
  dev <-
    (n * (logDet - 2 * const + logb(pi)) + (df + 1) * sum(freq * log1Q)
     - 2 * sum(log(2) + log.pt(L * sqrt((
       df + 1
     ) / (
       Q + df
     )), df + 1)))
  if (trace)
    cat("st.dev.fixed (param, dev): ", param, dev, "\n")
  dev
}

##----

sn.SFscore <- function(delta,
                       X,
                       y,
                       exact = FALSE,
                       trace = FALSE)
{
  ## Sartori-Firth's modified score function, with Bayes-Branco approx
  shape <- delta / sqrt(1 - delta ^ 2)
  dp <- sn.em(X, y, fixed = c(NA, NA, shape), trace = FALSE)$dp
  z <- (y - X %*% dp[1:ncol(X)]) / dp[ncol(X) + 1]
  if (exact) {
    funct <- function(x, alpha, k = 0)
      dsn(x, 0, 1, alpha) * x ^ k *  zeta(1, alpha * x) ^ 2
    a2 <- integrate(funct, -Inf, Inf, alpha = shape, k = 2)$value
    a4 <- integrate(funct, -Inf, Inf, alpha = shape, k = 4)$value
    M  <- (-0.5) * shape * a4 / a2
  } else
    M <- (-3 / 2) * shape / (1 + 8 * (shape / pi) ^ 2)
  score <- sum(zeta(1, shape * z) * z) + M
  if (trace)
    cat("sn.SFscore: (shape,score)=", format(c(shape, score)), "\n")
  attr(score, "dp") <- dp
  score
}

sn.mmle <-
  function(X,
           y,
           plot.it = TRUE,
           exact = FALSE,
           trace = FALSE,
           ...)
  {
    ## Sartori-Firth method; function revised in 2011
    n <- length(y)
    if (missing(X)) {
      X <- as.matrix(rep(1, n))
      colnames(X) <- "constant"
    }
    p  <- ncol(X)
    dp <-
      cp.to.dp(sn.mle(
        X = X,
        y = y,
        plot.it = plot.it,
        trace = trace,
        ...
      )$cp)
    sk <- dp[length(dp)]
    d0 <- sign(-sk) * 0.01
    d1 <- sign(sk) * 0.99999
    a <-
      uniroot(
        sn.SFscore,
        c(d0, d1),
        X = X,
        y = y,
        exact = exact,
        trace = trace
      )
    score <- sn.SFscore(a$root, X, y, exact = exact)
    dp <- attr(score, "dp")
    names(dp)[p + 2] <- "shape"
    logL <-
      sum(dsn(y, as.vector(X %*% dp[1:p]), dp[p + 1], dp[p + 2], log = TRUE))
    if (trace)
      cat("Modified MLE: ", dp, ", logL: ", logL, "\n")
    if (plot.it) {
      dp0 <- dp
      if (all(X == rep(1, n)))
        y0 <- y
      else {
        y0 <- y - as.vector(X %*% dp0[1:p])
        dp0 <- c(0, dp0[p + 1], dp0[p + 2])
        xlab <- "residuals"
      }
      x <-
        seq(min(pretty(y0, 10)), max(pretty(y0, 10)), length = 200)
      curve(dsn(x, dp = dp0),
            add = TRUE,
            lty = 2,
            col = 3)
    }
    info <- sn.Einfo(dp = dp, x = X)
    list(
      call = match.call(),
      dp = dp,
      se = info$se.dp,
      Einfo = info$info.dp
    )
  }

st.SFscore <- function(shape, df, z, trace = FALSE)
{
  ## Sartori-Firth's modified score function for skew-t case
  U <- function(x, shape, df) {
    u <- x * sqrt((df + 1) / (x ^ 2 + df))
    u * dt(shape * u, df = df + 1) / pt(shape * u, df = df + 1)
  }
  J <- function(x, shape, df) {
    u <- x * sqrt((df + 1) / (x ^ 2 + df))
    tee <- dt(shape * u, df = df + 1)
    Tee <- pt(shape * u, df = df + 1)
    ((df + 1) * shape * u ^ 3 * tee / ((df + 2) * (1 + (shape * u) ^
                                                     2 / (df + 1))) + (tee * u / Tee) ^ 2)
  }
  EJ <- integrate(
    function(x, shape = shape, df = df)
      J(x, shape = shape, df = df) * dst(x, 0, 1, shape, df),
    -Inf,
    Inf,
    shape = shape,
    df = df
  )$value
  nu111 <- integrate(
    function(x, shape = shape, df = df)
      U(x, shape = shape, df = df) ^ 3 * dst(x, 0, 1, shape, df),
    -Inf,
    Inf,
    shape = shape,
    df = df
  )$value
  nu1.2 <- integrate(
    function(x, shape = shape, df = df)
      U(x, shape = shape, df = df) * J(x, shape = shape, df =
                                         df) *
      dst(x, 0, 1, shape, df),-Inf,
    Inf,
    shape = shape,
    df = df
  )$value
  M <- 0.5 * (nu111 + nu1.2) / EJ
  u <- z * sqrt((df + 1) / (z ^ 2 + df))
  score <-
    sum(u * dt(shape * u, df = df + 1) / pt(shape * u, df = df +
                                              1)) + M
  if (trace)
    cat("st.SFscore(shape,score):", shape, score, "\n")
  score
}



sn.Einfo <- function(dp = NULL,
                     cp = NULL,
                     n = 1,
                     x = NULL)
{
  ## computes Expected  Fisher information matrix for SN variates
  if (is.null(dp) &
      is.null(cp))
    stop("either dp or cp must be set")
  if (!is.null(dp) &
      !is.null(cp))
    stop("either dp or cp must be set")
  if (is.null(cp))
    cp <- dp.to.cp(dp)
  if (is.null(dp))
    dp <- cp.to.dp(cp)
  if (is.null(x))
  {
    x <- matrix(rep(1, n), nrow = n, ncol = 1)
    xx <- n
    sum.x <- n
    p <- 1
  }
  else
  {
    if (n != 1)
      warning("You have set both n and x, I am setting n<-nrow(x)")
    n <- nrow(x)
    p <- ncol(x)
    xx <- t(x) %*% x
    sum.x <- matrix(apply(x, 2, sum))
  }
  if (length(cp) != (p + 2) | length(dp) != (p + 2))
    stop("length(dp) | length(cp) must be equal to ncol(x)+2")
  omega <- dp[p + 1]
  alpha <- dp[p + 2]
  E.z   <- sqrt(2 / pi) * alpha / sqrt(1 + alpha ^ 2)
  s.z   <- sqrt(1 - E.z ^ 2)
  I.dp  <- matrix(NA, p + 2, p + 2)
  if (abs(alpha) < 200) {
    a0 <- integrate(function(x)
      dsn(x, 0, 1, alpha) * zeta(1, alpha * x) ^ 2, -Inf, Inf)$value
    a1 <-
      integrate(function(x)
        dsn(x, 0, 1, alpha) * x * zeta(1, alpha * x) ^ 2, -Inf, Inf)$value
    a2 <-
      integrate(function(x)
        dsn(x, 0, 1, alpha) * x ^ 2 * zeta(1, alpha * x) ^ 2,
        -Inf,
        Inf)$value
  }
  else
  {
    a0 <- sign(alpha) * 0.7206 / abs(alpha)
    a1 <- -sign(alpha) * (0.6797 / alpha) ^ 2
    a2 <-
      2 * pi ^ 2 / (pi ^ 2 + 8 * alpha ^ 2) ^ 1.5 # Bayes&Branco, (2.3)
  }
  I.dp[1:p, 1:p] <- xx * (1 + alpha ^ 2 * a0) / omega ^ 2
  I.dp[p + 1, p + 1] <- n * (2 + alpha ^ 2 * a2) / omega ^ 2
  I.dp[p + 2, p + 2] <- n * a2
  I.dp[1:p, p + 1] <-
    sum.x * (E.z * (1 + E.z ^ 2 * pi / 2) + alpha ^ 2 * a1) / omega ^ 2
  I.dp[p + 1, 1:p] <- t(I.dp[1:p, p + 1])
  I.dp[1:p, p + 2] <-
    sum.x * (sqrt(2 / pi) / (1 + alpha ^ 2) ^ 1.5 - alpha * a1) / omega
  I.dp[p + 2, 1:p] <- t(I.dp[1:p, p + 2])
  I.dp[p + 1, p + 2] <-
    I.dp[p + 2, p + 1] <- n * (-alpha * a2) / omega
  ## cp <- dp.to.cp(dp)
  sigma <- cp[p + 1]
  gamma1 <- cp[p + 2]
  D  <- diag(p + 2)
  R  <- E.z / s.z
  Tee  <- sqrt(2 / pi - (1 - 2 / pi) * R ^ 2)
  Da.Dg <-
    2 * (Tee / (Tee * R) ^ 2 + (1 - 2 / pi) / Tee ^ 3) / (3 * (4 -
                                                                 pi))
  DE.z <- sqrt(2 / pi) / (1 + alpha ^ 2) ^ 1.5
  Ds.z <- (-E.z / s.z) * DE.z
  D[1, p + 1] <- (-R)
  D[1, p + 2] <- (-sigma * R) / (3 * gamma1)
  D[p + 1, p + 1] <- 1 / s.z
  D[p + 1, p + 2] <- (-sigma) * Ds.z * Da.Dg / s.z ^ 2
  D[p + 2, p + 2] <- Da.Dg
  I.cp  <- t(D) %*% I.dp %*% D
  I.cp <- (I.cp + t(I.cp)) / 2
  se.dp <- sqrt(diag(solvePD(I.dp)))
  se.cp <- sqrt(diag(solvePD(I.cp)))
  dimnames(I.cp) <- list(names(cp), names(cp))
  dimnames(I.dp) <- list(names(dp), names(dp))
  aux <- list(Deriv = D, a.int = c(a0, a1, a2))
  list(
    dp = dp,
    cp = cp,
    info.dp = I.dp,
    info.cp = I.cp,
    se.dp = se.dp,
    se.cp = se.cp,
    aux = aux
  )
}

##----


sn.logL.grouped <- function(param, breaks, freq, trace = FALSE)
{
  cdf <- pmax(psn(breaks, param[1], exp(param[2]), param[3]), 0)
  p <- diff(cdf)
  logL <- sum(freq * log(p))
  if (trace)
    print(c(param, logL))
  logL
}

sn.mle.grouped <- function(breaks,
                           freq,
                           trace = FALSE,
                           start = NA)
{
  if (any(is.na(start))) {
    b <- breaks
    d <- diff(b)
    if (b[1] == -Inf)
      b[1] <- b[2] - d[2]
    if (b[length(b)] == Inf)
      b[length(b)] <- b[length(b) - 1] + d[length(d) - 1]
    mid <- (b[-1] + b[-length(b)]) / 2
    dp <- msn.mle(y = mid,
                  freq = freq,
                  trace = trace)$dp
    start <- c(dp[[1]], log(sqrt(dp[[2]])), dp[[3]])
  }
  opt <- optim(
    start,
    sn.logL.grouped,
    control = list(fnscale = -1),
    breaks = breaks,
    freq = freq,
    trace = trace
  )
  param <- opt$par
  dp <- c(param[1], exp(param[2]), param[3])
  invisible(list(
    call = match.call(),
    dp = dp,
    logL = opt$value,
    end = param,
    opt = opt
  ))
}


st.logL.grouped <- function(param, breaks, freq, trace = FALSE)
{
  if (param[4] > 5.5214609)
    ## 5.5214609=log(250)
    cdf <- psn(breaks, param[1], exp(param[2]), param[3])
  else
    cdf <-
      pst(breaks, param[1], exp(param[2]), param[3], exp(param[4]))
  p <- pmax(diff(cdf), 1.0e-10)
  logL <- sum(freq * log(p))
  if (trace)
    print(c(param, logL))
  logL
}

st.mle.grouped <- function(breaks,
                           freq,
                           trace = FALSE,
                           start = NA)
{
  if (any(is.na(start))) {
    a <- sn.mle.grouped(breaks, freq)
    start <- c(a$end, log(15))
    if (trace)
      cat("Initial parameters set to:", format(start), "\n")
  }
  opt <- optim(
    start,
    st.logL.grouped,
    control = list(fnscale = -1),
    breaks = breaks,
    freq = freq,
    trace = trace
  )
  param <- opt$par
  dp <- c(param[1], exp(param[2]), param[3], exp(param[4]))
  logL <- opt$value
  invisible(list(
    call = match.call(),
    dp = dp,
    logL = logL,
    end = param,
    opt = opt
  ))
}

msn.affine <- function(dp, a = 0, A, drop = TRUE)
{
  ## computes distribution of affine transformation of MSN/MST variate, T=a+AY,
  ## using formulae in Appendix A.2 of Capitanio et al.(2003)
  ##
  Diag  <- function(x)
    diag(x, nrow = length(x), ncol = length(x))
  if (is.null(dp$xi))
    xi <- dp$beta
  else
    xi <- dp$xi
  xi.T  <- as.vector(A %*% matrix(xi, ncol = 1) + a)
  Omega <- dp$Omega
  O.T   <- as.matrix(A %*% Omega %*% t(A))
  oi    <- Diag(1 / sqrt(diag(Omega)))
  B     <- oi %*% Omega %*% t(A)
  tmp   <-
    (oi %*% Omega %*% oi - B %*% solvePD(O.T) %*% t(B)) %*% dp$alpha
  den   <- sqrt(1 + sum(dp$alpha * as.vector(tmp)))
  num   <-
    Diag(sqrt(diag(O.T))) %*% solvePD(O.T) %*% t(B) %*% dp$alpha
  alpha <- as.vector(num / den)
  if (all(dim(O.T) == c(1, 1)) & drop)
    dp.T <-
    list(location = xi.T,
         scale = sqrt(as.vector(O.T)),
         shape = alpha)
  else
    dp.T <- list(xi = xi.T,
                 Omega = O.T,
                 alpha = alpha)
  if (!is.null(dp$tau))
    dp.T$tau <- dp$tau
  if (!is.null(dp$df))
    dp.T$df <- dp$df
  return(dp.T)
}

mst.affine <-
  function(dp, a = 0, A, drop = TRUE)
    msn.affine(dp, a, A, drop)

##---

st.cumulants.inversion <- function(cum, abstol = 1e-8)
{
  st.cumulants.matching <- function(par, gamma)
  {
    cum <- st.cumulants(shape = par[1],
                        df = exp(par[2]) + 4,
                        n = 4)
    g1  <- cum[3] / cum[2] ^ 1.5
    g2  <- cum[4] / cum[2] ^ 2
    (abs(g1 - gamma[1]) ^ 1.5 / (1 + abs(gamma[1])) +
      abs(g2 - gamma[2]) ^ 1.5 / (1 + gamma[2]))
  }
  if (length(cum) != 4)
    stop("cum must be a vector of length 4")
  g1 <- cum[3] / cum[2] ^ 1.5
  g2 <- cum[4] / cum[2] ^ 2
  ## if(g2<0) {
  ##     warning("cumulants matching may be inaccurate")
  ##     return(c(location=cum[1], scale=sqrt(cum[2]), shape=0, df=Inf))
  ##   }
  opt1 <- optim(
    c(0, 1),
    st.cumulants.matching,
    control = list(abstol = abstol),
    gamma = c(g1, g2)
  )
  opt2 <- nlminb(
    c(0, 1),
    st.cumulants.matching,
    control = list(abs.tol = abstol),
    gamma = c(g1, g2)
  )
  if (opt1$value < opt2$objective)
    par <- opt1$par
  else
    par <- opt2$par
  if (min(opt1$value, opt2$objective) > abstol)
    warning("cumulants matching may be inaccurate")
  alpha <- par[1]
  df  <- exp(par[2]) + 4
  cumZ <- st.cumulants(dp = c(0, 1, alpha, df))
  omega <- sqrt(cum[2] / cumZ[2])
  c(
    location = cum[1] - omega * cumZ[1],
    scale = omega,
    shape = alpha,
    df = df
  )
}


sample.centralmoments <- function(x,
                                  w = rep(1, length(x)),
                                  order = 4)
{
  ## central moments, but first term is ordinary mean
  if (order < 1 | order != round(order))
    stop("order must be a positive integer")
  x <- as.vector(x)
  m <- weighted.mean(x, w = w, na.rm = TRUE)
  mom <- rep(0, order)
  mom[1] <- m
  if (order > 1)
    for (k in 2:order)
      mom[k] <- weighted.mean((x - m) ^ k, w = w, na.rm = TRUE)
  mom
}

solvePD <- function(x)
{
  ## inverse of a symmetric positive definite matrix
  u <- chol(x, pivot = FALSE)
  if (prod(diag(u)) <= 0)
    stop("matrix not positive definite")
  ## ui <- backsolve(u,diag(ncol(x)))
  ## ui %*% t(ui)
  chol2inv(u)
}



##---
log.pt <- function(x, df) {
  ## fix for log(pt(...)) when it gives -Inf
  ## see Abramowitz & Stegun formulae 26.7.8 & 26.2.13)
  ## However, new releases of R (>=2.3) seem to have fixed the problem
  if (df == Inf)
    return(pnorm(x, log.p = TRUE))
  p <- pt(x, df = df, log.p = TRUE)
  ninf <- (p == -Inf)
  x0 <-
    (1 - 1 / (4 * df)) * (-x[ninf]) / sqrt(1 + x[ninf] ^ 2 / (2 *
                                                                df))
  p[ninf] <-
    dnorm(x0, log = TRUE) - log(x0) + log1p(-1 / (x0 ^ 2 + 2))
  p
}



st.mmle <- function(X, y, df, trace = FALSE)
{
  n <- length(y)
  if (missing(X)) {
    X <- as.matrix(rep(1, n))
    colnames(X) <- "constant"
  }
  m <- ncol(X)
  dp <- st.mle(
    X = X,
    y = y,
    fixed.df = df,
    trace = trace
  )$dp
  z <- (y - as.vector(X %*% dp[1:m])) / dp[m + 1]
  start <- sign(dp[m + 2]) * min(5000, abs(dp[m + 2]))
  a0 <- start / 4
  f0 <- st.SFscore(a0, df, z, trace = trace)
  a1 <- start
  f1 <- st.SFscore(a1, df, z, trace = trace)
  while (f0 * f1 > 0) {
    a1 <- a0
    f1 <- f0
    a0 <- a0 / 4
    f0 <- st.SFscore(a0, df, z, trace = trace)
  }
  if (trace)
    cat("st.mmle: (a0, a1)= ", a0, a1, "\n")
  a <-
    uniroot(
      st.SFscore,
      interval = c(a0, a1),
      df = df,
      z = z,
      trace = trace
    )
  dp <- c(dp[1:(m + 1)], shape = a$root, df = df)
  list(call = match.call(), dp = dp)
}

.checkSameEsets <- function(esets) {
  matrix.one <- exprs(esets[[1]])
  dimnames(matrix.one) <- NULL
  matrix.two <- exprs(esets[[2]])
  dimnames(matrix.two) <- NULL
  pdata.one <- pData(esets[[1]])
  rownames(pdata.one) <- NULL
  pdata.two <- pData(esets[[2]])
  rownames(pdata.two) <- NULL
  output <-
    identical(matrix.one, matrix.two) &
    identical(pdata.one, pdata.two)
  return(output)
}

#' Skew-t Distribution
#' 
#' Density function, distribution function and random number generation for the
#' skew-\eqn{t} (ST) distribution.  Functions copied from \code{sn} CRAN
#' library v0.4.18 for argument name compatibility with \code{st.mle} function
#' from the same version.
#' 
#' 
#' @aliases dst pst qst rst
#' @param x vector of quantiles. Missing values (\code{NA}s) are allowed.
#' @param p vector of probabililities
#' @param location vector of location parameters.
#' @param scale vector of (positive) scale parameters.
#' @param shape vector of shape parameters. With \code{pst} and \code{qst}, it
#' must be of length 1.
#' @param df degrees of freedom (scalar); default is \code{df=Inf} which
#' corresponds to the skew-normal distribution.
#' @param dp a vector of length 4, whose elements represent location, scale
#' (positive), shape and df, respectively.  If \code{dp} is specified, the
#' individual parameters cannot be set.
#' @param n sample size.
#' @param log logical; if TRUE, densities are given as log-densities.
#' @param tol a scalar value which regulates the accuracy of the result of
#' \code{qsn}.
#' @param ... additional parameters passed to \code{integrate}.
#' @return Density (\code{dst}), probability (\code{pst}), quantiles
#' (\code{qst}) and random sample (\code{rst}) from the skew-\eqn{t}
#' distribution with given \code{location}, \code{scale}, \code{shape} and
#' \code{df} parameters.
#' @section Details: Typical usages are \preformatted{% dst(x, location=0,
#' scale=1, shape=0, df=Inf, log=FALSE) dst(x, dp=, log=FALSE) pst(x,
#' location=0, scale=1, shape=0, df=Inf, ...) pst(x, dp=, log=FALSE) qst(p,
#' location=0, scale=1, shape=0, df=Inf, tol=1e-8, ...) qst(x, dp=, log=FALSE)
#' rst(n=1, location=0, scale=1, shape=0, df=Inf) rst(x, dp=, log=FALSE) }
#' @seealso \code{\link{st.mle}}
#' @references Azzalini, A. and Capitanio, A. (2003). Distributions generated
#' by perturbation of symmetry with emphasis on a multivariate skew-\emph{t}
#' distribution. \emph{J.Roy. Statist. Soc. B} \bold{65}, 367--389.
#' @keywords distribution
#' @examples
#' 
#' pdf <- dst(seq(-4,4,by=0.1), shape=3, df=5)
#' rnd <- rst(100, 5, 2, -5, 8)
#' q <- qst(c(0.25,0.5,0.75), shape=3, df=5)
#' stopifnot(identical(all.equal(pst(q, shape=3, df=5), c(0.25,0.5,0.75)), TRUE))
#' 
#' @export dst
dst <-
  function (x,
            location = 0,
            scale = 1,
            shape = 0,
            df = Inf,
            dp = NULL,
            log = FALSE)
  {
    if (!is.null(dp)) {
      if (!missing(shape))
        stop("You cannot set both component parameters and dp")
      location <- dp[1]
      scale <- dp[2]
      shape <- dp[3]
      df <- dp[4]
    }
    if (df > 1e6)
      return(dsn(x, location, scale, shape, log = log))
    z   <- (x - location) / scale
    pdf <- dt(z, df = df, log = log)
    cdf <- pt(shape * z * sqrt((df + 1) / (z ^ 2 + df)), df = df + 1, log.p =
                log)
    if (log)
      logb(2) + pdf + cdf - logb(scale)
    else
      2 * pdf * cdf / scale
  }

#' @export
#' @name dst
rst <-
  function (n = 1,
            location = 0,
            scale = 1,
            shape = 0,
            df = Inf,
            dp = NULL)
  {
    if (!is.null(dp)) {
      if (!missing(shape))
        stop("You cannot set both component parameters and dp")
      location <- dp[1]
      scale <- dp[2]
      shape <- dp[3]
      df <- dp[4]
    }
    z <- rsn(n, location = 0, scale, shape)
    if (df == Inf)
      return(z + location)
    v <- rchisq(n, df) / df
    y <- z / sqrt(v) + location
    attr(y, "parameters") <- c(location, scale, shape, df)
    return(y)
  }

#' @export
#' @name dst
pst <-
  function (x,
            location = 0,
            scale = 1,
            shape = 0,
            df = Inf,
            dp = NULL,
            ...)
  {
    if (!is.null(dp)) {
      if (!missing(shape))
        stop("You cannot set both component parameters and dp")
      location <- dp[1]
      scale <- dp[2]
      shape <- dp[3]
      df <- dp[4]
    }
    fp <- function(v, shape, df, t.value)
      psn(sqrt(v) * t.value, 0, 1, shape) * dchisq(v * df, df = df) * df
    if (df > 1e6)
      # (== Inf)
      p <- psn(x, location, scale, shape)
    else
    {
      if (df <= 0)
        stop("df must be non-negative")
      z <- (x - location) / scale
      p <- numeric(length(z))
      for (i in 1:length(z)) {
        p[i]  <-
          if (round(df) == df)
            pmst(z[i], 0, matrix(1, 1, 1), shape, df, ...)
        else{
          if (abs(z[i]) == Inf)
            (1 + sign(z[i])) / 2
          else{
            if (z[i] < 0)
              integrate(dst,-Inf, z[i], shape = shape, df = df, ...)$value
            else
              integrate(
                fp,
                0,
                Inf,
                shape = shape,
                df = df,
                t.value = z[i],
                ...
              )$value
          }
        }
      }
      pmax(0, pmin(1, p))
    }
  }

#' @export
#' @name dst
qst <- function (p,
                 location = 0,
                 scale = 1,
                 shape = 0,
                 df = Inf,
                 tol = 1e-06,
                 dp = NULL,
                 ...)
{
  if (!is.null(dp)) {
    if (!missing(shape))
      stop("You cannot set both component parameters and dp")
    location <- dp[1]
    scale <- dp[2]
    shape <- dp[3]
    df <- dp[4]
  }
  if (df > 1e4)
    # (== Inf)
    return(qsn(p, location, scale, shape))
  max.q <- sqrt(qf(p, 1, df))
  min.q <- -sqrt(qf(1 - p, 1, df))
  if (shape == Inf)
    return(location + scale * max.q)
  if (shape == -Inf)
    return(location + scale * min.q)
  na <- is.na(p) | (p < 0) | (p > 1)
  zero <- (p == 0)
  one <- (p == 1)
  p <- replace(p, (na | zero | one), 0.5)
  cum <- st.cumulants(0, 1, shape, max(df, 5), n = 4)
  g1 <- cum[3] / cum[2] ^ (3 / 2)
  g2 <- cum[4] / cum[2] ^ 2
  x <- qnorm(p)
  x <- (x + (x ^ 2 - 1) * g1 / 6 + x * (x ^ 2 - 3) * g2 / 24 -
          x * (2 *  x ^ 2 - 5) * g1 ^ 2 / 36)
  x <- cum[1] + sqrt(cum[2]) * x
  max.err <- 1
  while (max.err > tol) {
    x1 <- x - (pst(x, 0, 1, shape, df, ...) - p) / dst(x, 0, 1, shape, df)
    x1 <- pmin(x1, max.q)
    x1 <- pmax(x1, min.q)
    max.err <- max(abs(x1 - x) / (1 + abs(x)))
    x <- x1
  }
  x <- replace(x, na, NA)
  x <- replace(x, zero,-Inf)
  x <- replace(x, one, Inf)
  return(as.numeric(location + scale * x))
}

#' Maximum likelihood estimation for a (multivariate) skew-t distribution
#' 
#' Fits a skew-t (ST) or multivariate skew-t (MST) distribution to data, or
#' fits a linear regression model with (multivariate) skew-t errors, using
#' maximum likelihood estimation.  Functions copied from \code{sn} CRAN library
#' v0.4.18 because they were later deprecated in that library.
#' 
#' If \code{y} is a vector and it is supplied to \code{mst.mle}, then it is
#' converted to a one-column matrix, and a scalar skew-t distribution is
#' fitted. This is also the mechanism used by \code{st.mle} which is simply an
#' interface to \code{mst.mle}.
#' 
#' The parameter \code{freq} is intended for use with grouped data, setting the
#' values of \code{y} equal to the central values of the cells; in this case
#' the resulting estimate is an approximation to the exact maximum likelihood
#' estimate. If \code{freq} is not set, exact maximum likelihood estimation is
#' performed.
#' 
#' % To fit a scalar skew-t distribution to grouped data by exact % maximum
#' likelihood estimation, use \code{st.mle.grouped}.
#' 
#' Numerical search of the maximum likelihood estimates is performed in a
#' suitable re-parameterization of the original parameters with aid of the
#' selected optimizer (\code{nlminb} or \code{optim}) which is supplied with
#' the derivatives of the log-likelihood function. Notice that, in case the
#' optimizer is \code{optim}), the gradient may or may not be used, depending
#' on which specific method has been selected.  On exit from the optimizer, an
#' inverse transformation of the parameters is performed. For a specific
#' description on the re-parametrization adopted, see Section 5.1 and Appendix
#' B of Azzalini \& Capitanio (2003).
#' 
#' @aliases mst.mle st.mle
#' @param y a matrix (for \code{mst.mle}) or a vector (for \code{st.mle}). If
#' \code{y} is a matrix, rows refer to observations, and columns to components
#' of the multivariate distribution.
#' @param X a matrix of covariate values.  If missing, a one-column matrix of
#' 1's is created; otherwise, it must have the same number of rows of \code{y}.
#' If \code{X} is supplied, then it must include a column of 1's.
#' @param freq a vector of weights. If missing, a vector of 1's is created;
#' otherwise it must have length equal to the number of rows of \code{y}.
#' @param start for \code{mst.mle}, a list contaning the components
#' \code{beta},\code{Omega}, \code{alpha}, \code{df} of the type described
#' below; for \code{st.mle}, a vector whose components contain analogous
#' ingredients as before, with the exception that the scale parameter is the
#' square root of \code{Omega}.  In both cases, the \code{dp} component of the
#' returned list from a previous call has the required format and it can be
#' used as a new \code{start}. If the \code{start} parameter is missing,
#' initial values are selected by the function.
#' @param fixed.df a scalar value containing the degrees of freedom (df), if
#' these must be taked as fixed, or \code{NA} (default value) if \code{df} is a
#' parameter to be estimated.
#' @param trace logical value which controls printing of the algorithm
#' convergence. If \code{trace=TRUE}, details are printed. Default value is
#' \code{FALSE}.
#' @param algorithm a character string which selects the numerical optimization
#' procedure used to maximize the loglikelihood function. If this string is set
#' equal to \code{"nlminb"}, then this function is called; in all other cases,
#' \code{optim} is called, with \code{method} set equal to the given string.
#' Default value is \code{"nlminb"}.
#' @param control this parameter is passed to the chose optimizer, either
#' \code{nlminb} or \code{optim}; see the documentation of this function for
#' its usage.
#' @return A list containing the following components:
#' 
#' \item{call}{ a string containing the calling statement. } \item{dp}{ for
#' \code{mst.mle}, this is a list containing the direct parameters \code{beta},
#' \code{Omega}, \code{alpha}. Here, \code{beta} is a matrix of regression
#' coefficients with \code{dim(beta)=c(ncol(X),ncol(y))}, \code{Omega} is a
#' covariance matrix of order \code{ncol(y)}, \code{alpha} is a vector of shape
#' parameters of length \code{ncol(y)}.  For \code{st.mle}, \code{dp} is a
#' vector of length \code{ncol(X)+3}, containing \code{c(beta, omega, alpha,
#' df)}, where \code{omega} is the square root of \code{Omega}. } \item{se}{ a
#' list containing the components \code{beta}, \code{alpha}, \code{info}. Here,
#' \code{beta} and \code{alpha} are the standard errors for the corresponding
#' point estimates; \code{info} is the observed information matrix for the
#' working parameter, as explained below. } \item{algorithm}{ the list returned
#' by the chose optimizer, either \code{nlminb} or \code{optim}, plus an item
#' with the \code{name} of the selected algorithm; see the documentation of
#' either \code{nlminb} or \code{optim} for explanation of the other
#' components. }
#' @section Background: The family of multivariate skew-t distributions is an
#' extension of the multivariate Student's t family, via the introduction of a
#' \code{shape} parameter which regulates skewness; when \code{shape=0}, the
#' skew-t distribution reduces to the usual t distribution. When \code{df=Inf}
#' the distribution reduces to the multivariate skew-normal one; see
#' \code{dmsn}. See the reference below for additional information.
#' @seealso \code{\link{dst}}
#' @references Azzalini, A. and Capitanio, A. (2003).  Distributions generated
#' by perturbation of symmetry with emphasis on a multivariate skew \emph{t}
#' distribution.  The full version of the paper published in abriged form in
#' \emph{J.Roy. Statist. Soc. B} \bold{65}, 367--389, is available at
#' \url{http://azzalini.stat.unipd.it/SN/se-ext.ps}
#' @keywords distribution regression
#' @examples
#' 
#' dat <- rt(100, df=5, ncp=100)
#' fit <- st.mle(y=dat)
#' fit
#' 
#' @export mst.mle
mst.mle <-
  function (X,
            y,
            freq,
            start,
            fixed.df = NA,
            trace = FALSE,
            algorithm = c("nlminb", "Nelder-Mead", "BFGS", "CG", "SANN"),
            control = list())
  {
    algorithm <- match.arg(algorithm)
    y.name <- deparse(substitute(y))
    y.names <- dimnames(y)[[2]]
    y <- data.matrix(y)
    X <- if (missing(X))
      matrix(rep(1, nrow(y)), ncol = 1)
    else
      data.matrix(X)
    if (missing(freq))
      freq <- rep(1, nrow(y))
    x.names <- dimnames(X)[[2]]
    d <- ncol(y)
    n <- sum(freq)
    m <- ncol(X)
    if (missing(start)) {
      qrX <- qr(X)
      beta <- as.matrix(qr.coef(qrX, y))
      Omega <- matrix(var(qr.resid(qrX, y)), d, d)
      omega <- sqrt(diag(Omega))
      alpha <- rep(0, d)
      df <- ifelse(is.na(fixed.df), 10, fixed.df)
      if (trace) {
        cat("mst.mle: dp=", "\n")
        print(c(beta, Omega, alpha))
        cat("df:", df, "\n")
      }
    }
    else {
      if (!is.na(fixed.df))
        start$df <- fixed.df
      if (all(names(start) == c("beta", "Omega", "alpha", "df"))) {
        beta <- start$beta
        Omega <- start$Omega
        alpha <- start$alpha
        df <- start$df
      }
      else
        stop("start parameter is not in the form that I expected")
    }
    eta <- alpha / sqrt(diag(Omega))
    Oinv <- solvePD(Omega)
    upper <- chol(Oinv)
    D <- diag(upper)
    A <- upper / D
    D <- D ^ 2
    if (d > 1)
      param <-
      c(beta,-log(D) / 2, A[!lower.tri(A, diag = TRUE)], eta)
    else
      param <- c(beta,-log(D) / 2, eta)
    if (is.na(fixed.df))
      param <- c(param, log(df))
    if (algorithm == "nlminb") {
      opt <- nlminb(
        param,
        objective = mst.dev,
        gradient = mst.dev.grad,
        control = control,
        X = X,
        y = y,
        freq = freq,
        trace = trace,
        fixed.df = fixed.df
      )
      info <- num.deriv2(
        opt$par,
        FUN = "mst.dev.grad",
        X = X,
        y = y,
        freq = freq,
        fixed.df = fixed.df
      ) / 2
      opt$value <-  opt$objective
    }
    else{
      opt <- optim(
        param,
        fn = mst.dev,
        gr = mst.dev.grad,
        method = algorithm,
        control = control,
        hessian = TRUE,
        X = X,
        y = y,
        freq = freq,
        trace = trace,
        fixed.df = fixed.df
      )
      info <- opt$hessian / 2
    }
    dev   <- opt$value
    param <- opt$par
    opt$name <- algorithm
    if (trace) {
      cat("Message from optimization routine:", opt$message, "\n")
      cat("deviance:", dev, "\n")
    }
    beta <- matrix(param[1:(m * d)], m, d)
    D <- exp(-2 * param[(m * d + 1):(m * d + d)])
    A <- diag(d)
    i0 <- m * d + d * (d + 1) / 2
    if (d > 1)
      A[!lower.tri(A, diag = TRUE)] <- param[(m * d + d + 1):i0]
    eta <- param[(i0 + 1):(i0 + d)]
    if (is.na(fixed.df))
      df <- exp(param[i0 + d + 1])
    else
      df <- fixed.df
    Oinv <- t(A) %*% diag(D, d, d) %*% A
    Omega <- solvePD(Oinv)
    omega <- sqrt(diag(Omega))
    alpha <- eta * omega
    dimnames(beta) <- list(x.names, y.names)
    dimnames(Omega) <- list(y.names, y.names)
    if (length(y.names) > 0)
      names(alpha) <- y.names
    if (all(is.finite(info))) {
      qr.info <- qr(info)
      info.ok <- (qr.info$rank == length(param))
    }
    else
      info.ok <- FALSE
    if (info.ok) {
      se2 <- diag(solve(qr.info))
      if (min(se2) < 0)
        se <- NA
      else {
        se <- sqrt(se2)
        se.beta <- matrix(se[1:(m * d)], m, d)
        se.alpha <- se[(i0 + 1):(i0 + d)] * omega
        dimnames(se.beta)[2] <- list(y.names)
        dimnames(se.beta)[1] <- list(x.names)
        names(se.alpha) <- y.names
        se.df <- df * se[i0 + d + 1]
        se <- list(
          beta = se.beta,
          alpha = se.alpha,
          df = se.df,
          internal = se,
          info = info
        )
      }
    }
    else
      se <- NA
    dp <- list(
      beta = beta,
      Omega = Omega,
      alpha = alpha,
      df = df
    )
    list(
      call = match.call(),
      logL = -dev / 2,
      deviance = dev,
      dp = dp,
      se = se,
      algorithm = opt
    )
  }

#' @export
#' @name mst.mle
st.mle <- function(X,
                   y,
                   freq,
                   start,
                   fixed.df = NA,
                   trace = FALSE,
                   algorithm = c("nlminb", "Nelder-Mead", "BFGS", "CG", "SANN"),
                   control = list())
{
  y.name  <- deparse(substitute(y))
  y <- data.matrix(y)
  if (missing(X))
    X <- matrix(1, nrow = length(y), ncol = 1)
  dimnames(y)[[2]] <- list(y.name)
  if (missing(start)) {
    cp0 <- sn.mle(
      X = X,
      y = y,
      plot.it = FALSE,
      trace = trace
    )$cp
    m <- length(cp0) - 2
    cp0[m + 2] <- cp0[m + 2] * 0.9
    mle0 <- cp.to.dp(cp0)
    start <- list(
      beta = mle0[1:m],
      Omega = matrix(mle0[m + 1] ^ 2, 1, 1),
      alpha = mle0[m + 2],
      df = 10
    )
  }
  else {
    m <- length(start) - 3
    if (m < 1)
      stop("bad start vector")
    start <-
      list(
        beta = start[1:m],
        Omega = matrix(start[m + 1] ^ 2, 1, 1),
        alpha = start[m + 2],
        df = start[m + 3]
      )
  }
  fit <-
    mst.mle(
      X,
      y,
      freq,
      start = start,
      fixed.df = fixed.df,
      trace = trace,
      algorithm = algorithm,
      control = control
    )
  mle <- list()
  mle$call <- match.call()
  dp <- fit$dp
  se <- fit$se
  p  <- length(dp$beta)
  dp.names <- c(if (p == 1)
    "location"
    else
      dimnames(dp$beta)[[1]],
    "scale", "shape", "df")
  mle$dp  <-
    c(dp$beta, sqrt(as.vector(dp$Omega)), dp$alpha, dp$df)
  names(mle$dp) <- dp.names
  mle$se <- if (all(is.na(se)))
    NA
  else
    c(se$beta, mle$dp[p + 1] * se$internal[p + 1],
      se$alpha, dp$df * se$internal[p + 3])
  mle$logL <- fit$logL
  mle$algorithm <- fit$algorithm
  mle
}

#' DoppelGang S4 class
#'
#' S4 class containing results of doppelgangR() function.
#'
#'
#' @name DoppelGang-class
#' @aliases DoppelGang-class DoppelGang
#' @docType class
#' @section Objects from the Class: Objects can be created by calls of the form
#' \code{new(DoppelGang ...)}
#' @param x,object A DoppelGang class object
#' @author Levi Waldron and Markus Riester
#' @seealso \code{\link{plot,DoppelGang-method}}
#' @export
setClass(
  Class = "DoppelGang",
  representation(
    fullresults = "list",
    summaryresults = "data.frame",
    inputargs = "list"
  )
)

setGeneric("print")
setGeneric("summary")
setGeneric("plot")

#' @name DoppelGang-class
#' @aliases summary,DoppelGang-method
#' @export
setMethod("summary", signature(object = "DoppelGang"),
          function(object)
            object@summaryresults)

#' @name DoppelGang-class
#' @aliases show,DoppelGang-method
#' @export
setMethod("show", signature(object = "DoppelGang"),
          function(object) {
            cat ("S4 object of class:" , class (object) , "\n")
            cat (
              "Number of potential doppelgangers:" ,
              nrow(object@summaryresults),
              ": ",
              sum(object@summaryresults$expr.doppel),
              "expression, ",
              sum(object@summaryresults$pheno.doppel),
              "phenotype, ",
              sum(object@summaryresults$smokinggun.doppel),
              "smoking gun. \n"
            )
            cat (" \n ")
            cat ("Use summary(object) to obtain a data.frame of potential doppelgangrs.",
                 "\n")
            cat (" \n ")
          })

#' @name DoppelGang-class
#' @aliases print,DoppelGang-method
#' @export
setMethod("print", signature(x = "DoppelGang"),
          function(x)
            print(x@summaryresults))

#' Histograms of all pairwise sample correlations, showing identified
#' doppelgangers.
#'
#' Identified doppelgangers are shown with a red vertical line overlaid on a
#' histogram of pairwise sample correlations.  One plot is made per pair of
#' datasets.
#'
#'
#' @name plot-methods
#' @aliases plot-methods plot,DoppelGang plot,DoppelGang-method
#' plot,DoppelGang,ANY-method plot.DoppelGang plot.doppelgangR
#' @docType methods
#' @param x An object of class \code{\link{DoppelGang}}
#' @param skip.no.doppels (default FALSE) If TRUE, do not plot histograms where
#' no doppelgangers were identified.
#' @param plot.pair An optional character vector of length two, providing the
#' names of two datasets.  If provided, only the comparison of these two
#' datasets will be plotted.
#' @param \dots Additional arguments passed on to \code{\link{hist}}.
#' @return None
#' @section Methods: \describe{ \item{list("signature(x = \"DoppelGang\")")}{
#' Histograms of all pairwise sample correlations, showing identified
#' doppelgangers. } }
#' @author Levi Waldron
#' @keywords methods
#' @examples
#'
#' library(curatedOvarianData)
#' data(TCGA_eset)
#' data(GSE26712_eset)
#' ## Remove some TCGA samples to speed computation:
#' keep.tcga <-
#' c("TCGA.13.2060", "TCGA.24.2290", "TCGA.25.2392", "TCGA.25.2404",
#' "TCGA.59.2349", "TCGA.09.2044", "TCGA.24.2262", "TCGA.24.2293",
#' "TCGA.25.2393", "TCGA.25.2408", "TCGA.59.2350", "TCGA.09.2045",
#' "TCGA.24.2267", "TCGA.59.2351", "TCGA.09.2048", "TCGA.24.2271",
#' "TCGA.24.2298", "TCGA.25.2398", "TCGA.59.2354", "TCGA.09.2050",
#' "TCGA.24.2281", "TCGA.09.2051", "TCGA.29.2428", "TCGA.09.2055",
#' "TCGA.24.2289", "TCGA.29.2414", "TCGA.59.2352", "TCGA.36.2532",
#' "TCGA.36.2529", "TCGA.36.2551", "TCGA.42.2590", "TCGA.13.2071",
#' "TCGA.29.2432", "TCGA.36.2537", "TCGA.36.2547", "TCGA.04.1369",
#' "TCGA.42.2591", "TCGA.23.2641", "TCGA.29.2434", "TCGA.36.2538",
#' "TCGA.36.2548", "TCGA.04.1516", "TCGA.42.2593", "TCGA.36.2549",
#' "TCGA.04.1644", "TCGA.13.2057", "TCGA.23.2647", "TCGA.36.2530",
#' "TCGA.36.2552", "TCGA.42.2587", "TCGA.13.2061", "TCGA.42.2588",
#' "TCGA.36.2544", "TCGA.42.2589", "TCGA.13.2066", "TCGA.61.2613",
#' "TCGA.61.2614", "TCGA.24.1852", "TCGA.29.1704", "TCGA.13.1819"
#' )
#' keep.tcga <- unique(c(keep.tcga, sampleNames(TCGA_eset)[1:200]))
#' testesets <- list(Bonome08=GSE26712_eset, TCGA=TCGA_eset[, keep.tcga])
#' results1 <- doppelgangR(testesets,
#'     corFinder.args=list(use.ComBat=FALSE), phenoFinder.args=NULL,
#'     cache.dir=NULL)
#' plot(results1)
#' @export
setMethod("plot", signature(x = "DoppelGang"),
          function(x,
                   skip.no.doppels = FALSE,
                   plot.pair = NULL,
                   ...) {
            if (!is.null(plot.pair)) {
              if (is.character(plot.pair) & length(plot.pair) == 2) {
                study.names <-
                  unique(unlist(strsplit(
                    names(x@fullresults), split = x@inputargs$separator
                  )))
                if (!all(plot.pair %in% study.names))
                  stop("One or both of plot.pair do not match names(esets)")
                iplot <-
                  which(names(x@fullresults) %in% c(
                    paste(plot.pair, collapse = ":"),
                    paste(rev(plot.pair), collapse = ":")
                  ))
              } else{
                stop(
                  "plot.pair must be a character vector of length two, containing the names of two datasets seen in names(esets)"
                )
              }
            } else{
              iplot <- 1:length(x@fullresults)
            }
            op <- par()
            for (i in iplot) {
              cors <- x@fullresults[[i]]$correlations
              cors <- na.omit(as.numeric(cors))
              expr.doppels <-
                x@fullresults[[i]]$expr.doppels$outlierFinder.res
              expr.doppels <-
                expr.doppels[expr.doppels$doppel,]
              if (skip.no.doppels &
                  (nrow(expr.doppels) == 0 | is.null(expr.doppels)))
                next
              stfit <- x@fullresults[[i]]$expr.doppels$stfit
              hist.stats <-
                hist(
                  cors,
                  main = paste(names(x@fullresults)[i], stfit$algorithm$message, sep = "\n"),
                  freq = TRUE,
                  xlab = "Pairwise Correlations",
                  breaks = "FD",
                  ...
                )
              abline(v = expr.doppels$similarity,
                     col = "red",
                     lw = 0.5)
              xvals <- hist.stats$breaks
              transFun <-
                x@inputargs$outlierFinder.expr.args$transFun
              suppressWarnings(xvals <-
                                 xvals[!is.na(transFun(xvals))])
              dens.vals <-
                diff(
                  pst(
                    transFun(xvals),
                    location = stfit$dp["location"],
                    scale = stfit$dp["scale"],
                    shape = stfit$dp["shape"],
                    df = stfit$dp["df"]
                  )
                )
              xvals <- (xvals[-length(xvals)] + xvals[-1]) / 2
              freq.vals <- dens.vals * sum(hist.stats$counts)
              lines(xvals, freq.vals)
              par(ask = prod(par("mfcol")) < length(x@fullresults) &&
                    dev.interactive())
            }
            suppressWarnings(par(op))
          })

library(BiocParallel)

breast.packages <- c("breastCancerMAINZ", "breastCancerNKI", "breastCancerTRANSBIG", "breastCancerUNT", "breastCancerUPP", "breastCancerVDX")

other.packages <- "WGCNA"

if (!require(BiocManager))
    stop("You need to install BiocManager from CRAN")


for (pkg in breast.packages){
    if(!require(package=pkg, character.only=TRUE)){
        print(paste("Need to install", pkg))
        install(pkg, update=FALSE)
    }
}


for (pkg in other.packages){
    if(!require(package=pkg, character.only=TRUE)){
        print(paste("Need to install", pkg))
        install(pkg, update=FALSE)
    }
}

if(file.exists("breast_esets.rda")) {
  load("breast_esets.rda")
}else{
  esets <- bplapply(breast.packages, function(pkg) {
    print(pkg)
    library(Biobase)
    esetname <- tolower(sub("breastCancer", "", pkg))
    data(list = esetname)
    output <- get(esetname)
    output <- output[!is.na(featureData(output)$EntrezGene.ID),]
    merge.probeset <- WGCNA::collapseRows(
      datET = exprs(output),
      rowGroup = featureData(output)$EntrezGene.ID,
      rowID = featureNames(output)
    )
    output <- output[merge.probeset$selectedRow,]
    featureNames(output) <- featureData(output)$EntrezGene.ID
    return(output)
  })
  names(esets) <- sub("breastCancer", "", breast.packages)
  save(esets, file = "breast_esets.rda", compress = "bzip2")
}

library(Biobase)
table(table(unlist(lapply(esets, sampleNames))))

#set.seed(1)
#eset2 <- lapply(esets, function(x) x[sample(1:nrow(x), 300), ])

library(doppelgangR)

if(file.exists("breast_dop.rda")){
  load("breast_dop.rda")
}else{
  dop <- doppelgangR(esets, phenoFinder.args=NULL, smokingGunFinder.args=NULL,
                     outlierFinder.expr.args=list(bonf.prob = 1.0, transFun = atanh, tail = "upper"))
  warnings()
  save(dop, file="breast_dop.rda")
}
##Look for smoking guns only:
for (i in 1:length(esets))
    esets[[i]]$samplenames <- sampleNames(esets[[i]])
dop.gun <- doppelgangR(esets, manual.smokingguns=c("alt_sample_name", "unique_patient_ID", "samplenames"),
                       phenoFinder.args=NULL, corFinder.args=NULL, impute.knn.args=NULL)
save(dop.gun, file="breast_dopgun.rda")
write.csv(summary(dop.gun), file="breast_dopgun.csv")

write.csv(dop@summaryresults, file="breast_dop.csv")

pdf("breast_dop.pdf")
plot(dop)
dev.off()

library(Biobase)
esets2 <- esets[c("UNT", "UPP")]
esets2$UPP = esets2$UPP[, which(esets2$UPP$er==1)]
unt.dops <- grep("^KIU", sub("UNT:", "", summary(dop)[, 1]), val=TRUE)
keep = sort(na.omit(unique(c(which(sampleNames(esets2$UNT) %in% unt.dops), which(esets2$UNT$er==0)))))
esets2$UNT <- esets2$UNT[, keep]
doper <- doppelgangR(esets2, phenoFinder.args=NULL, smokingGunFinder.args=NULL,
                     outlierFinder.expr.args=list(bonf.prob = 1.0, transFun = atanh, tail = "upper"))

doper.ids <- summary(doper)[, 1:2]
doper.ids <- paste(doper.ids[, 1], doper.ids[, 2])

dop.ids <- summary(dop)[, 1:2]
dop.ids <- paste(dop.ids[, 1], dop.ids[, 2])
dop.ids <- grep("^UNT", dop.ids, val=TRUE)
lapply(esets, function(eset) table(eset$er))
lapply(esets2, function(eset) table(eset$er))  #UNT is 32/72 ER+, UPP is all 213 ER+
summary(dop.ids %in% doper.ids)  #all 32 ER+ doppelgangers are found, only the 5 ER- doppelgangers that were removed are gone.

library(Biobase)

if(file.exists("ovarian_esets.rda")){
    load("ovarian_esets.rda")
}else{
    library(curatedOvarianData)
    library(logging)
    source(system.file("extdata",
                       "patientselection_all.config",package="curatedOvarianData"))
    min.number.of.genes <- 2000
    source(system.file("extdata", "createEsetList.R", package =
                       "curatedOvarianData"))
    rm(list=ls(pattern="_eset"))
    save(esets, file="ovarian_esets.rda")
}

esets <- esets[c("GSE14764_eset", "GSE2109_eset", "GSE32062.GPL6480_eset")]
table(table(unlist(lapply(esets, sampleNames))))

library(doppelgangR)
res.orig <- doppelgangR(esets, phenoFinder.args=NULL, smokingGunFinder.args=NULL, within.datasets.only=TRUE)
confirmed.dups <- summary(res.orig)[-7, 1:2]
dups <- c(confirmed.dups[, 1], confirmed.dups[, 2])
dups <- sub(".+:", "", dups)

reduceEset <- function(eset, dups, n){
    keeps <- which(sampleNames(eset) %in% dups)
    maybes <- which(!sampleNames(eset) %in% dups)
    n.extras <- n - length(keeps)
    keeps <- c(keeps, sample(maybes, n.extras))
    return(eset[, keeps])
}


if(file.exists("ovc_small_datasets.rds")){
    res <- readRDS("ovc_small_datasets.rds")
}else{
    res <- list()
    for (i in 1:length(esets)){
        res[[i]] <- list()
        nseq <- c(5, seq(10, ncol(esets[[i]]), by=10))
        min.keeps <- sum(sampleNames(esets[[i]]) %in% dups)
        nseq <- nseq[nseq > min.keeps]
        for (k in 1:length(nseq)){
            eset <- reduceEset(esets[[i]], dups, nseq[k])
            res[[i]][[k]] <- doppelgangR(eset, phenoFinder.args=NULL, smokingGunFinder.args=NULL, intermediate.pruning=FALSE)
        }
        names(res[[i]]) <- nseq
    }
    names(res) <- names(esets)
    saveRDS(res, file="ovc_small_datasets.rds")
}

for (i in 1:length(res)){
    print(" ")
    print(names(res)[i])
    print(sapply(res[[i]], function(x) nrow(summary(x))))
}

plot(res[["GSE32062.GPL6480_eset"]][[1]])
plot(res[["GSE32062.GPL6480_eset"]][[2]])

#' Calculate pairwise similarities of phenoData between samples for a list
#' containing two ExpressionSets
#' 
#' This function acts as a wrapper to phenoDist to handle cases of one
#' ExpressionSet, a list of two identical ExpressionSets, or a list of two
#' different ExpressionSets.
#' 
#' 
#' @param eset.pair input: a list of ExpressionSets with two elements, or an
#' ExpressionSet.  If the two elements are identical, return the correlation
#' matrix for pairs of samples in the first element.  If not identical, return
#' pairs between the two elements.
#' @param separator a separator between dataset name (taken from the list
#' names) and sample name (taken from sampleNames(eset), to keep track of which
#' samples come from which dataset.
#' @param \dots Extra arguments passed on to phenoDist
#' @return A matrix of similarities between the phenotypes of pairs of samples.
#' @author Levi Waldron, Markus Riester, Marcel Ramos
#' @examples
#' 
#' library(curatedOvarianData)
#' data(GSE32063_eset)
#' data(GSE17260_eset)
#' esets2 <- list(JapaneseB=GSE32063_eset,
#'                 Yoshihara2010=GSE17260_eset)
#' 
#' ## standardize the sample ids to improve matching based on clinical annotation
#' esets2 <- lapply(esets2, function(X){
#'     X$alt_sample_name <- paste(X$sample_type, gsub("[^0-9]", "", X$alt_sample_name), sep="_")
#' 
#' ## Removal of columns that cannot possibly match also helps duplicated patients to stand out
#'     pData(X) <- pData(X)[, !grepl("uncurated_author_metadata", colnames(pData(X)))]
#'     X <- X[, 1:20]  ##speed computations
#'     return(X) })
#' 
#' ## See first six samples in both rows and columns
#' phenoFinder(esets2)[1:6, 1:6]
#' 
#' @export phenoFinder
phenoFinder <-
  function # Calculate pairwise similarities of phenoData between samples for a list containing two ExpressionSets
### This function acts as a wrapper to phenoDist to handle cases of
### one ExpressionSet, a list of two identical ExpressionSets, or a
### list of two different ExpressionSets.
(eset.pair,
 ### input: a list of ExpressionSets with two elements, or an
 ### ExpressionSet.  If the two elements are identical, return the
 ### correlation matrix for pairs of samples in the first element.  If
 ### not identical, return pairs between the two elements.
 separator = ":",
 ### a separator between dataset name (taken from the list names) and
 ### sample name (taken from sampleNames(eset), to keep track of which
 ### samples come from which dataset.
 ...
 ### Extra arguments passed on to phenoDist
) {
  if ((!is(eset.pair, "list") | length(eset.pair) != 2))
    stop("eset.pair should be a list of length 2")
  if (!identical(colnames(pData(eset.pair[[1]])), colnames(pData(eset.pair[[2]]))))
    stop(
      "pData slots of esets must have identical column names, e.g.
     identical(colnames(pData(eset[[1]])), colnames(pData(eset[[2]])))"
    )
  matrix.one <- as.matrix(pData(eset.pair[[1]]))
  if (is.null(rownames(matrix.one)))
    rownames(matrix.one) <- make.names(1:nrow(matrix.one))
  ##This part removes columns that are all NA.  The complication
  ##with keep.col is necessary because Surv objects get turned
  ##into two elements in keep.col.
  keep.col <- apply(matrix.one, 2, function(x)
    ! all(is.na(x)))
  keep.col <- keep.col[names(keep.col) %in% colnames(matrix.one)]
  matrix.one <-
    subset(matrix.one, select = match(names(keep.col), colnames(matrix.one)))
  matrix.one <- subset(matrix.one, select = keep.col)
  if (.checkSameEsets(eset.pair)) {
    ##Calculate similarity matrix for a single ExpressionSet:
    similarity.mat <- 1 - phenoDist(matrix.one, ...)
    similarity.mat[!upper.tri(similarity.mat)] <-
      NA  ##NA for all but upper triangle.
  } else{
    ##Calculate similarity matrix for two distinct ExpressionSets:
    matrix.two <- as.matrix(pData(eset.pair[[2]]))
    matrix.two <-
      matrix.two[, match(colnames(matrix.one), colnames(matrix.two)), drop =
                   FALSE]
    if (is.null(rownames(matrix.two)))
      rownames(matrix.two) <- make.names(1:nrow(matrix.two))
    similarity.mat <- 1 - phenoDist(matrix.one, matrix.two, ...)
  }
  return(similarity.mat)
  ### A matrix of similarities between the phenotypes of pairs of samples.
}

library(gdata)
library(R.utils)

snames <- paste(c("bladder", "CRC", "breast", "ovarian"), "_dop.csv", sep="")

if(file.exists("manual_duplicates_curation.rda")){
    load("manual_duplicates_curation.rda")
}else{
    if(file.exists("manual_duplicates_curation.xls.bz2"))
        bunzip2("manual_duplicates_curation.xls.bz2", "manual_duplicates_curation.xls")
    manuals <- lapply(snames, function(x) read.xls("manual_duplicates_curation.xls", sheet=x, as.is=TRUE))
    names(manuals) <- snames
    save(manuals, file="manual_duplicates_curation.rda")
}

autos <- lapply(snames, function(x) read.csv(x, as.is=TRUE))
names(autos) <- snames

output <- sapply(1:length(autos), function(i){
    auto.ids <- with(autos[[i]], paste(sample1, sample2))
    if(grepl("breast", names(manuals)[i])){
        is.healthy <- rep(FALSE, nrow(manuals[[i]]))
    }else{
        is.healthy <- grepl("healthy|adjacentnormal", manuals[[i]]$sample_type)
    }
    manual.ids.healthy <- with(manuals[[i]][is.healthy & manuals[[i]]$manually.confirmed, ], paste(sample1, sample2))
    manual.ids.tumor <- with(manuals[[i]][!is.healthy & manuals[[i]]$manually.confirmed, ], paste(sample1, sample2))
    ##Dataframe for counting within and between-dataset:
    manual.ds <- strsplit(manual.ids.tumor, split=" ")
    manual.ds <- t(sapply(manual.ds, function(x) sub(":.*$", "", x)))
    auto.ds <- strsplit(auto.ids, split=" ")
    auto.ds <- t(sapply(auto.ds, function(x) sub(":.*$", "", x)))
    df <- data.frame(truepos=sum(auto.ids %in% manual.ids.tumor),
                     falsepos=sum(!auto.ids %in% manual.ids.tumor),
                     falsepos.is.healthy=sum(!auto.ids %in% manual.ids.healthy),
                     totalautopos=length(auto.ids),
                     within.ds.doppels=sum(manual.ds[, 1] == manual.ds[, 2]),
                     between.ds.doppels=sum(manual.ds[, 1] != manual.ds[, 2]),
                     total.dspairs.with.dops=length(unique(paste(manual.ds[, 1], manual.ds[, 2]))),
                     total.dspairs.found=sum(unique(paste(manual.ds[, 1], manual.ds[, 2])) %in% paste(auto.ds[, 1], auto.ds[, 2])),
                     total.manual.pos=length(manual.ids.tumor)
                     )
    rownames(df) <- names(autos)[i]
    df
})
colnames(output) <- names(autos)
output <- t(output)
output

write.csv(output, file="doppelgangers_summary.csv")

## summarize all samples
library(Biobase)
output <- list()
esetsfiles <- dir(pattern="_esets\\.rda$")
k <- 0
for (i in 1:length(esetsfiles)){
    load(esetsfiles[i])
    for (j in 1:length(esets)){
        k <- k+1
        output[[k]] <- c(sub("_esets.rda", "", esetsfiles[i]),
                         names(esets)[j],
                         ncol(esets[[j]]),
                         experimentData(esets[[j]])@lab,
                         esets[[j]]@annotation,
                         experimentData(esets[[j]])@pubMedIds,
                         experimentData(esets[[j]])@name)
    }
}

output <- do.call(rbind, output)
colnames(output) <- c("Cancer Type", "Dataset", "N.samples", "Lab", "Annotation", "PMID", "Name")
write.csv(output, file="AllStudies.csv")

## -----------------------------------------
## -----------------------------------------
## ROC plot from all correlations
## -----------------------------------------
## -----------------------------------------

## Curation of smoking gun doppelgangers

## Ovarian:
## GSE12470_eset GSE17260_eset
## GSE12470_eset GSE32062.GPL6480_eset
## GSE12470_eset GSE32063_eset
## PMID15897565_eset:X0074_1776_h133a_1784	PMID17290060_eset:X0074_1776_h133a_1784
## PMID17290060_eset:X0193_0000_h133a_D1805	PMID19318476_eset:D1805

library(Biobase)
load("ovarian_esets.rda")
esets <- esets[c("GSE12470_eset", "GSE17260_eset", "GSE32062.GPL6480_eset", "GSE32063_eset", "PMID15897565_eset", "PMID17290060_eset", "PMID19318476_eset")]
##
esets[["GSE12470_eset"]]$uniqueid <- paste("Yoshihara", esets[["GSE12470_eset"]]$sample_type, gsub("[^0-9]", "", esets[["GSE12470_eset"]]$alt_sample_name), sep="_")
esets[["GSE32062.GPL6480_eset"]]$uniqueid <- paste("Yoshihara", esets[["GSE32062.GPL6480_eset"]]$sample_type, gsub("[^0-9]", "", esets[["GSE32062.GPL6480_eset"]]$alt_sample_name), sep="_")
esets[["GSE32063_eset"]]$uniqueid <- paste("Yoshihara", esets[["GSE32063_eset"]]$sample_type, gsub("[^0-9]", "", esets[["GSE32063_eset"]]$alt_sample_name), sep="_")
esets[["GSE17260_eset"]]$uniqueid <- paste("Yoshihara", esets[["GSE17260_eset"]]$sample_type, gsub("[^0-9]", "", esets[["GSE17260_eset"]]$alt_sample_name), sep="_")
esets[["PMID15897565_eset"]]$uniqueid <- paste("Duke", esets[["PMID15897565_eset"]]$sample_type, sub(".+_", "", sampleNames(esets[["PMID15897565_eset"]])), sep="_")
esets[["PMID17290060_eset"]]$uniqueid <- paste("Duke", esets[["PMID17290060_eset"]]$sample_type, gsub("[^0-9]", "", sub(".+_", "", sampleNames(esets[["PMID17290060_eset"]]))), sep="_")
esets[["PMID17290060_eset"]]$uniqueid[esets[["PMID17290060_eset"]]$alt_sample_name=="M3142"] <- "M3142"
esets[["PMID19318476_eset"]]$uniqueid <- paste("Duke", esets[["PMID19318476_eset"]]$sample_type, gsub("[^0-9]", "", esets[["PMID19318476_eset"]]$alt_sample_name), sep="_")
library(doppelgangR)
tmp <- doppelgangR(esets, corFinder.args=NULL, phenoFinder.args=NULL, manual.smokingguns="uniqueid", cache.dir=NULL)
rm(esets)
goldstandard <- list()
goldstandard[["ovarian_dop.csv"]] <- rbind(paste(summary(tmp)[, 1], summary(tmp)[, 2]),
                                           paste(summary(tmp)[, 2], summary(tmp)[, 1]))

## ## Breast:
## TRANSBIG:VDXOXFU_104	UNT:OXFU_104
## TRANSBIG:VDXKIU_136B04	UPP:UPP_136B04
## UNT:KIU_101B88	UPP:UPP_101B88
load("breast_esets.rda")
esets <- esets[c("TRANSBIG", "UNT", "UPP")]
esets[["UNT"]]$uniqueid <- sub(".+_", "", sampleNames(esets[c("UNT")]))
esets[["UPP"]]$uniqueid <- sub(".+_", "", sampleNames(esets[c("UPP")]))
esets[["TRANSBIG"]]$uniqueid <- make.unique(sub(".+_", "", sampleNames(esets[c("TRANSBIG")])))
tmp <- doppelgangR(esets, corFinder.args=NULL, phenoFinder.args=NULL, manual.smokingguns="uniqueid", cache.dir=NULL)
goldstandard[["breast_dop.csv"]] <- rbind(paste(summary(tmp)[, 1], summary(tmp)[, 2]),
                                          paste(summary(tmp)[, 2], summary(tmp)[, 1]))
rm(esets)


## ## CRC:
## GSE13067_eset	GSE14333_eset:  41 manually
## GSE18105_eset	GSE21510_eset
load("CRC_esets.rda")

esets <- esets[c("GSE13067_eset", "GSE14333_eset", "GSE18105_eset", "GSE21510_eset")]
esets[["GSE13067_eset"]]$uniqueid <- paste("Jorissen", esets[["GSE13067_eset"]]$sample_type, sub(": .+", "", esets[["GSE13067_eset"]]$alt_sample_name), sep="_")
esets[["GSE14333_eset"]]$uniqueid <- paste("Jorissen", esets[["GSE14333_eset"]]$sample_type, sub("-[0-9][A-Z]$", "", esets[["GSE14333_eset"]]$alt_sample_name), sep="_")
##
celltype <- sub(".+, ", "", esets[["GSE18105_eset"]]$alt_sample_name)
esets[["GSE18105_eset"]]$uniqueid <- paste("Matsuyama", esets[["GSE18105_eset"]]$sample_type, celltype, gsub("[^0-9]", "", esets[["GSE18105_eset"]]$alt_sample_name), sep="_")
##
celltype <- sub(".+, ", "", esets[["GSE21510_eset"]]$alt_sample_name)
celltype <- sub(" .+", "", celltype)
esets[["GSE21510_eset"]]$uniqueid <- paste("Matsuyama", esets[["GSE21510_eset"]]$sample_type, celltype, gsub("[^0-9]", "", esets[["GSE21510_eset"]]$alt_sample_name), sep="_")

crc.dop <- doppelgangR(esets, corFinder.args=NULL, phenoFinder.args=NULL, manual.smokingguns="uniqueid", cache.dir=NULL)
goldstandard[["CRC_dop.csv"]] <- rbind(paste(summary(crc.dop)[, 1], summary(crc.dop)[, 2]),
                                       paste(summary(crc.dop)[, 2], summary(crc.dop)[, 1]))
rm(esets)



## ## Bladder:
## GSE5287_eset	GSE89_eset
## GSE19915.GPL3883_eset	GSE32894_eset
## GSE19915.GPL3883_eset GSE19915.GPL5186_eset

load("bladder_esets.rda")

esets <- esets[c("GSE5287_eset", "GSE89_eset", "GSE19915.GPL3883_eset", "GSE32894_eset", "GSE19915.GPL5186_eset")]
##
esets[["GSE5287_eset"]]$uniqueid <- paste("Als", esets[["GSE5287_eset"]]$sample_type, sub("Sample # ", "", esets[["GSE5287_eset"]]$alt_sample_name))
esets[["GSE89_eset"]]$uniqueid <- paste("Als", esets[["GSE89_eset"]]$sample_type, sub("Sample # ", "", esets[["GSE89_eset"]]$alt_sample_name))
##
esets[["GSE19915.GPL3883_eset"]]$uniqueid <- paste("Lindgren", esets[["GSE19915.GPL3883_eset"]]$sample_type, sub("([UCN]+_[0-9]+).+", "\\1", esets[["GSE19915.GPL3883_eset"]]$alt_sample_name))
esets[["GSE32894_eset"]]$uniqueid <- paste("Lindgren", esets[["GSE32894_eset"]]$sample_type, sub("([UCN]+_[0-9]+).+", "\\1", esets[["GSE32894_eset"]]$alt_sample_name))
esets[["GSE19915.GPL5186_eset"]]$uniqueid <- paste("Lindgren", esets[["GSE19915.GPL5186_eset"]]$sample_type, sub("([UCN]+_[0-9]+).+", "\\1", esets[["GSE19915.GPL5186_eset"]]$alt_sample_name))

summary(esets[["GSE19915.GPL5186_eset"]]$uniqueid %in% esets[["GSE19915.GPL3883_eset"]]$uniqueid)
summary(esets[["GSE32894_eset"]]$uniqueid %in% esets[["GSE19915.GPL3883_eset"]]$uniqueid)
summary(esets[["GSE32894_eset"]]$uniqueid %in% esets[["GSE19915.GPL5186_eset"]]$uniqueid)

bladder.dop <- doppelgangR(esets, corFinder.args=NULL, phenoFinder.args=NULL, manual.smokingguns="uniqueid", cache.dir=NULL)
goldstandard[["bladder_dop.csv"]] <- rbind(paste(summary(bladder.dop)[, 1], summary(bladder.dop)[, 2]),
                                           paste(summary(bladder.dop)[, 2], summary(bladder.dop)[, 1]))
rm(esets)


matrixToDf <- function(x){
    data.frame(sample=array(outer(rownames(x), colnames(x), FUN=paste)),
               correlation=as.numeric(x))
}

doppelmelt <- function(obj, ds){
    cormat <- obj@fullresults[[ds]]$correlations
    if(identical(rownames(cormat), colnames(cormat))){
        cormat[lower.tri(cormat)] <- cormat[upper.tri(cormat)]
    }
    if(nrow(cormat) < ncol(cormat)) cormat <- t(cormat)
    idx <- sapply(rownames(cormat), function(x) which.max(cormat[x, ]))
    corvec <- sapply(1:nrow(cormat), function(i) cormat[i, idx[i]])
    output <- data.frame(sample=paste(rownames(cormat), colnames(cormat)[idx]),
                         correlation=corvec, stringsAsFactors=FALSE)
    return(output)
}
plotROC <- function(pred, labels, plot = TRUE, na.rm = TRUE, colorize = FALSE, ...) {
    require(ROCR)
    require(pROC)
    if (na.rm) {
        idx <- !is.na(labels)
        pred <- pred[idx]
        labels <- labels[idx]
    }
    pred.rocr <- prediction(pred, labels)
    perf.rocr <- performance(pred.rocr, "tpr", "fpr")
    auc <- performance(pred.rocr, "auc")@y.values[[1]][[1]]
    roc.obj <- roc(labels, pred)
    auc.ci <- ci(roc.obj)
    significant <- ifelse(ci(roc.obj, conf.level=0.9)[1] > 0.5, "*", "")
    best <- coords(roc.obj,x="best", transpose = FALSE)
    if (plot) {
        plot(perf.rocr, colorize = colorize, cex.lab = 1.3, ...)
        text(0, 0.9, paste("AUC = ", round(auc, digits = 2), significant,
        sep=""), cex = 1.5, pos = 4)
        abline(a = 0, b = 1, lty = 2)
        text(1, 0.1, paste("n =", length(labels)), cex = 1.5, pos = 2)
        abline(a = 0, b = 1, lty = 2)
    }
    invisible(list(auc,auc.ci,best))
}



library(ROCR)
if(file.exists("pairwise.perf.rda")){
    load("pairwise.perf.rda")
}else{
    pairwise.perf <- list()
    pairwise.auc <- list()
    for (sname in snames){
        print(sname)
        load(sub("csv", "rda", sname))
##        pairwise.cors <- lapply(dop@fullresults, function(x) na.omit(matrixToDf(x$correlations)))
        pairwise.dsnames <- names(dop@fullresults)
        ## Look across studies only
        pairwise.dsnames <- pairwise.dsnames[sapply(strsplit(pairwise.dsnames, ":"), function(x) !identical(x[1], x[2]))]
        pairwise.cors <- lapply(pairwise.dsnames, function(ds){
            doppelmelt(dop, ds)
        })
        names(pairwise.cors) <- pairwise.dsnames
##        pairwise.cors <- do.call(rbind, pairwise.cors)
        ##
        pairwise.perf[[sname]] <- list()
        pairwise.auc[[sname]] <- list()
        for (i in 1:length(pairwise.cors)){
            pairwise.cors[[i]]$TP <- 0
            pairwise.cors[[i]]$TP[ pairwise.cors[[i]]$sample %in% goldstandard[[sname]] ] <- 1
            if(identical(all.equal(sum(pairwise.cors[[i]]$TP), 0), TRUE)) next
            pairwise.pred <- prediction(predictions=pairwise.cors[[i]]$correlation, labels=pairwise.cors[[i]]$TP)
            pairwise.perf[[sname]][[names(pairwise.cors)[i]]] <- performance(pairwise.pred, measure="tpr", x.measure="fpr")
            pairwise.auc[[sname]][[names(pairwise.cors)[i]]] <- performance(pairwise.pred, measure="auc")
        }
        ##
        ##        pairwise.perf[[sname]] <- roc(predictor=pairwise.cors$correlation, response=pairwise.cors$TP, plot=TRUE)
    }
    save(pairwise.perf, pairwise.auc, file="pairwise.perf.rda")
}

pdf("pairwise.perf.pdf")
par(mfrow=c(2, 2))
for (i in 1:length(pairwise.perf)){
    for (j in 1:length(pairwise.perf[[i]])){
        plot(pairwise.perf[[i]][[j]], add=(j>1), main=sub("_dop.csv", "", names(pairwise.perf)[i]), lty=j)
    }
    mycex <- ifelse(names(pairwise.perf)[i] %in% c("bladder_dop.csv", "ovarian_dop.csv"), 0.75, 1)
    legend("bottomright", legend=gsub("_eset", "", names(pairwise.perf[[i]])), lty=1:length(pairwise.perf[[i]]), bty='n', cex=mycex)
}
dev.off()

##Mean AUC is 0.97:
mean(unlist(sapply(pairwise.auc, function(auc1) sapply(auc1, function(auc2) auc2@y.values[[1]]))))

## pairwise.spline <- lapply(pairwise.perf, function(pairwise.cancer){
##     lapply(pairwise.cancer, function(perf1){
##         spline(perf1@x.values[[1]], perf1@y.values[[1]], xout=seq(0, 1, length.out=1001))
##     })
## })

## pairwise.splineout <- lapply(pairwise.spline, function(pairwise.1cancer){
##     data.frame(smoothx=rowMeans(sapply(pairwise.1cancer, function(x) x$x)),
##                smoothy=rowMeans(sapply(pairwise.1cancer, function(x) x$y)))
## })

## pdf("pairwise.perf.pdf")
## par(mfrow=c(2, 2))
## for (i in 1:4){
##     plot(pairwise.splineout[[i]], main=sub("_dop.csv", "", snames[i]), type="l", xlim=c(0, 1), ylim=c(0, 1))
##     abline(a=0, b=1, lty=2)
## }
## dev.off()

library(Biobase)
efiles <- dir(pattern="^.*_esets\\.rda$")

res <- sapply(rev(efiles), function(efile){
    print(efile)
    load(efile)
    output <- c(length(esets), sum(sapply(esets, ncol)))
    names(output) <- c("n.datasets", "n.samples")
    output
})

write.csv(t(res), file="database_totalpatients.csv")

library(GEOquery)
library(doppelgangR)
eset <- getGEO("GSE44104")[[1]]

if(!file.exists("GSE44104_esets.rda")){
  (fnames=dir(pattern="^.*\\.CEL\\.gz$"))
  batch.var <-
    sapply(fnames,function(fname)
    {library(affyio)
      tempDate1 <- read.celfile.header(fname,info="full")$ScanDate
      output <- as.character(as.Date(tempDate1, format = "%m/%d/%y %H:%M:%S"))
      if(length(tempDate1) > 0 && is.na(output))
        output <- as.character(as.Date(tempDate1))
      if(length(output)==0) output <- NA
      return(output)
    })
  batch.var=factor(batch.var)
  library(affy)
  affybatch <- read.affybatch(filenames=fnames)
  ##library(arrayQualityMetrics)
  ##aqm <- arrayQualityMetrics(affybatch, do.logtransform=TRUE)
  eset2 = mas5(affybatch)
  exprs(eset2) = log2(exprs(eset2))
  rm(affybatch); gc()
  library(sva)
  big.matrix.combat <- sva::ComBat(exprs(eset2), mod=model.matrix(~(rep(1, length(batch.var)))), batch=batch.var)
  eset3 <- eset2
  exprs(eset3) = big.matrix.combat
  save(eset, eset2, eset3, file="GSE44104_esets.rda")
}else{
  load("GSE44104_esets.rda")
}


wuetal <- doppelgangR(eset, outlierFinder.expr.args = list(bonf.prob = 40, transFun = atanh, tail = "upper"))
wuetaltable <- summary(wuetal); rownames(wuetaltable) <- NULL
wuetaltable[, 1] <- paste0("GSE44104:", wuetaltable[, 1])
wuetaltable[, 2] <- paste0("GSE44104:", wuetaltable[, 2])
write.csv(wuetaltable, file="wuetal.csv")
library(pheatmap)
cormat <- wuetal@fullresults[[1]][[1]]
rownames(cormat) <- sub("ExpressionSet1:", "", rownames(cormat))
colnames(cormat) <- sub("ExpressionSet2:", "", colnames(cormat))

pdf("GSE44104.pdf", width=6.5, height=6.5)
plot(wuetal)
pheatmap(cormat, fontsize_row=6, fontsize_col=6)
dev.off()

wuetal2 <- doppelgangR(eset2, outlierFinder.expr.args = list(bonf.prob = 13, transFun = atanh, tail = "upper"),
                       phenoFinder.args = NULL, smokingGunFinder.args = NULL, intermediate.pruning = TRUE)

## eset3 has ComBat batch correction, does not help.
wuetal3 <- doppelgangR(eset3, outlierFinder.expr.args = list(bonf.prob = 5, transFun = atanh, tail = "upper"),
                       phenoFinder.args = NULL, smokingGunFinder.args = NULL, intermediate.pruning = TRUE)
plot(wuetal3)

library(pheatmap)
pheatmap(cor(exprs(eset2)))
pheatmap(cor(exprs(eset3)))


tmp <- exprs(eset)[, eset$title %in% c("Tm_110", "Tm_96")]
hist(tmp[, 2] - tmp[, 1])

if( !require(RTCGAToolbox) ){
    library(devtools)
    install_github("LiNk-NY/RTCGAToolbox")
    library(RTCGAToolbox)
}

all.dates <- getFirehoseRunningDates()
all.datasets <- getFirehoseDatasets()

data.path <- "/scratch/lw391/doppelgangR/inst"
data.path <- "."
data.file <- file.path(data.path, "TCGA.rda")


if(file.exists(data.file)){
    load(data.file)
}else{
    tcga.res <- list()
    for (i in 1:length(all.datasets)){
        (ds.name <- all.datasets[i])
        if(!ds.name %in% names(tcga.res)){
            res <- try(getFirehoseData(ds.name, runDate=all.dates[1], RNAseq_Gene=TRUE, RNAseq2_Gene_Norm=TRUE, mRNA_Array=TRUE))
        }
        if(!is(res, "try-error")){
            tcga.res[[ds.name]] <- res
        }
    }
    save(tcga.res, file=data.file)
}

library(Biobase)
if(file.exists(file.path(data.path, "tcga.esets.rda"))){
    load(file.path(data.path, "tcga.esets.rda"))
}else{
    tcga.esets <- list()
    for (i in 1:length(tcga.res)){
        tmp <- list()
##        tmp[["mrna"]] <- try(extract(tcga.res[[i]], "mRNA_Array"))  #RNAseq and RNAseq2 only
        tmp[["rnaseq"]] <- try(extract(tcga.res[[i]], "RNAseq_Gene"))
        tmp[["rnaseq2"]] <- try(extract(tcga.res[[i]], "RNAseq2_Gene_Norm"))
        tmp <- tmp[sapply(tmp, function(x) !is(x, "try-error"))]
        pickplat <- which.max(sapply(tmp, ncol))
        print(paste(names(tcga.res)[i], ":", names(tmp)[pickplat]))
        tcga.esets[[paste(names(tcga.res)[i], names(tmp)[pickplat])]] <- tmp[[pickplat]]
    }
    # use only primary tumors
    tcga.esets <- lapply(tcga.esets, function(x) x[,substr(sampleNames(x),14,15) %in% c( "01", "03", "09" )] )
    save(tcga.esets, file=file.path(data.path, "tcga.esets.rda"))
}


cor.list <- lapply(tcga.esets, function(eset){
    output <- cor(log2(1+exprs(eset)))
    output[upper.tri(output)]
})
names(cor.list) <- names(tcga.esets)

save(cor.list, file=file.path(data.path, "cor.list.log2.rda"))

load(file.path(data.path, "cor.list.log2.rda"))

ztrans.list <- lapply(cor.list, atanh)

suitability.table <- data.frame(perc.gt.95=signif(100*sapply(cor.list, function(x) sum(x > 0.95) / length(x)), 1),
                                quantile999=round(sapply(cor.list, quantile, 0.999), 2),
                                nsamples=sapply(cor.list, function(x) (1 + sqrt(1 + 4*2*length(x))) / 2))
rownames(suitability.table) <- sub("mrna", "microarray", rownames(suitability.table))
suitability.table$cancertype <- sub(" .+", "", rownames(suitability.table))
suitability.table$assaytype <- sub(".+ ", "", rownames(suitability.table))
rownames(suitability.table) <- NULL
##
tcgacodes <-
structure(list(Study.Abbreviation = c("GBM", "OV", "LUSC", "LAML",
"COAD", "KIRC", "LUAD", "READ", "BRCA", "STAD", "UCEC", "KIRP",
"HNSC", "LIHC", "LGG", "BLCA", "THCA", "CESC", "PRAD", "PAAD",
"DLBC", "SKCM", "SARC", "KICH", "ESCA", "UCS", "ACC", "MESO",
"PCPG", "UVM", "CHOL", "TGCT", "THYM"), Study.Name = c("Glioblastoma multiforme",
"Ovarian serous cystadenocarcinoma", "Lung squamous cell carcinoma",
"Acute Myeloid Leukemia", "Colon adenocarcinoma", "Kidney renal clear cell carcinoma",
"Lung adenocarcinoma", "Rectum adenocarcinoma", "Breast invasive carcinoma",
"Stomach adenocarcinoma", "Uterine Corpus Endometrial Carcinoma",
"Kidney renal papillary cell carcinoma", "Head and Neck squamous cell carcinoma",
"Liver hepatocellular carcinoma", "Brain Lower Grade Glioma",
"Bladder Urothelial Carcinoma", "Thyroid carcinoma", "Cervical SCC and endocervical AC",
"Prostate adenocarcinoma", "Pancreatic adenocarcinoma", "Diffuse Large B-cell Lymphoma",
"Skin Cutaneous Melanoma", "Sarcoma", "Kidney Chromophobe", "Esophageal carcinoma ",
"Uterine Carcinosarcoma", "Adrenocortical carcinoma", "Mesothelioma",
"Pheochromocytoma and Paraganglioma", "Uveal Melanoma", "Cholangiocarcinoma",
"Testicular Germ Cell Tumors", "Thymoma")), .Names = c("Study.Abbreviation",
"Study.Name"), row.names = c(2L, 10L, 24L, 26L, 29L, 33L, 35L,
43L, 48L, 49L, 50L, 52L, 55L, 56L, 79L, 87L, 88L, 89L, 92L, 107L,
136L, 180L, 218L, 226L, 254L, 302L, 304L, 353L, 366L, 416L, 427L,
429L, 430L), class = "data.frame")
##
suitability.table$Study.Name <- tcgacodes[match(suitability.table$cancertype, tcgacodes$Study.Abbreviation), "Study.Name"]
suitability.table <- suitability.table[, c(4, 6, 5, 3, 2:1)]
##
suitability.table <- suitability.table[order(suitability.table$quantile99, suitability.table$perc.gt.95), ]
rownames(suitability.table) <- 1:nrow(suitability.table)
suitability.table$Study.Name[is.na(suitability.table$Study.Name )] <- "Colorectal adenocarcinoma"
suitability.table$Study.Name <- tolower(suitability.table$Study.Name)

##Last publication restrictions in place until 12/18/2015
# library(pipeR)
# library(XML)
# library(stringr)
# url1 <- "http://cancergenome.nih.gov/publications/publicationguidelines"
# tabb <- readHTMLTable(url1, stringsAsFactors=FALSE)
# tt <- tabb[1][[1]]
# names(tt) <- c("disease", "restrict")
# tt$disease %>>% strsplit("\\(") %>>% sapply("[", 2) %>>%
#   gsub(pattern="\\)", replacement="", x=.) %>>% tolower -> tt$disease
# tt <- tt[complete.cases(tt),]
# tt[tt[,"disease"]=="coad, read",1] <- c("coad")
# tt <- rbind(tt[1:7,],c("read", NA),tt[-(1:7),])
# imin <- which.max(which(is.na(tt[, 2])))
# #for (i in imin:nrow(tt))
# tt$restrict <- str_extract_all(tt$restrict, "[0-9]{2}/[0-9]{2}/[0-9]{4}")
# tt$restrict <- ifelse(str_detect(tt$restrict, "No restrictions"), NA, tt$restrict)
# 
# tt2 <- tt[match(suitability.table$cancertype, toupper(tt[, 1])), ]
# tt2$restrict[is.na(tt2$disease)] <- "unknown"
# tt2$restrict[is.na(tt2$restrict)] <- "unrestricted"
# suitability.table$embargoed <- tt2$restrict
# 
write.csv(suitability.table, file="suitability.table.log2.csv")

library(xtable)
sink("suitability.table.log2.html")
print(xtable(suitability.table), type="html")
sink()


pdf("TCGA_PairwisePearson.log2.pdf")
j <- 0
for (i in match(suitability.table$cancertype, sub(" .+", "", names(cor.list)))){
    j <- j+1
    hist(cor.list[[i]], breaks="FD", xlab="PCC", xlim=c(0, 1),
         main=paste(names(cor.list)[i], "\n", suitability.table$Study.Name[j]))
    quant999 <- quantile(cor.list[[i]], 0.999)
    abline(v=quant999, col="red", lw=2); abline(v=0.95, col="black", lw=2)
    legend("topleft", pch=-1, col=c("black", "red"), bty="n",
           lw=2, legend=c("PCC=0.95", "99.9 percentile"))
}
dev.off()

bimods <- c("PAAD rnaseq2", "COADREAD rnaseq2", "UCEC rnaseq2", "KICH rnaseq2", "TGCT rnaseq2", "ESCA rnaseq", "HNSC rnaseq2", "LGG rnaseq2", "THYM rnaseq2", "STAD rnaseq", "GBM rnaseq2")
pdf("TCGA_PairwisePearson_bimodal.log2.pdf", width=7.5, height=9)
par(mfrow=c(4,3))
j <- 0
bimods2 <- sub(" .+", "", bimods)
st <- suitability.table[match(bimods2, suitability.table$cancertype), ]
for (i in match(bimods, names(cor.list))){
  j <- j+1
  hist(cor.list[[i]], breaks="FD", xlab="PCC", xlim=c(0, 1),
       main=paste(names(cor.list)[i], "\n", st$Study.Name[j]))
}
dev.off()

# remove restricted 
#cor.list <- cor.list[-unlist(sapply(toupper(tt[!is.na(tt$restrict),1]), grep, names(cor.list)))]
#cor.list <- cor.list[!grepl("mrna$", names(cor.list))]
names(cor.list) <- gsub(" rnaseq2","", names(cor.list))
names(cor.list) <- gsub(" rnaseq","", names(cor.list))
names(cor.list) <- suitability.table$Study.Name[match(names(cor.list), suitability.table$cancertype)]
#names(cor.list) <- sub("cervical squamous cell carcinoma and endocervical adenocarcinoma", "cervical squamous cell carcinoma \n endocervical adenocarcinoma", names(cor.list))

d.f <- do.call(rbind, lapply(names(cor.list), function(i) data.frame(Cancer=i, COR=cor.list[[i]])))
d.f$Cancer <- factor(d.f$Cancer, levels=names(cor.list)[order(sapply(cor.list, quantile, p=0.99),decreasing=TRUE)])

library(ggplot2)
pdf("tcgacor.log2.pdf", width=12,height=6)
ggplot(d.f, aes(Cancer,COR))+geom_violin()+theme_classic()+theme(axis.text.x = element_text(angle = 45, hjust = 1))+xlab("")+ylab("Pairwise Pearson Correlation")
dev.off()

##bimodal: KICH (RNAseq2), maybe KIRC and KIRP, LUSC, PAAD, PCPG, THCA, GBM

##very high correlations normally: THCA, HNSC, LIHC, maybe KIRP, LAML, PCPG, PRAD, STAD, THYM, ESCA

##looks good: ACC, BLCA, BRCA, CESC, COAD, COADREAD, DLBC, LGG,

#' Calculate Hamming Distance between two vectors, using pairwise complete
#' observations.
#'
#' Simple function to count the fraction of different elements (in the same
#' position) between two vectors of the same length, after removing elements
#' from both vectors corresponding to positions that are NA in either vector.
#'
#'
#' @param x a matrix
#' @param y a matrix with the same number of columns as x
#' @param k row in x to test for differences
#' @param l row in y to test for differences
#' @return Returns a numeric value, the Hamming Distance (the number of
#' non-equal values between x and y).
#' @author Levi Waldron, Markus Riester, Marcel Ramos
#' @examples
#'
#' (mat <- matrix(c(paste0("A", 1:5), paste0("A", 5:1)),
#'     nrow = 2, byrow = TRUE))
#'
#' stopifnot(vectorHammingDist(mat, mat, 1, 2) == 0.8)
#' stopifnot(vectorHammingDist(mat, mat, 1, 1) == 0)
#'
#' mat[1, 1] <- NA
#'
#' stopifnot(vectorHammingDist(mat, mat, 1, 2) == 0.75)
#' stopifnot(vectorHammingDist(mat, mat, 1, 1) == 0)
#'
#' mat[1, 3] <- NA
#'
#' stopifnot(vectorHammingDist(mat, mat, 1, 2) == 1)
#'
#' @export vectorHammingDist
vectorHammingDist <- function(x, y, k, l) {
    z <- as.vector(x[k, ] != y[l, ])
    sum(z, na.rm = TRUE) / length(na.omit(z))
}

#' Calculate distance between two vectors, rows of one matrix/dataframe, or
#' rows of two matrices/dataframes.
#'
#' This function does some simple looping to allow x and y to be various
#' combinations of vectors and matrices/dataframes.
#'
#'
#' @param x A vector, matrix or dataframe
#' @param y NULL, a vector, matrix, or dataframe.  If x is a vector, y must
#' also be specified.
#' @param bins discretize continuous fields in the specified number of bins
#' @param vectorDistFun A function of two vectors that returns the distance
#' between those vectors.
#' @param \dots Extra arguments passed on to vectorDistFun
#' @return a matrix of distances between pairs of rows of x (if y is
#' unspecified), or between all pairs of rows between x and y (if both are
#' provided).
#' @author Levi Waldron, Markus Riester, Marcel Ramos
#' @examples
#'
#' example("phenoFinder")
#'
#' pdat1 <- pData(esets2[[1]])
#' pdat2 <- pData(esets2[[2]])
#'
#' ## Use phenoDist() to calculate a weighted distance matrix
#' distmat <- phenoDist(as.matrix(pdat1), as.matrix(pdat2))
#' ## Note outliers with identical clinical data, these are probably the same patients:
#' graphics::boxplot(distmat)
#'
#' \dontrun{
#'    library(curatedOvarianData)
#'    data(GSE32063_eset)
#'    data(GSE17260_eset)
#'    pdat1 <- pData(GSE32063_eset)
#'    pdat2 <- pData(GSE17260_eset)
#'    ## Curation of the alternative sample identifiers makes duplicates stand out more:
#'    pdat1$alt_sample_name <-
#'      paste(pdat1$sample_type,
#'            gsub("[^0-9]", "", pdat1$alt_sample_name),
#'            sep = "_")
#'    pdat2$alt_sample_name <-
#'      paste(pdat2$sample_type,
#'            gsub("[^0-9]", "", pdat2$alt_sample_name),
#'            sep = "_")
#'    ## Removal of columns that cannot possibly match also helps duplicated patients to stand out
#'    pdat1 <-
#'      pdat1[,!grepl("uncurated_author_metadata", colnames(pdat1))]
#'    pdat2 <-
#'      pdat2[,!grepl("uncurated_author_metadata", colnames(pdat2))]
#'    ## Use phenoDist() to calculate a weighted distance matrix
#'    distmat <- phenoDist(as.matrix(pdat1), as.matrix(pdat2))
#'    ## Note outliers with identical clinical data, these are probably the same patients:
#'    graphics::boxplot(distmat)
#' }
#'
#' @export phenoDist
phenoDist <- function(x, y = NULL, bins = 10,
    vectorDistFun = vectorWeightedDist, ...) {
    if (is.vector(x) && is.vector(y)) {
        z <- vectorDistFun(matrix(x, nrow = 1), matrix(y, nrow = 1), 1, 1, ...)
    } else {
        x <- .discretizeDataFrame(x, bins)
        if (is.null(y)) {
            z <- matrix(0, nrow = nrow(x), ncol = nrow(x))
            for (k in 1:(nrow(x) - 1)) {
                for (l in (k + 1):nrow(x)) {
                    z[k, l] <- vectorDistFun(x, x, k, l, ...)
                    z[l, k] <- z[k, l]
                }
            }
            dimnames(z) <- list(rownames(x), rownames(x))
        } else {
            y <- .discretizeDataFrame(y, bins)
            z <- matrix(0, nrow = nrow(x), ncol = nrow(y))
            for (k in 1:(nrow(x))) {
                for (l in 1:nrow(y)) {
                    z[k, l] <- vectorDistFun(x, y, k, l, ...)
                }
            }
            dimnames(z) <- list(rownames(x), rownames(y))
        }
    }
    z
}

.discretizeDataFrame <- function(X, bins) {
  .discretizeRow <- function(x) {
    if (length(levels(as.factor(x))) > bins)
      return(cut(x, breaks = bins))
    as.factor(x)
  }
  idx <- apply(X, 2L, is.numeric)
  if (sum(idx) == 0)
    return(X)
  X[, idx] <-
    as.data.frame(apply(X[, idx, drop = FALSE], 2, .discretizeRow))
  X
}

datadir <- "."
load("mRNAexpression/NCI60.dataset.rda")
library(org.Hs.eg.db)
xx <- as.list(org.Hs.egALIAS2EG)
# Remove pathway identifiers that do not map to any entrez gene id
xx <- xx[!is.na(xx)]

rna <- rna[!is.na(rna$X.2),]
rna.entrez <- sapply(xx[rna$X.2], function(x) x[[1]])
idx <- !is.na(names(rna.entrez))
rna <- rna[idx,]
rna.entrez <- unlist(rna.entrez[idx])

rna.eset <- rna[!duplicated(rna.entrez), -(1:8)]
rownames(rna.eset) <- paste(rna.entrez[!duplicated(rna.entrez)], "at", sep="_")
nci60.eset <- ExpressionSet(as.matrix(rna.eset))

saveRDS(nci60.eset, file="mRNAexpression/NCI60_mrna.rds")

#ccle

expr.dat <- read.table(file.path(datadir,"mRNAexpression/CCLE_Expression_Entrez_2012-09-29.gct"), skip=2, sep="\t", as.is=TRUE,header = TRUE, check.names=FALSE)
cor(expr.dat[, colnames(expr.dat) %in% "NCIH292_LUNG"])

expr.names <- colnames(expr.dat)[-1:-2]
expr.matrix <- as.matrix(expr.dat[,-(1:2)])
rownames(expr.matrix) <- expr.dat$Name

ccle.eset <- ExpressionSet(expr.matrix)

saveRDS(ccle.eset, file="mRNAexpression/CCLE_mrna.rds")

library(curatedCRCData)
library(Biobase)
library(BiocParallel)
multicoreParam <- MulticoreParam()

source(system.file("extdata",
    "patientselection_all.config",package="curatedCRCData"))
min.number.of.genes <- 2000
source(system.file("extdata", "createEsetList.R", package =
    "curatedCRCData"))
rm(list=ls(pattern="_eset"))

library(doppelgangR)
##esets <- esets[c("GSE11237_eset", "GSE14095_eset")]
##esets <- esets[c("GSE11237_eset", "GSE3294_eset")]
esets <- esets[!names(esets) %in% c("GSE3294_eset","TCGA.RNASeqV2_eset", "TCGA.RNASeqV2.READ_eset")]  ##uses Genbank IDs instead of gene symbols.
esets <- esets[!names(esets) %in% c("GSE17536_eset", "GSE17537_eset")] #subseries of GSE17538.GPL570_eset

## Double-check there are no duplicated sample IDs:
table(table(unlist(lapply(esets, sampleNames))))

save(esets, file="CRC_esets.rda", compress="bzip2")

if(file.exists("crc_dop.rda")){
  load("crc_dop.rda")
}else{
  dop <- doppelgangR(esets, phenoFinder.args=NULL, smokingGunFinder.args=NULL, outlierFinder.expr.args=list(bonf.prob = 1.0, transFun = atanh, tail = "upper"))
  warnings()
  save(dop, file="crc_dop.rda")
}

##Look for smoking guns only:
for (i in 1:length(esets))
    esets[[i]]$samplenames <- sampleNames(esets[[i]])
dop.gun <- doppelgangR(esets, manual.smokingguns=c("alt_sample_name", "unique_patient_ID", "samplenames"),
                       phenoFinder.args=NULL, corFinder.args=NULL, impute.knn.args=NULL)
save(dop.gun, file="crc_dopgun.rda")
write.csv(summary(dop.gun), file="crc_dopgun.csv")

load("crc_dop.rda")
write.csv(dop@summaryresults, file="crc_dop.csv")
pdf("CRC_dop.pdf")
plot(dop, skip.no.doppels=TRUE)
dev.off()

#' Calculate pair-wise correlations between samples using the expr() slots of a
#' list of two ExpressionSets.
#' 
#' This function acts as a wrapper around ComBat (sva package) and cor(), to
#' calculate pairwise correlations within one or between two ExpressionSets.
#' 
#' 
#' @param eset.pair a list of ExpressionSets, with two elements.  If the two
#' elements are identical, return the correlation matrix for pairs of samples
#' in the first element.  If not identical, return pairs between the two
#' elements.
#' @param separator Separator between dataset name and sample name.  Dataset
#' names are added to sample names to keep track of dataset of origin.
#' @param use.ComBat Use the sva::ComBat function for batch correction of the
#' expr() data between the two datasets.
#' @param \dots Extra arguments passed to the cor() function.
#' @return Returns a matrix of sample-wise Pearson Correlations.
#' @author Levi Waldron, Markus Riester, Marcel Ramos
#' @examples
#' 
#' example("phenoFinder")
#' 
#' corFinder(esets2)
#' 
#' @export corFinder
corFinder <-
  function  # Calculate pair-wise correlations between samples using the expr() slots of a list of two ExpressionSets.
### This function acts as a wrapper around ComBat (sva package) and
### cor(), to calculate pairwise correlations within one or between
### two ExpressionSets.
(eset.pair,
 ### a list of ExpressionSets, with two elements.  If the two
 ### elements are identical, return the correlation matrix for pairs
 ### of samples in the first element.  If not identical, return pairs
 ### between the two elements.
 separator = ":",
 ### Separator between dataset name and sample name.  Dataset names are
 ### added to sample names to keep track of dataset of origin.
 use.ComBat = TRUE,
 ### Use the sva::ComBat function for batch correction of the expr()
 ### data between the two datasets.
 ...
 ### Extra arguments passed to the cor() function. 
){
  if (!is(eset.pair, "list") || length(eset.pair) != 2)
    stop("eset.pair should be a list of two ExpressionSets")
  if (!.checkSameEsets(eset.pair)) {
    matrix.pair <- .getMatrixPair(eset.pair, use.ComBat)
    cormat <- cor(matrix.pair[[1]], matrix.pair[[2]], ...)
  } else{
    matrix.one <- exprs(eset.pair[[1]])
    cormat <- cor(matrix.one, ...)
    cormat[!upper.tri(cormat)] <- NA  ##NA for diagonal
  }
  return(cormat)
  ###   Returns a matrix of sample-wise Pearson Correlations.
}

.getMatrixPair <- function(eset.pair, use.ComBat) {
  genes.intersect <-
    intersect(featureNames(eset.pair[[1]]), featureNames(eset.pair[[2]]))
  for (i in 1:length(eset.pair)) {
    eset.pair[[i]] <- eset.pair[[i]][genes.intersect,]
  }
  ## Calculate correlation matrix for a pair of ExpressionSets:
  if (use.ComBat) {
    big.matrix <- do.call(cbind, lapply(eset.pair, exprs))
    if (any(!is.finite(big.matrix))) {
      all.finite <- apply(big.matrix, 1, function(x)
        all(is.finite(x)))
      big.matrix <- big.matrix[all.finite,]
      if (nrow(big.matrix) < 2)
        stop("Fewer than two genes without all finite values.")
    }
    batch.var <-
      lapply(names(eset.pair), function(x)
        rep(x, ncol(eset.pair[[x]])))
    batch.var <- do.call(c, batch.var)
    big.matrix.combat <-
      sva::ComBat(big.matrix, mod = model.matrix( ~ (rep(
        1, length(batch.var)
      ))), batch = batch.var)
    matrix.pair <-
      lapply(unique(batch.var), function(x)
        big.matrix.combat[, batch.var %in% x])
    names(matrix.pair) <- unique(batch.var)
  } else{
    matrix.pair <- lapply(eset.pair, exprs)
    names(matrix.pair) <- names(eset.pair)
  }
  return(matrix.pair)
}

library(Biobase)
library(doppelgangR)

ncor <- 0
npheno <- 0
nsmoking <- 0
options(stringsAsFactors = FALSE)
set.seed(1)
m1 <- matrix(rnorm(1100), ncol = 11)
colnames(m1) <- paste("m", 1:11, sep = "")
rownames(m1) <- make.names(1:nrow(m1))
n1 <- matrix(rnorm(1000), ncol = 10)
colnames(n1) <- paste("n", 1:10, sep = "")
rownames(n1) <- make.names(1:nrow(n1))
##m:1 & n:1 are expression doppelgangers:
m1[, 1] <- n1[, 1] + rnorm(100, sd = 0.25)
ncor <- ncor + 1
##m:2 & m:3 are expression doppelgangers:
m1[, 2] <- m1[, 3] + rnorm(100, sd = 0.25)
ncor <- ncor + 1
##n:2 & n:3 are expression doppelgangers:
n1[, 2] <- n1[, 3] + rnorm(100, sd = 0.25)
ncor <- ncor + 1
##n:8 & n:9 are expression doppelgangers:
n1[, 8] <- n1[, 9] + rnorm(100, sd = 0.25)
ncor <- ncor + 1
#n:4 & m:6 are expression doppelgangers:
n1[, 4] <- m1[, 6] + rnorm(100, sd = 0.25)
ncor <- ncor + 1
#n:5 & m:4 are expression doppelgangers:
n1[, 5] <- m1[, 4] + rnorm(100, sd = 0.25)
ncor <- ncor + 1

##
##m:10 and n:10 are phenotype doppelgangers:
m.pdata <-
  matrix(letters[sample(1:26, size = 110, replace = TRUE)], ncol = 10)
rownames(m.pdata) <- colnames(m1)
n.pdata <-
  matrix(letters[sample(1:26, size = 100, replace = TRUE)], ncol = 10)
n.pdata[10,] <- m.pdata[10,]
npheno <- npheno + 1
rownames(n.pdata) <- colnames(n1)



##Create ExpressionSets
m.eset <-
  ExpressionSet(assayData = m1, phenoData = AnnotatedDataFrame(data.frame(m.pdata)))
m.eset$id <- toupper(colnames(m1))
##
n.eset <-
  ExpressionSet(assayData = n1, phenoData = AnnotatedDataFrame(data.frame(n.pdata)))
n.eset$id <- toupper(colnames(n1))
##m5 and n4 are "smoking gun" doppelgangers:
n.eset$id[4] <- "gotcha"
m.eset$id[5] <- "gotcha"
nsmoking <- nsmoking + 1
##
esets <- list(m = m.eset, n = n.eset)

##------------------------------------------
##Check of all three types of doppelgangers:
##------------------------------------------
res1 <-
  doppelgangR(
    esets,
    manual.smokingguns = "id",
    automatic.smokingguns = FALSE,
    cache.dir = NULL
  )
df1 <- summary(res1)

expect_true(df1[df1$sample1 == "m:m1" &
                  df1$sample2 == "n:n1", "expr.doppel"])
expect_true(df1[df1$sample1 == "m:m2" &
                  df1$sample2 == "m:m3", "expr.doppel"])
expect_true(df1[df1$sample1 == "m:m6" &
                  df1$sample2 == "n:n4", "expr.doppel"])
expect_true(df1[df1$sample1 == "n:n2" &
                  df1$sample2 == "n:n3", "expr.doppel"])
expect_true(df1[df1$sample1 == "m:m6" &
                  df1$sample2 == "n:n4", "expr.doppel"])
expect_true(df1[df1$sample1 == "m:m10" &
                  df1$sample2 == "n:n10", "pheno.doppel"])
expect_true(df1[df1$sample1 == "m:m5" &
                  df1$sample2 == "n:n4", "smokinggun.doppel"])
expect_equal(nrow(df1), ncor + npheno + nsmoking)
expect_equal(sum(df1$expr.doppel), ncor)
expect_equal(sum(df1$pheno.doppel), npheno)
expect_equal(sum(df1$smokinggun.doppel), nsmoking)
expect_equal(sum(is.na(df1$expr.similarity)), 0)
expect_equal(sum(is.na(df1$pheno.similarity)), 0)
expect_equal(sum(is.na(df1$smokinggun.similarity)), 0)
expect_equal(
  df1$id,
  c(
    "M2:M3",
    "N2:N3",
    "N8:N9",
    "M1:N1",
    "gotcha:gotcha",
    "M6:gotcha",
    "M4:N5",
    "M10:N10"
  )
)
for (i in match(paste("X", 1:10, sep = ""), colnames(df1))) {
  lab <- paste("Checking column", i, "\n")
  expect_equal(all(grepl("[a-z]:[a-z]", df1[[i]])), TRUE, label = lab)
}

##------------------------------------------
## Check without smoking guns
##------------------------------------------
res2 <-
  doppelgangR(esets,
              smokingGunFinder.args = NULL,
              cache.dir = NULL)
df2 <- summary(res2)
for (i in grep("pheno.similarity|smokinggun.similarity",
               colnames(df1),
               invert = TRUE)) {
  lab <- paste("Check without smoking guns, column", i, "\n")
  expect_equal(df2[, i], df1[!df1$smokinggun.doppel, i], label = lab)
}


##------------------------------------------
## Check without phenotype
##------------------------------------------
res3 <-
  doppelgangR(
    esets,
    phenoFinder.args = NULL,
    manual.smokingguns = "id",
    automatic.smokingguns = FALSE,
    cache.dir = NULL
  )
df3 <- summary(res3)
for (i in grep("pheno.similarity", colnames(df1), invert = TRUE)) {
  lab <- paste("Check without phenotype column", i, "\n")
  expect_equal(df3[, i], df1[!df1$pheno.doppel, i], label = lab)
}

##------------------------------------------
## Check without expression
##------------------------------------------
res4 <-
  doppelgangR(
    esets,
    corFinder.args = NULL,
    manual.smokingguns = "id",
    automatic.smokingguns = FALSE,
    cache.dir = NULL
  )
df4 <- summary(res4)
for (i in grep("expr.similarity", colnames(df1), invert = TRUE)) {
  lab <- paste("Check without expression column", i, "\n")
  expect_equal(df4[, i], df1[!df1$expr.doppel, i], label = lab)
}

##------------------------------------------
## Check smoking guns only
##------------------------------------------
res4b <-
  doppelgangR(
    esets,
    corFinder.args = NULL,
    phenoFinder.args = NULL,
    manual.smokingguns = "id",
    automatic.smokingguns = FALSE,
    cache.dir = NULL
  )
df4b <- summary(res4b)
rownames(df4b) <- NULL
df4b.compare <-
  df1[df1$smokinggun.doppel,]
rownames(df4b.compare) <- NULL
##don't check expr and pheno columns
expect_identical(df4b.compare[,-3:-6], df4b[,-3:-6], label = "Check smoking guns only")


##------------------------------------------
## Check pruning
##------------------------------------------
res5 <-
  doppelgangR(
    esets,
    manual.smokingguns = "id",
    automatic.smokingguns = FALSE,
    intermediate.pruning = TRUE,
    cache.dir = NULL
  )
df5 <- summary(res5)
expect_equal(df1, df5, label = "Check pruning")

##------------------------------------------
## Check caching, with a third ExpressionSet that is almost identical to the first
##------------------------------------------
esets2 <- c(esets, esets[[1]])
names(esets2)[3] <- "o"
exprs(esets2[[3]]) <-
  exprs(esets2[[3]]) + rnorm(nrow(esets2[[3]]) * ncol(esets2[[3]]), sd =
                               0.1)
esets2[[3]]$X10 <- "a"
sampleNames(esets2[[3]]) <-
  paste("X", sampleNames(esets2[[3]]), sep = "")

tmpcachedir <- tempdir()
##Do this twice, so the second time the cache will be used:
for (i in 1:2) {
  res6 <-
    doppelgangR(
      esets2,
      manual.smokingguns = "id",
      automatic.smokingguns = FALSE,
      cache.dir = tmpcachedir
    )
  ##Make sure comparison of m to n is the same as res1:
  df6a <- summary(res6)
  df6a <-
    df6a[grepl("^[mn]", df6a$sample1) & grepl("^[mn]", df6a$sample2),]
  rownames(df6a) <- 1:nrow(df6a)
  expect_equal(df1, df6a, label = "Check caching, with a third ExpressionSet that is almost identical to the first")
}

df6b <- summary(res6)
df6b <-
  df6b[grepl("^[mo]", df6b$sample1) & grepl("^[mo]", df6b$sample2),]
expect_identical(df6b[df6b$sample1 == "o:Xm2" &
                        df6b$sample2 == "o:Xm3", "expr.doppel"], TRUE)
df6b <- df6b[-1:-2,]
##expect_true(all(df6b$expr.doppel))  ## not a bug, but a shortcoming in the outlier detection that these are not all identified as expression doppelgangers.
expect_true(all(df6b$pheno.doppel))
expect_true(all(df6b$smokinggun.doppel))


res7 <-
  doppelgangR(
    esets2,
    phenoFinder.args = NULL,
    smokingGunFinder.args = NULL,
    outlierFinder.expr.args = list(
      bonf.prob = 1.0,
      transFun = atanh,
      tail = "upper"
    ),
    cache.dir = NULL
  )
df7 <- summary(res7)
has.o <- grepl("^o", df7$sample1) | grepl("^o", df7$sample2)

df7a <- df7[has.o,]
df7a$sample1 <- sub("o", "m", df7a$sample1)
df7a$sample1 <- sub("X", "", df7a$sample1)
df7a$sample2 <- sub("o", "m", df7a$sample2)
df7a$sample2 <- sub("X", "", df7a$sample2)

df7b <- df7[!has.o,]
df7b <-
  df7b[(!grepl("^n", df7b$sample1) | !grepl("^n", df7b$sample2)),]
for (i in 1:nrow(df7a)) {
  df7a[i, 1:2] <- sort(as.character(df7a[i, 1:2]))
  df7b[i, 1:2] <- sort(as.character(df7b[i, 1:2]))
}
df7a <- df7a[order(df7a$sample1, df7a$sample2),]
df7b <- df7b[order(df7b$sample1, df7b$sample2),]
expect_true(all(df7a$expr.doppel == df7b$expr.doppel))
expect_true(all(df7a$pheno.doppel == df7b$pheno.doppel))
expect_true(all(df7a$smokinggun.doppel == df7b$smokinggun.doppel))

##------------------------------------------
## Check corFinder function
##------------------------------------------
cor1 <- corFinder(eset.pair = esets)
cor2 <- corFinder(eset.pair = esets[c(2, 1)])
expect_equal(cor1, t(cor2), label = "Check corFinder function")

cor1 <- corFinder(eset.pair = esets, use.ComBat = FALSE)
cor2 <- corFinder(eset.pair = esets[c(2, 1)], use.ComBat = FALSE)
expect_equal(cor1, t(cor2), label = "Check corFinder function 2")

cor1 <- corFinder(eset.pair = esets[c(1, 1)])
cor2 <- corFinder(eset.pair = esets[c(1, 1)], use.ComBat = FALSE)
expect_equal(cor1, cor2, label = "Check corFinder function 3")

##Check missing values:
exprs(esets[[1]])[1:10, 1:5] <- NA
expect_message(doppelgangR(esets[1:2]), regexp = "Finalizing", label = "check missing values 1")
## More missing values:
exprs(esets[[1]])[1:10, 1:8] <- NA
expect_warning(doppelgangR(esets[1:2]), regexp = "10 rows with more than 50 % entries missing", label = "check missing values 2")
## More missing values:
exprs(esets[[1]])[1:10, 1:11] <- NA
expect_warning(doppelgangR(esets[1:2]), regexp = "mean imputation used for these rows", label = "check missing values 3")
## infinite values:
exprs(esets[[1]])[14, 1] <- -Inf
exprs(esets[[1]])[15, 2] <- Inf
expect_warning(doppelgangR(esets[1:2]), regexp = "Inf with min/max expression values for dataset m", label = "check missing values 4")

##------------------------------------------
## Smoking guns only with cache=TRUE
##------------------------------------------
expect_warning(
  dop <-
    doppelgangR(
      esets,
      corFinder.args = NULL,
      phenoFinder.args = NULL,
      manual.smokingguns = "id"
    ),
  label = "Smoking guns only with cache=TRUE"
)
expect_equal(summary(dop)[, 1], "m:m5", label = "Smoking guns only with cache=TRUE 2")
expect_equal(summary(dop)[, 2], "n:n4", label = "Smoking guns only with cache=TRUE 3")


##------------------------------------------
## Identical ExpressionSets
##------------------------------------------
expect_warning(df1 <-
                 summary(doppelgangR(esets[[1]], cache.dir = NULL)), label = "Identical ExpressionSets 1")
expect_true(df1$sample1 == "m2", label = "Identical ExpressionSets 2")
expect_true(df1$sample2 == "m3", label = "Identical ExpressionSets 3")
##
df2 <- summary(doppelgangR(esets[[2]], cache.dir = NULL))
expect_true(all(df2$sample1 == "n2"), label = "Identical ExpressionSets 4")
expect_true(all(df2$sample2 == "n3"), label = "Identical ExpressionSets 4b")
##
expect_warning(df5 <-
                 summary(doppelgangR(
                   list(eset1 = esets[[1]], eset2 = esets[[2]]), cache.dir = NULL
                 )), label = "Identical ExpressionSets 5")
expect_warning(df6 <-
                 summary(doppelgangR(esets, cache.dir = NULL)), label = "Identical ExpressionSets 6")
expect_identical(df5[,-1:-2], df6[,-1:-2], label = "Identical ExpressionSets 7")
expect_identical(sub("eset2", "n", sub("eset1", "m", df5$sample1)), df6$sample1, label = "Identical ExpressionSets 8")
expect_identical(sub("eset2", "n", sub("eset1", "m", df5$sample2)), df6$sample2, label = "Identical ExpressionSets 9")

## with zero-column pData:
expect_warning(withpheno <-
                 summary(doppelgangR(esets)), label = "with zero-column pData")
esets3 <- esets
pData(esets3[[1]]) <- pData(esets3[[1]])[, 0]
expect_warning(withoutpheno <-
                 summary(doppelgangR(esets3)),
               regexp = "expression values for dataset m",
               label = "with zero-column pData 2")

pData(esets3[[2]]) <- pData(esets3[[2]])[, 0]
expect_warning(withoutpheno2 <-
                 summary(doppelgangR(esets3)),
               regexp = "with min/max expression values for dataset m",
               label = "with zero-column pData 3")

withoutpheno3 <- withoutpheno[!withoutpheno$pheno.doppel,]
withoutpheno4 <- withoutpheno2[!withoutpheno2$pheno.doppel,]

expect_identical(withoutpheno[, 1:4], withoutpheno3[, 1:4], label = "with zero-column pData 4")
expect_identical(withoutpheno2[, 1:4], withoutpheno4[, 1:4], label = "with zero-column pData 5")

esets4 <- esets
for (i in 1:length(esets4))
  pData(esets4[[i]]) <- pData(esets4[[i]])[1]
expect_warning(doppelgangR(esets4[[1]]), label = "with zero-column pData 6")
expect_s4_class(doppelgangR(esets4[[2]]), "DoppelGang")

#' doppelgangR
#'
#' Identify samples with suspiciously high correlations and phenotype
#' similarities
#'
#'
#' @param esets a list of ExpressionSets, containing the numeric and phenotypic
#' data to be analyzed.
#' @param separator a delimitor to use between dataset names and sample names
#' @param corFinder.args a list of arguments to be passed to the corFinder
#' function.
#' @param phenoFinder.args a list of arguments to be passed to the phenoFinder
#' function.  If NULL, samples with similar phenotypes will not be searched
#' for.
#' @param outlierFinder.expr.args a list of arguments to be passed to
#' outlierFinder when called for expression data
#' @param outlierFinder.pheno.args a list of arguments to be passed to
#' outlierFinder when called for phenotype data
#' @param smokingGunFinder.args a list of arguments to be passed to
#' smokingGunFinder
#' @param impute.knn.args a list of arguments to be passed to
#' impute::impute.knn.  Set to NULL to do no knn imputation.
#' @param manual.smokingguns a character vector of phenoData columns that, if
#' identical, will be considered evidence of duplication
#' @param automatic.smokingguns automatically look for "smoking guns."  If
#' TRUE, look for phenotype variables that are unique to each patient in
#' dataset 1, also unique to each patient in dataset 2, but contain exact
#' matches between datasets 1 and 2.
#' @param within.datasets.only If TRUE, only search within each dataset for
#' doppelgangers.
#' @param intermediate.pruning The default setting FALSE will result in output
#' with no missing values, but uses extra memory because all results from the
#' expression, phenotype, and smoking gun doppelganger searches must be saved
#' until the end.  Setting this to TRUE will save memory for very large
#' searches, but distance metrics will only be available if that value was
#' identified as a doppelganger (for example, phenotype doppelgangers will have
#' missing values for the expression and smoking gun similarity).
#' @param cache.dir The name of a directory in which to cache or look up
#' results to save re-calculating correlations.  Set to NULL for no caching.
#' @param BPPARAM Argument for BiocParallel::bplapply(), by default will use
#' all cores of a multi-core machine
#' @param verbose Print progress information
#'
#' @return Returns an object of S4-class "DoppelGang"
#'
#' @author Levi Waldron, Markus Riester, Marcel Ramos
#'
#' @seealso \link{DoppelGang-class}
#' \link[BiocParallel]{BiocParallelParam-class}
#'
#' @examples
#'
#' example("phenoFinder")
#'
#' results2 <- doppelgangR(esets2, cache.dir = NULL)
#' results2
#' plot(results2)
#' summary(results2)
#'
#' ## Set phenoFinder.args=NULL to ignore similar phenotypes, and
#' ## turn off ComBat batch correction:
#'
#' \dontrun{
#' results2 <- doppelgangR(testesets,
#' corFinder.args=list(use.ComBat=FALSE), phenoFinder.args=NULL,
#'     cache.dir=NULL)
#' summary(results2)
#'
#' library(curatedOvarianData)
#' data(GSE32062.GPL6480_eset)
#' data(GSE32063_eset)
#' data(GSE12470_eset)
#' data(GSE17260_eset)
#'
#' testesets <- list(JapaneseA = GSE32062.GPL6480_eset,
#'     JapaneseB = GSE32063_eset,
#'     Yoshihara2009 = GSE12470_eset,
#'     Yoshihara2010 = GSE17260_eset)
#'
#' ## standardize the sample ids to improve matching
#' ## based on clinical annotation
#'
#' testesets <- lapply(testesets, function(X) {
#'   X$alt_sample_name <-
#'     paste(X$sample_type, gsub("[^0-9]", "", X$alt_sample_name), sep = "_")
#'   pData(X) <-
#'     pData(X)[,!grepl("uncurated_author_metadata", colnames(pData(X)))]
#'   X[, 1:20]  ##speed computations
#' })
#'
#' (results1 <- doppelgangR(testesets, cache.dir = NULL))
#' plot(results1)
#' summary(results1)
#'
#' }
#'
#' @export doppelgangR
doppelgangR <- function
  ### Identify samples with suspiciously high correlations and phenotype similarities
  (
    esets,
    ### a list of ExpressionSets, containing the numeric and phenotypic data to be analyzed.
    separator = ":",
    ### a delimitor to use between dataset names and sample names
    corFinder.args = list(
      separator = separator,
      use.ComBat = TRUE,
      method = "pearson"
    ),
    ### a list of arguments to be passed to the corFinder function.
    phenoFinder.args = list(separator = separator, vectorDistFun = vectorWeightedDist),
    ### a list of arguments to be passed to the phenoFinder function.  If
    ### NULL, samples with similar phenotypes will not be searched for.
    outlierFinder.expr.args = list(
      bonf.prob = 0.5,
      transFun = atanh,
      tail = "upper"
    ),
    ### a list of arguments to be passed to outlierFinder when called for expression data
    outlierFinder.pheno.args = list(
      normal.upper.thresh = 0.99,
      bonf.prob = NULL,
      tail = "upper"
    ),
    ### a list of arguments to be passed to outlierFinder when called for phenotype data
    smokingGunFinder.args = list(transFun = I),
    ### a list of arguments to be passed to smokingGunFinder
    impute.knn.args = list(
      k = 10,
      rowmax = 0.5,
      colmax = 0.8,
      maxp = 1500,
      rng.seed = 362436069
    ),
    ### a list of arguments to be passed to impute::impute.knn.  Set to
    ### NULL to do no knn imputation.
    manual.smokingguns = NULL,
    ### a character vector of phenoData columns that, if identical, will
    ### be considered evidence of duplication
    automatic.smokingguns = FALSE,
    ### automatically look for "smoking guns."  If TRUE, look for
    ### phenotype variables that are unique to each patient in dataset 1,
    ### also unique to each patient in dataset 2, but contain exact
    ### matches between datasets 1 and 2.
    within.datasets.only = FALSE,
    ### If TRUE, only search within each dataset for doppelgangers.
    intermediate.pruning = FALSE,
    ### The default setting FALSE will result in output with no missing
    ### values, but uses extra memory because all results from the
    ### expression, phenotype, and smoking gun doppelganger searches must
    ### be saved until the end.  Setting this to TRUE will save memory for
    ### very large searches, but distance metrics will only be available
    ### if that value was identified as a doppelganger (for example,
    ### phenotype doppelgangers will have missing values for the
    ### expression and smoking gun similarity).
    cache.dir = "cache",
    ### The name of a directory in which to cache or look up results to save
    ### re-calculating correlations.  Set to NULL for no caching.
    BPPARAM = bpparam(),
    ### Argument for BiocParallel::bplapply(), by default what is returned by BiocParallel::bpparam(), 
    ### see ?BiocParallel::bpparam to change options.
    verbose = TRUE
    ### Print progress information
  ) {
    ##Save input args except for esets:
    input.argnames <- ls()[-match("esets", ls())]
    input.args <- lapply(input.argnames, function(x)
      get(x))
    names(input.args) <- input.argnames
    if (is(esets, "ExpressionSet")) {
      esets <- list(ExpressionSet1 = esets, ExpressionSet2 = esets)
      eset.method <- TRUE
      within.datasets.only <- FALSE
      between.datasets.only <- TRUE
    } else{
      eset.method <- FALSE
      between.datasets.only <- FALSE
    }
    if (!is(esets, "list")) {
      stop("esets must be an ExpressionSet or a list of ExpressionSets")
    }
    input.args$esets.names <- names(esets)
    if (!is.null(cache.dir))
      dir.create(cache.dir, showWarnings = FALSE)
    if (is.null(names(esets)))
      names(esets) <- paste("dataset", 1:length(esets), sep = "_")
    names(esets) <- make.unique(names(esets))
    for (i in 1:length(esets)) {
      sampleNames(esets[[i]]) <-
        paste(names(esets)[i], sampleNames(esets[[i]]), sep = separator)
      if (min(exprs(esets[[i]]), na.rm = TRUE) == -Inf |
          max(exprs(esets[[i]]), na.rm = TRUE) == Inf) {
        warning(paste(
          "Replacing -+Inf with min/max expression values for dataset",
          names(esets)[i]
        ))
        exprs(esets[[i]])[exprs(esets[[i]]) == -Inf] <-
          min(exprs(esets[[i]])[is.finite(exprs(esets[[i]]))], na.rm = TRUE)
        exprs(esets[[i]])[exprs(esets[[i]]) == Inf] <-
          max(exprs(esets[[i]])[is.finite(exprs(esets[[i]]))], na.rm = TRUE)
      }
      if (!is.null(impute.knn.args) &
          any(!complete.cases(exprs(esets[[i]])))) {
        ##KNN imputation
        message(paste("KNN imputation for", names(esets)[i]))
        impute.knn.args$data <- exprs(esets[[i]])
        impute.knn.output  <-
          do.call(impute::impute.knn, args = impute.knn.args)
        exprs(esets[[i]]) <- impute.knn.output$data
        .Random.seed <-
          impute.knn.output$rng.state  ##restore original RNG state
      }
    }
    ds.combns <- NULL
    if (!between.datasets.only)
      ds.combns <- lapply(1:length(esets), function(i)
        c(i, i))
    if (!within.datasets.only)
      ds.combns <-
      c(ds.combns, combn(1:length(esets), 2, simplify = FALSE))
    output.full <- bplapply(ds.combns, function(ij) {
      i <- ij[1]
      j <- ij[2]
      if (verbose)
        message(paste("Working on datasets", names(esets)[i], "and", names(esets)[j]))
      ## Create a negative result dataframe that will be used when a similarity-finder
      ## (corFinder, phenoFinder, smokingGunFinder) is not called.
      if (eset.method | identical(i, j)) {
        na.output <- matrix(0, nrow = ncol(esets[[i]]), ncol = ncol(esets[[i]]))
        rownames(na.output) <- sampleNames(esets[[i]])
        colnames(na.output) <- rownames(na.output)
        na.output[!upper.tri(na.output)] <- NA
      } else{
        na.output <- matrix(0, nrow = ncol(esets[[i]]), ncol = ncol(esets[[j]]))
        rownames(na.output) <- sampleNames(esets[[i]])
        colnames(na.output) <- sampleNames(esets[[j]])
      }
      na.output <- outlierFinder(na.output, normal.upper.thresh = 1)
      na.output$outlierFinder.res$similarity <- NA
      ## output object:
      output3 <- list()
      ## calculate correlation matrix
      if (sum(featureNames(esets[[i]]) %in% featureNames(esets[[j]])) < 2) {
        warning(
          paste(
            names(esets)[i],
            "and",
            names(esets)[j],
            "have no featureNames in common, skipping corFinder for this dataset pair."
          )
        )
        corFinder.args <- NULL
      }
      if (!is.null(cache.dir) & !is.null(corFinder.args)) {
        do.cache <- TRUE
        cache.file <- file.path(cache.dir,
                                paste0(digest::digest(
                                  list(corFinder,
                                       corFinder.args,
                                       esets[c(i, j)])
                                ),
                                ".rda"))
        if (file.exists(cache.file)) {
          if (verbose)
            message("\tSkipping corFinder, loading cached results.")
          load(cache.file)
        }
      } else{
        do.cache <- FALSE
      }
      if (is.null(corFinder.args)) {
        cor.sim <- na.output
      } else{
        corFinder.args$eset.pair <- esets[c(i, j)]
        if (!exists("cor.sim")) {
          if (verbose)
            message("Calculating correlations...")
          cor.sim <- do.call(corFinder, corFinder.args)
        }
      }
      if (eset.method)
        diag(cor.sim) <- NA
      if (do.cache &&
          !is.null(cache.dir) && !file.exists(cache.file))
        save(cor.sim, file = cache.file)
      ## find numeric (expression) doppelgangers
      outlierFinder.expr.args$similarity.mat <- cor.sim
      if (is.null(corFinder.args)) {
        output3[["expr.doppels"]] <- na.output
      } else{
        if (verbose)
          message("Identifying correlation doppelgangers...")
        output3[["correlations"]] <- cor.sim
        output3[["expr.doppels"]] <-
          do.call(outlierFinder, outlierFinder.expr.args)
      }
      ## If there is no phenoData in one of the esets, do not
      ## search for phenotype doppelgangers:
      if (min(c(ncol(pData(esets[[1]])), ncol(pData(esets[[2]])))) == 0)
        phenoFinder.args <- NULL
      ## If column names don't match, do not search for phenotype doppelgangers:
      if (!identical(colnames(pData(esets[[i]])), colnames(pData(esets[[j]])))) {
        warning(
          paste(
            names(esets)[i],
            "and",
            names(esets)[j],
            "have different column names in phenoData.  Skipping phenotype checking for this pair.  Set phenoFinger.args=NULL to disable phenotype checking altogether."
          )
        )
        phenoFinder.args <- NULL
      }
      ## automatically find potential "smoking gun" phenotypes
      if (automatic.smokingguns & !is.null(phenoFinder.args)) {
        new.smokinggun.phenotypes <-
          unlist(sapply(colnames(pData(esets[[i]])), function(cname) {
            if (cname %in% colnames(pData(esets[[j]]))) {
              if ((sum(!is.na(pData(esets[[i]])[, cname])) > 2 &
                   sum(!is.na(pData(esets[[j]])[, cname])) > 2) &
                  (identical(length(pData(esets[[i]])[, cname]), length(unique(
                    pData(esets[[i]])[, cname]
                  ))) |
                  identical(length(pData(esets[[j]])[, cname]), length(unique(
                    pData(esets[[j]])[, cname]
                  )))))
                return(cname)
            }
          }))
        manual.smokingguns <-
          unique(c(manual.smokingguns, new.smokinggun.phenotypes))
      }
      ##        output3[["smokingguns"]] <- manual.smokingguns  ##FIXME: write full arguments somewhere else
      if (is.null(manual.smokingguns)) {
        output3[["smokinggun.doppels"]] <- na.output
      } else{
        ## find smokinggun doppelgangers
        if (verbose)
          message("Identifying smoking-gun doppelgangers...")
        smokingGunFinder.args$eset.pair <- esets[c(i, j)]
        smokingGunFinder.args$smokingguns <- manual.smokingguns
        outlierFinder.smokinggun.args <- list()
        outlierFinder.smokinggun.args$similarity.mat <-
          do.call(smokingGunFinder, smokingGunFinder.args)
        if (eset.method)
          diag(outlierFinder.smokinggun.args$similarity.mat) <-
          NA
        outlierFinder.smokinggun.args$normal.upper.thresh <- 0.5
        output3[["smokinggun.doppels"]] <-
          do.call(outlierFinder, outlierFinder.smokinggun.args)
      }
      ## calculate phenotype similarity matrix
      if (is.null(phenoFinder.args)) {
        output3[["pheno.doppels"]] <- na.output
      } else{
        phenoFinder.args$eset.pair <- esets[c(i, j)]
        ##keep no rows because we only need pData(x):
        for (k in 1:2)
          phenoFinder.args$eset.pair[[k]] <-
            phenoFinder.args$eset.pair[[k]][0,]
        ## do not use "smoking guns" when calculating phenotype distances
        for (k in 1:2)
          if (any(manual.smokingguns %in% colnames(pData(phenoFinder.args$eset.pair[[k]]))))
            pData(phenoFinder.args$eset.pair[[k]]) <-
              pData(phenoFinder.args$eset.pair[[k]])[, (!colnames(pData(phenoFinder.args$eset.pair[[k]])) %in% manual.smokingguns)]
          if (do.cache && !is.null(cache.dir)) {
            cache.file <-
              paste(cache.dir, "/", digest::digest(list(phenoFinder, phenoFinder.args)), ".rda", sep =
                      "")
            if (file.exists(cache.file)) {
              if (verbose)
                message("\tSkipping phenoFinder, loading cached results.")
              load(cache.file)
            }
          }
          if (!exists("pheno.sim")) {
            if (verbose)
              message("Calculating phenotype similarities...")
            pheno.sim <- do.call(phenoFinder, phenoFinder.args)
            if (eset.method)
              diag(pheno.sim) <- NA
          }
          if (do.cache &&
              !is.null(cache.dir) && !file.exists(cache.file))
            save(pheno.sim, file = cache.file)
          ## find phenotype doppelgangers
          outlierFinder.pheno.args$similarity.mat <- pheno.sim
          if (verbose)
            message("Identifying phenotype doppelgangers...")
          output3[["pheno.doppels"]] <-
            do.call(outlierFinder, outlierFinder.pheno.args)
      }
      ##If a sample is identified as a doppelganger by any method,
      ##then keep that sample for all methods, so we don't lose the
      ##data when wrapping up:
      if (intermediate.pruning) {
        keep.rows <- output3[["pheno.doppels"]]$outlierFinder.res$doppel |
          output3[["expr.doppels"]]$outlierFinder.res$doppel |
          output3[["smokinggun.doppels"]]$outlierFinder.res$doppel
        output3[["smokinggun.doppels"]]$outlierFinder.res <-
          output3[["smokinggun.doppels"]]$outlierFinder.res[keep.rows,]
        output3[["pheno.doppels"]]$outlierFinder.res <-
          output3[["pheno.doppels"]]$outlierFinder.res[keep.rows,]
        output3[["expr.doppels"]]$outlierFinder.res <-
          output3[["expr.doppels"]]$outlierFinder.res[keep.rows,]
      }
      return(output3)
    }, BPPARAM = BPPARAM)
    has.errors <-
      sapply(output.full, function(x)
        any(grep("error", class(x))))
    if (any(has.errors)) {
      ds.errors <- ds.combns[has.errors]
      warning(paste0(
        "The following dataset combinations resulted in errors: ",
        paste(lapply(ds.errors, function(idx)
          paste(names(esets)[idx], collapse = "/")),
          collapse = ", ")
      ))
      warning(output.full[has.errors])
    }
    names(output.full) <- sapply(ds.combns, function(ij) {
      paste(names(esets)[c(ij[1], ij[2])], collapse = separator)
    })
    if (verbose)
      message("Finalizing...")
    wrapUp <- function(object, element) {
      tmp <- lapply(object, function(x)
        x[[element]]$outlierFinder.res)
      tmp <- tmp[!sapply(tmp, is.null)]
      tmp <- do.call(rbind, tmp)
      rownames(tmp) <- NULL
      return(tmp)
    }
    pheno.doppels <- wrapUp(output.full, "pheno.doppels")
    expr.doppels <- wrapUp(output.full, "expr.doppels")
    smokinggun.doppels <- wrapUp(output.full, "smokinggun.doppels")
    addCols <- function(orig, add) {
      newrows1 <- paste(add[, 1], add[, 2])
      newrows2 <- paste(add[, 2], add[, 1])
      oldrows <- paste(orig[, 2], orig[, 1])
      if (any(!(newrows1 %in% oldrows | newrows2 %in% oldrows))) {
        tmp <- add[!(newrows1 %in% oldrows | newrows2 %in% oldrows), 1:2]
        tmp <-
          cbind(tmp, matrix(NA, nrow = nrow(tmp), ncol = (ncol(orig) - 2)))
        colnames(tmp) <- colnames(orig)
        orig <- rbind(orig, tmp)
      }
      match.rows <-
        match(paste(add[, 1], add[, 2]), paste(orig[, 1], orig[, 2]))
      match.rows2 <-
        match(paste(add[, 2], add[, 1]), paste(orig[, 1], orig[, 2]))
      match.rows[is.na(match.rows)] <-
        match.rows2[is.na(match.rows)]
      if (nrow(add) > 0 & nrow(orig) == 0) {
        ##adding to a zero-row dataframe
        newdf <- add[, 1:2]
        for (i in 3:ncol(orig))
          newdf[[colnames(orig)[i]]] <- NA
        orig <- newdf
      }
      if (nrow(add) == 0 & nrow(orig) == 0) {
        return(cbind(orig, add[,-1:-2]))
      }
      orig[[colnames(add)[3]]] <- NA
      orig[[colnames(add)[3]]][match.rows] <- add[, 3]
      orig[[colnames(add)[4]]] <- FALSE
      orig[[colnames(add)[4]]][match.rows] <- add[, 4]
      orig
    }
    ## merge all doppelganger types
    all.doppels <- expr.doppels
    if (intermediate.pruning) {
      colnames(all.doppels)[3:4] <-
        paste("expr.", colnames(all.doppels)[3:4], sep = "")
      all.doppels <- addCols(all.doppels, pheno.doppels)
      colnames(all.doppels)[5:6] <-
        paste("pheno.", colnames(all.doppels)[5:6], sep = "")
      all.doppels <- addCols(all.doppels, smokinggun.doppels)
      colnames(all.doppels)[7:8] <-
        sub("pheno", "smokinggun", colnames(all.doppels)[5:6])
    } else{
      if (eset.method) {
        ##     pheno.doppels <- pheno.doppels[!sub(".+:", "", pheno.doppels[, 1]) == sub(".+:", "", pheno.doppels[, 2]), ]
        smokinggun.doppels <-
          smokinggun.doppels[!sub(".+:", "", smokinggun.doppels[, 1]) == sub(".+:", "", smokinggun.doppels[, 2]),]
        rownames(smokinggun.doppels) <- NULL
      }
      if (!is.null(expr.doppels) &
          identical(expr.doppels[, 1:2], pheno.doppels[, 1:2]) &
          identical(expr.doppels[, 1:2], smokinggun.doppels[, 1:2])) {
        all.doppels <-
          cbind(all.doppels, pheno.doppels[, 3:4], smokinggun.doppels[, 3:4])
        colnames(all.doppels)[3:8] <-
          paste(
            c(
              "expr",
              "expr",
              "pheno",
              "pheno",
              "smokinggun",
              "smokinggun"
            ),
            colnames(all.doppels)[3:8],
            sep = "."
          )
      } else{
        stop("Intermediate pruning off but no addCols shortcut available.")
      }
    }
    ##Following 2 lines needed if pruning is done above on output3:
    for (k in c(4, 6, 8))
      all.doppels[, k][is.na(all.doppels[, k])] <- FALSE
    all.doppels <-
      all.doppels[all.doppels[, 4] |
                    all.doppels[, 6] | all.doppels[, 8],]
    rownames(all.doppels) <- NULL
    ##If all esets have the same colnames of pdata, add merged
    ##pairwise sample pdata to all.doppels:
    if (identical(nrow(all.doppels) > 0, TRUE) &&
        identical(colnames(pData(esets[[1]])),
                  unique(unlist(lapply(esets, function(eset)
                    colnames(pData(eset)))))) &&
        ncol(pData(esets[[1]])) > 0 &&
        ncol(pData(esets[[2]])) > 0)  {
      all.pdat <- lapply(esets, pData)
      for (k in 1:length(all.pdat))
        all.pdat[[k]]$sampleid <- rownames(all.pdat[[k]])
      all.pdat <- do.call(rbind, all.pdat)
      pdat.sample1 <-
        all.pdat[match(all.doppels[, 1], all.pdat$sampleid),]
      pdat.sample2 <-
        all.pdat[match(all.doppels[, 2], all.pdat$sampleid),]
      merged.pdat <- lapply(1:ncol(pdat.sample1), function(k) {
        paste(pdat.sample1[, k],
              pdat.sample2[, k],
              sep = separator)
      })
      merged.pdat <- do.call(cbind, merged.pdat)
      merged.pdat <-
        subset(merged.pdat, select = -ncol(merged.pdat))
      colnames(merged.pdat) <- colnames(pData(esets[[1]]))
      all.doppels <- cbind(all.doppels, merged.pdat)
      if (eset.method) {
        all.doppels$sample1 <- sub(".+:", "", all.doppels$sample1)
        all.doppels$sample2 <-
          sub(".+:", "", all.doppels$sample2)
        ##Alternating rows only
        all.doppels <-
          all.doppels[seq(1, nrow(all.doppels), by = 2),]
      }
    }
    ### Returns an object of S4-class "DoppelGang".  See ?DoppelGang-class.
    new(
      "DoppelGang",
      fullresults = output.full,
      summaryresults = all.doppels,
      inputargs = input.args
    )
}

---
title: "doppelgängR"
author: "Levi Waldron"
date: "`r format(Sys.time(), '%B %d, %Y')`"
package: "`r pkg_ver('doppelgangR')`"
vignette: >
  %\VignetteIndexEntry{doppelgangR vignette}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
abstract: >
    Whole-genome analysis of cancer specimens is commonplace and
    investigators frequently share or re-use specimens in later studies.
    Duplicate expression profiles in public databases will impact
    re-analysis if left undetected, a so-called “doppelgänger” effect. The
    doppelgängR package uses batch correction and outlier detection among
    pairwise expression profile correlations to accurately identify
    duplicate profiles for cancer types where profiles are sufficiently
    distinct.  It is intended for use when nucleotide-level sequence data
    are unavailable, and is is effective even for specimens where
    duplicated samples are profiled by different microarray technologies,
    or by a combination of microarray and log-transformed RNA-seq data.
output:
  BiocStyle::html_document:
  toc: true
---

```{r, echo=FALSE, results='hide', eval=FALSE}
library(knitr)
opts_knit$set(cache=TRUE)
```

# doppelgängR

## Introduction

`r BiocStyle::Biocpkg("doppelgangR")` is a package for identifying duplicate
samples within or between datasets of transcriptome profiles. It is intended for
microarray and RNA-seq gene expression profiles where biological replicates are
ordinarily more distinct than technical replicates, as is the case for cancer
types with "noisy" genomes. It is intended for cases where per-gene summaries
are available but full genotypes are not, which is typical of public databases
such as the Gene Expression Omnibus.

Results from running `doppelgangR` on CRC, bladder, and ovarian
[on Dropbox](httpss://www.dropbox.com/sh/or3l7oo96x1ilm8/AAD1MVQVnoS6H7OExoYwOovSa?dl=0).

For the manuscript vignette, visit
<https://github.com/waldronlab/doppelgangR_paper>.

```{r, echo=FALSE, message=FALSE}
library(doppelgangR)
```

The `doppelgangR()` function identifies duplicates in three different ways:

* **"expression"** doppelgängers have highly similar expression profiles, which
are identified by default by having higher Pearson correlation than expected
based on an empirical distribution of Pearson correlations between biological
replicates. The type of correlation, and default use of ComBat batch correction,
can be changed using the "corFinder.args" argument.

* **"phenotype"** doppelgängers have highly similar clinical or phenotype data,
as contained in the phenoData slot of the `ExpressionSet`. In order to identify
duplicates this way, it is required to curate the phenoData of each
ExpressionSet they have identical column names, and encode phenotypes in the
same way.  For example, if each dataset provides information on age, this column
of the phenoData could be called "age" in every dataset, and encoded as an
integer number of years.  If the phenoData slots are NULL then this type of
checking will automatically be turned off.  If they are not NULL but are also
not curated, you should turn off phenotype checking by setting
`phenoFinder.args=NULL`.

* **"smoking gun"** doppelgängers have the same value for an identifier that
should be unique. You can enable this type of check by setting the argument
"manual.smokingguns" to the names of columns containing supposedly unique
identifiers, or setting "automatic.smokingguns" to TRUE, and the function will
assume any column containing unique values within the column should also be
unique across datasets.

This vignette focuses on the "expression" type of doppelgänger.

# Data types

Identification of doppelgängers is effective for both microarray and
**log-transformed** RNA-seq data, and even for matching samples that have been
profiled by microarray and RNA-seq.

# Case Study: Batch correction in Japanese datasets

We load for datasets by Yoshihara __et al.__ that have been curated
in `r BiocStyle::Biocexptpkg("curatedOvarianData")`.  These are objects of class `ExpressionSet`.

```{r, message = FALSE}
library(curatedOvarianData)
data(GSE32062.GPL6480_eset)
data(GSE17260_eset)
```

The `doppelgangR` function requires a list of
`ExpressionSet` objects as input, which we create here:

```{r testesets}
testesets <- list(JapaneseA=GSE32062.GPL6480_eset,
                  Yoshihara2010=GSE17260_eset)
```

Now run `doppelgangR` with default arguments, except for setting
`phenoFinder.args=NULL`, which turns off checking for similar clinical data in
the `phenoData` slot of the ExpressionSet objects:

```{r rundopp, results="hide", message=FALSE, cache=TRUE}
results1 <- doppelgangR(testesets, phenoFinder.args=NULL)
```

This creates an object of class `DoppelGang`, which has print, summary, and plot
methods.  Summary method output not shown here due to voluminous output:

```{r summarizedop, results='hide'}
summary(results1)
```

Plot creates a histogram of sample pairwise correlations within and between each
study:

```{r plotdop}
#| fig-cap: Doppelgängers identified on the basis of similar expression
#|   profiles. The vertical red lines indicate samples that were flagged.

par(mfrow=c(2,2), las=1)
plot(results1)
```

One of these histograms can be drawn using the plot.pair argument:

```{r plotdop2}
#| fig-cap: Pair plot of JapaneseA:JapaneseA Doppelgängers identified. The
#|   vertical red lines indicate samples that were flagged.

plot(results1, plot.pair=c("JapaneseA", "JapaneseA"))
```

# Important options

## Changing sensitivity

If after inspecting the histograms, you see that some visible outliers were not
caught, or non-outliers exceeded the sensitivity threshold, you can change the
default sensitivity using the argument:

```{r, eval=FALSE}
outlierFinder.expr.args =
    list(bonf.prob = 0.5, transFun = atanh, tail = "upper")
```

The default 0.5 is a reasonable but arbitrary trade-off between sensitivity and
specificity which we have found to often select dataset pairs containing
duplicates, but to often not find *all* the duplicate samples.  Sensitivity can
be increased by changing the bonf.prob argument, *i.e.*:

```{r rundopp2, results="hide", message=FALSE, eval=FALSE}
results1 <- doppelgangR(testesets, 
        outlierFinder.expr.args = list(bonf.prob = 1.0, transFun = atanh, 
                                       tail = "upper"))
```

## Use of the ExpressionSet

The `doppelgangR()` function takes as its main argument a list of
`ExpressionSet` objects.  If you just have matrices, you can easily convert
these to the `ExpressionSet` objects, for example:

```{r}
mat <- matrix(1:4, ncol=2)
library(Biobase)
eset <- ExpressionSet(mat)
class(eset)
```

## Parallelizing

The `doppelgangR()` function checks all pairwise combinations of datasets in a
list of `ExpressionSet` objects, and these dataset pairs can be checked in
parallel using multiple processing cores using the BPPARAM argument. This
functionality is imported from the \Biocpkg("BiocParallel") package. Please see
"?BiocParallel::\`BiocParallelParam-class\`" documentation. 

```{r, eval=FALSE}
results2 <- doppelgangR(testesets, BPPARAM = MulticoreParam(workers = 8))
```

## Caching

By default, the `doppelgangR()` function caches intermediate results to make
re-running with different arguments faster.  Turn caching off by setting the
argument `cache.dir=NULL`.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vectorHammingDist.R
\name{vectorHammingDist}
\alias{vectorHammingDist}
\title{Calculate Hamming Distance between two vectors, using pairwise complete
observations.}
\usage{
vectorHammingDist(x, y, k, l)
}
\arguments{
\item{x}{a matrix}

\item{y}{a matrix with the same number of columns as x}

\item{k}{row in x to test for differences}

\item{l}{row in y to test for differences}
}
\value{
Returns a numeric value, the Hamming Distance (the number of
non-equal values between x and y).
}
\description{
Simple function to count the fraction of different elements (in the same
position) between two vectors of the same length, after removing elements
from both vectors corresponding to positions that are NA in either vector.
}
\examples{

(mat <- matrix(c(paste0("A", 1:5), paste0("A", 5:1)),
    nrow = 2, byrow = TRUE))

stopifnot(vectorHammingDist(mat, mat, 1, 2) == 0.8)
stopifnot(vectorHammingDist(mat, mat, 1, 1) == 0)

mat[1, 1] <- NA

stopifnot(vectorHammingDist(mat, mat, 1, 2) == 0.75)
stopifnot(vectorHammingDist(mat, mat, 1, 1) == 0)

mat[1, 3] <- NA

stopifnot(vectorHammingDist(mat, mat, 1, 2) == 1)

}
\author{
Levi Waldron, Markus Riester, Marcel Ramos
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/outlierFinder.R
\name{outlierFinder}
\alias{outlierFinder}
\title{Identifies outliers in a similarity matrix.}
\usage{
outlierFinder(
  similarity.mat,
  bonf.prob = 0.05,
  transFun = atanh,
  normal.upper.thresh = NULL,
  tail = "upper"
)
}
\arguments{
\item{similarity.mat}{A matrix of similarities - larger values mean more
similar.}

\item{bonf.prob}{Bonferroni-corrected probability.  A raw.prob is calculated
by dividing this by the number of non-missing values in similarity.mat, and
the rejection threshold is qnorm(1-raw.prob, mean, sd) where mean and sd are
estimated from the transFun-transformed similarity.mat.}

\item{transFun}{A function applied to the numeric values of similarity.mat,
that should result in normally-distributed values.}

\item{normal.upper.thresh}{Instead of specifying bonf.prob and transFun, an
upper similarity threshold can be set, and values above this will be
considered likely duplicates.  If specified, this over-rides bonf.prob.}

\item{tail}{"upper" to look for samples with very high similarity values,
"lower" to look for very low values, or "both" to look for both.}
}
\value{
Returns either NULL or a dataframe with three columns: sample1,
sample2, and similarity.
}
\description{
By default uses the Fisher z-transform for Pearson correlation (atanh), and
identifies outliers as those above the quantile of a skew-t distribution
with mean and standard deviation estimated from the z-transformed matrix.
The quantile is calculated from the Bonferroni-corrected cumulative
probability of the upper tail.
}
\examples{

library(curatedOvarianData)
data(GSE32063_eset)
cormat <- cor(exprs(GSE32063_eset))
outlierFinder(cormat, bonf.prob = 0.05)

}
\author{
Levi Waldron, Markus Riester, Marcel Ramos
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/doppelgangR-package.R
\docType{package}
\name{doppelgangR-package}
\alias{doppelgangR-package}
\title{Identify likely duplicate samples from genomic or meta-data}
\description{
The main function is doppelgangR(), which takes as minimal input a list of
ExpressionSet object, and searches all list pairs for duplicated samples.
The search is based on the genomic data (exprs(eset)), phenotype/clinical
data (pData(eset)), and "smoking guns" - supposedly unique identifiers found
in pData(eset).
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/lwaldron/doppelgangR}
  \item Report bugs at \url{https://github.com/lwaldron/doppelgangR/issues}
}

}
\author{
Levi Waldron, Markus Riester, Marcel Ramos
}
\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sn.R
\name{mst.mle}
\alias{mst.mle}
\alias{st.mle}
\title{Maximum likelihood estimation for a (multivariate) skew-t distribution}
\usage{
mst.mle(
  X,
  y,
  freq,
  start,
  fixed.df = NA,
  trace = FALSE,
  algorithm = c("nlminb", "Nelder-Mead", "BFGS", "CG", "SANN"),
  control = list()
)

st.mle(
  X,
  y,
  freq,
  start,
  fixed.df = NA,
  trace = FALSE,
  algorithm = c("nlminb", "Nelder-Mead", "BFGS", "CG", "SANN"),
  control = list()
)
}
\arguments{
\item{X}{a matrix of covariate values.  If missing, a one-column matrix of
1's is created; otherwise, it must have the same number of rows of \code{y}.
If \code{X} is supplied, then it must include a column of 1's.}

\item{y}{a matrix (for \code{mst.mle}) or a vector (for \code{st.mle}). If
\code{y} is a matrix, rows refer to observations, and columns to components
of the multivariate distribution.}

\item{freq}{a vector of weights. If missing, a vector of 1's is created;
otherwise it must have length equal to the number of rows of \code{y}.}

\item{start}{for \code{mst.mle}, a list contaning the components
\code{beta},\code{Omega}, \code{alpha}, \code{df} of the type described
below; for \code{st.mle}, a vector whose components contain analogous
ingredients as before, with the exception that the scale parameter is the
square root of \code{Omega}.  In both cases, the \code{dp} component of the
returned list from a previous call has the required format and it can be
used as a new \code{start}. If the \code{start} parameter is missing,
initial values are selected by the function.}

\item{fixed.df}{a scalar value containing the degrees of freedom (df), if
these must be taked as fixed, or \code{NA} (default value) if \code{df} is a
parameter to be estimated.}

\item{trace}{logical value which controls printing of the algorithm
convergence. If \code{trace=TRUE}, details are printed. Default value is
\code{FALSE}.}

\item{algorithm}{a character string which selects the numerical optimization
procedure used to maximize the loglikelihood function. If this string is set
equal to \code{"nlminb"}, then this function is called; in all other cases,
\code{optim} is called, with \code{method} set equal to the given string.
Default value is \code{"nlminb"}.}

\item{control}{this parameter is passed to the chose optimizer, either
\code{nlminb} or \code{optim}; see the documentation of this function for
its usage.}
}
\value{
A list containing the following components:

\item{call}{ a string containing the calling statement. } \item{dp}{ for
\code{mst.mle}, this is a list containing the direct parameters \code{beta},
\code{Omega}, \code{alpha}. Here, \code{beta} is a matrix of regression
coefficients with \code{dim(beta)=c(ncol(X),ncol(y))}, \code{Omega} is a
covariance matrix of order \code{ncol(y)}, \code{alpha} is a vector of shape
parameters of length \code{ncol(y)}.  For \code{st.mle}, \code{dp} is a
vector of length \code{ncol(X)+3}, containing \code{c(beta, omega, alpha,
df)}, where \code{omega} is the square root of \code{Omega}. } \item{se}{ a
list containing the components \code{beta}, \code{alpha}, \code{info}. Here,
\code{beta} and \code{alpha} are the standard errors for the corresponding
point estimates; \code{info} is the observed information matrix for the
working parameter, as explained below. } \item{algorithm}{ the list returned
by the chose optimizer, either \code{nlminb} or \code{optim}, plus an item
with the \code{name} of the selected algorithm; see the documentation of
either \code{nlminb} or \code{optim} for explanation of the other
components. }
}
\description{
Fits a skew-t (ST) or multivariate skew-t (MST) distribution to data, or
fits a linear regression model with (multivariate) skew-t errors, using
maximum likelihood estimation.  Functions copied from \code{sn} CRAN library
v0.4.18 because they were later deprecated in that library.
}
\details{
If \code{y} is a vector and it is supplied to \code{mst.mle}, then it is
converted to a one-column matrix, and a scalar skew-t distribution is
fitted. This is also the mechanism used by \code{st.mle} which is simply an
interface to \code{mst.mle}.

The parameter \code{freq} is intended for use with grouped data, setting the
values of \code{y} equal to the central values of the cells; in this case
the resulting estimate is an approximation to the exact maximum likelihood
estimate. If \code{freq} is not set, exact maximum likelihood estimation is
performed.

% To fit a scalar skew-t distribution to grouped data by exact % maximum
likelihood estimation, use \code{st.mle.grouped}.

Numerical search of the maximum likelihood estimates is performed in a
suitable re-parameterization of the original parameters with aid of the
selected optimizer (\code{nlminb} or \code{optim}) which is supplied with
the derivatives of the log-likelihood function. Notice that, in case the
optimizer is \code{optim}), the gradient may or may not be used, depending
on which specific method has been selected.  On exit from the optimizer, an
inverse transformation of the parameters is performed. For a specific
description on the re-parametrization adopted, see Section 5.1 and Appendix
B of Azzalini \& Capitanio (2003).
}
\section{Background}{
 The family of multivariate skew-t distributions is an
extension of the multivariate Student's t family, via the introduction of a
\code{shape} parameter which regulates skewness; when \code{shape=0}, the
skew-t distribution reduces to the usual t distribution. When \code{df=Inf}
the distribution reduces to the multivariate skew-normal one; see
\code{dmsn}. See the reference below for additional information.
}

\examples{

dat <- rt(100, df=5, ncp=100)
fit <- st.mle(y=dat)
fit

}
\references{
Azzalini, A. and Capitanio, A. (2003).  Distributions generated
by perturbation of symmetry with emphasis on a multivariate skew \emph{t}
distribution.  The full version of the paper published in abriged form in
\emph{J.Roy. Statist. Soc. B} \bold{65}, 367--389, is available at
\url{http://azzalini.stat.unipd.it/SN/se-ext.ps}
}
\seealso{
\code{\link{dst}}
}
\keyword{distribution}
\keyword{regression}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/phenoFinder.R
\name{phenoFinder}
\alias{phenoFinder}
\title{Calculate pairwise similarities of phenoData between samples for a list
containing two ExpressionSets}
\usage{
phenoFinder(eset.pair, separator = ":", ...)
}
\arguments{
\item{eset.pair}{input: a list of ExpressionSets with two elements, or an
ExpressionSet.  If the two elements are identical, return the correlation
matrix for pairs of samples in the first element.  If not identical, return
pairs between the two elements.}

\item{separator}{a separator between dataset name (taken from the list
names) and sample name (taken from sampleNames(eset), to keep track of which
samples come from which dataset.}

\item{\dots}{Extra arguments passed on to phenoDist}
}
\value{
A matrix of similarities between the phenotypes of pairs of samples.
}
\description{
This function acts as a wrapper to phenoDist to handle cases of one
ExpressionSet, a list of two identical ExpressionSets, or a list of two
different ExpressionSets.
}
\examples{

library(curatedOvarianData)
data(GSE32063_eset)
data(GSE17260_eset)
esets2 <- list(JapaneseB=GSE32063_eset,
                Yoshihara2010=GSE17260_eset)

## standardize the sample ids to improve matching based on clinical annotation
esets2 <- lapply(esets2, function(X){
    X$alt_sample_name <- paste(X$sample_type, gsub("[^0-9]", "", X$alt_sample_name), sep="_")

## Removal of columns that cannot possibly match also helps duplicated patients to stand out
    pData(X) <- pData(X)[, !grepl("uncurated_author_metadata", colnames(pData(X)))]
    X <- X[, 1:20]  ##speed computations
    return(X) })

## See first six samples in both rows and columns
phenoFinder(esets2)[1:6, 1:6]

}
\author{
Levi Waldron, Markus Riester, Marcel Ramos
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sn.R
\name{dst}
\alias{dst}
\alias{pst}
\alias{qst}
\alias{rst}
\title{Skew-t Distribution}
\usage{
dst(x, location = 0, scale = 1, shape = 0, df = Inf, dp = NULL, log = FALSE)

rst(n = 1, location = 0, scale = 1, shape = 0, df = Inf, dp = NULL)

pst(x, location = 0, scale = 1, shape = 0, df = Inf, dp = NULL, ...)

qst(
  p,
  location = 0,
  scale = 1,
  shape = 0,
  df = Inf,
  tol = 1e-06,
  dp = NULL,
  ...
)
}
\arguments{
\item{x}{vector of quantiles. Missing values (\code{NA}s) are allowed.}

\item{location}{vector of location parameters.}

\item{scale}{vector of (positive) scale parameters.}

\item{shape}{vector of shape parameters. With \code{pst} and \code{qst}, it
must be of length 1.}

\item{df}{degrees of freedom (scalar); default is \code{df=Inf} which
corresponds to the skew-normal distribution.}

\item{dp}{a vector of length 4, whose elements represent location, scale
(positive), shape and df, respectively.  If \code{dp} is specified, the
individual parameters cannot be set.}

\item{log}{logical; if TRUE, densities are given as log-densities.}

\item{n}{sample size.}

\item{...}{additional parameters passed to \code{integrate}.}

\item{p}{vector of probabililities}

\item{tol}{a scalar value which regulates the accuracy of the result of
\code{qsn}.}
}
\value{
Density (\code{dst}), probability (\code{pst}), quantiles
(\code{qst}) and random sample (\code{rst}) from the skew-\eqn{t}
distribution with given \code{location}, \code{scale}, \code{shape} and
\code{df} parameters.
}
\description{
Density function, distribution function and random number generation for the
skew-\eqn{t} (ST) distribution.  Functions copied from \code{sn} CRAN
library v0.4.18 for argument name compatibility with \code{st.mle} function
from the same version.
}
\section{Details}{
 Typical usages are \preformatted{% dst(x, location=0,
scale=1, shape=0, df=Inf, log=FALSE) dst(x, dp=, log=FALSE) pst(x,
location=0, scale=1, shape=0, df=Inf, ...) pst(x, dp=, log=FALSE) qst(p,
location=0, scale=1, shape=0, df=Inf, tol=1e-8, ...) qst(x, dp=, log=FALSE)
rst(n=1, location=0, scale=1, shape=0, df=Inf) rst(x, dp=, log=FALSE) }
}

\examples{

pdf <- dst(seq(-4,4,by=0.1), shape=3, df=5)
rnd <- rst(100, 5, 2, -5, 8)
q <- qst(c(0.25,0.5,0.75), shape=3, df=5)
stopifnot(identical(all.equal(pst(q, shape=3, df=5), c(0.25,0.5,0.75)), TRUE))

}
\references{
Azzalini, A. and Capitanio, A. (2003). Distributions generated
by perturbation of symmetry with emphasis on a multivariate skew-\emph{t}
distribution. \emph{J.Roy. Statist. Soc. B} \bold{65}, 367--389.
}
\seealso{
\code{\link{st.mle}}
}
\keyword{distribution}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DoppelGang-class.R
\docType{class}
\name{DoppelGang-class}
\alias{DoppelGang-class}
\alias{DoppelGang}
\alias{summary,DoppelGang-method}
\alias{show,DoppelGang-method}
\alias{print,DoppelGang-method}
\title{DoppelGang S4 class}
\usage{
\S4method{summary}{DoppelGang}(object)

\S4method{show}{DoppelGang}(object)

\S4method{print}{DoppelGang}(x)
}
\arguments{
\item{x, object}{A DoppelGang class object}
}
\description{
S4 class containing results of doppelgangR() function.
}
\section{Objects from the Class}{
 Objects can be created by calls of the form
\code{new(DoppelGang ...)}
}

\seealso{
\code{\link{plot,DoppelGang-method}}
}
\author{
Levi Waldron and Markus Riester
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vectorWeightedDist.R
\name{vectorWeightedDist}
\alias{vectorWeightedDist}
\title{Calculate a weighted distance between two vectors, using pairwise complete
observations.}
\usage{
vectorWeightedDist(x, y, k, l)
}
\arguments{
\item{x}{a matrix}

\item{y}{a matrix with the same number of columns as x}

\item{k}{row in x to test for differences}

\item{l}{row in y to test for differences}
}
\value{
Returns a numeric value, the log of the probability of observing the
matches in x and y
}
\description{
Simple function to count the fraction of different elements (in the same
position) between two vectors of the same length, after removing elements
from both vectors corresponding to positions that are NA in either vector.
Distance is the probability for observing the matches and mismatches in two
random patients.
}
\examples{

mymat1 <- matrix(rnorm(20), ncol = 5)
mymat1[1, 4] <- NA
mymat2 <- matrix(rnorm(20), ncol = 5)
vectorWeightedDist(mymat1, mymat2, 1, 2)

}
\author{
Levi Waldron, Markus Riester, Marcel Ramos
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DoppelGang-class.R
\docType{methods}
\name{plot-methods}
\alias{plot-methods}
\alias{plot,DoppelGang}
\alias{plot,DoppelGang-method}
\alias{plot,DoppelGang,ANY-method}
\alias{plot.DoppelGang}
\alias{plot.doppelgangR}
\title{Histograms of all pairwise sample correlations, showing identified
doppelgangers.}
\usage{
\S4method{plot}{DoppelGang,ANY}(x, skip.no.doppels = FALSE, plot.pair = NULL, ...)
}
\arguments{
\item{x}{An object of class \code{\link{DoppelGang}}}

\item{skip.no.doppels}{(default FALSE) If TRUE, do not plot histograms where
no doppelgangers were identified.}

\item{plot.pair}{An optional character vector of length two, providing the
names of two datasets.  If provided, only the comparison of these two
datasets will be plotted.}

\item{\dots}{Additional arguments passed on to \code{\link{hist}}.}
}
\value{
None
}
\description{
Identified doppelgangers are shown with a red vertical line overlaid on a
histogram of pairwise sample correlations.  One plot is made per pair of
datasets.
}
\section{Methods}{
 \describe{ \item{list("signature(x = \"DoppelGang\")")}{
Histograms of all pairwise sample correlations, showing identified
doppelgangers. } }
}

\examples{

library(curatedOvarianData)
data(TCGA_eset)
data(GSE26712_eset)
## Remove some TCGA samples to speed computation:
keep.tcga <-
c("TCGA.13.2060", "TCGA.24.2290", "TCGA.25.2392", "TCGA.25.2404",
"TCGA.59.2349", "TCGA.09.2044", "TCGA.24.2262", "TCGA.24.2293",
"TCGA.25.2393", "TCGA.25.2408", "TCGA.59.2350", "TCGA.09.2045",
"TCGA.24.2267", "TCGA.59.2351", "TCGA.09.2048", "TCGA.24.2271",
"TCGA.24.2298", "TCGA.25.2398", "TCGA.59.2354", "TCGA.09.2050",
"TCGA.24.2281", "TCGA.09.2051", "TCGA.29.2428", "TCGA.09.2055",
"TCGA.24.2289", "TCGA.29.2414", "TCGA.59.2352", "TCGA.36.2532",
"TCGA.36.2529", "TCGA.36.2551", "TCGA.42.2590", "TCGA.13.2071",
"TCGA.29.2432", "TCGA.36.2537", "TCGA.36.2547", "TCGA.04.1369",
"TCGA.42.2591", "TCGA.23.2641", "TCGA.29.2434", "TCGA.36.2538",
"TCGA.36.2548", "TCGA.04.1516", "TCGA.42.2593", "TCGA.36.2549",
"TCGA.04.1644", "TCGA.13.2057", "TCGA.23.2647", "TCGA.36.2530",
"TCGA.36.2552", "TCGA.42.2587", "TCGA.13.2061", "TCGA.42.2588",
"TCGA.36.2544", "TCGA.42.2589", "TCGA.13.2066", "TCGA.61.2613",
"TCGA.61.2614", "TCGA.24.1852", "TCGA.29.1704", "TCGA.13.1819"
)
keep.tcga <- unique(c(keep.tcga, sampleNames(TCGA_eset)[1:200]))
testesets <- list(Bonome08=GSE26712_eset, TCGA=TCGA_eset[, keep.tcga])
results1 <- doppelgangR(testesets,
    corFinder.args=list(use.ComBat=FALSE), phenoFinder.args=NULL,
    cache.dir=NULL)
plot(results1)
}
\author{
Levi Waldron
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/colFinder.R
\name{colFinder}
\alias{colFinder}
\title{Calculate pairwise similarities of colData between samples for a list
containing two DataFrame}
\usage{
colFinder(summex.list, ...)
}
\arguments{
\item{summex.list}{input: a list of DataFrame with two elements, or a
DataFrame. If the two elements are identical, return the correlation
matrix for pairs of samples in the first element.  If not identical, return
pairs between the two elements.}

\item{\dots}{Extra arguments passed on to colFinder}
}
\value{
A matrix of similarities between the colData of pairs of samples.
}
\description{
This function acts as a wrapper to colData to handle cases of one
DataFrame, a list of two identical DataFrame, or a list of two
different DataFrame
}
\author{
Fabio Da Col, Marcel Ramos
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/smokingGunFinder.R
\name{smokingGunFinder}
\alias{smokingGunFinder}
\title{Find doppelgangers based on "smoking gun" phenotypes - those that should be
unique to each patient.}
\usage{
smokingGunFinder(eset.pair, smokingguns, transFun = I, separator = ":")
}
\arguments{
\item{eset.pair}{a list of ExpressionSets, with two elements.  If the two
elements are identical, the function will check for duplicate IDs within one
element. If not identical, it will check for duplicate IDs between elements.}

\item{smokingguns}{phenoData column names found in multiple elements of
eset.pair that may contain "smoking guns" such as identifiers that should be
unique to each sample.}

\item{transFun}{a function to apply to IDs before comparing.  By default
apply no transformation.}

\item{separator}{Separator between dataset name and sample name.  Dataset
names are added to sample names to keep track of dataset of origin.}
}
\value{
Returns an adjacency matrix for samples where matches have value 1,
non-matches have value zero.  Value for a sample against itself is NA.
}
\description{
Checks all pairwise combinations of samples for values of the "smoking" gun
phenotypes that are identical.
}
\examples{

example("phenoFinder")

smokingGunFinder(esets2, "days_to_death")

}
\author{
Levi Waldron, Markus Riester, Marcel Ramos
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/corFinder.R
\name{corFinder}
\alias{corFinder}
\title{Calculate pair-wise correlations between samples using the expr() slots of a
list of two ExpressionSets.}
\usage{
corFinder(eset.pair, separator = ":", use.ComBat = TRUE, ...)
}
\arguments{
\item{eset.pair}{a list of ExpressionSets, with two elements.  If the two
elements are identical, return the correlation matrix for pairs of samples
in the first element.  If not identical, return pairs between the two
elements.}

\item{separator}{Separator between dataset name and sample name.  Dataset
names are added to sample names to keep track of dataset of origin.}

\item{use.ComBat}{Use the sva::ComBat function for batch correction of the
expr() data between the two datasets.}

\item{\dots}{Extra arguments passed to the cor() function.}
}
\value{
Returns a matrix of sample-wise Pearson Correlations.
}
\description{
This function acts as a wrapper around ComBat (sva package) and cor(), to
calculate pairwise correlations within one or between two ExpressionSets.
}
\examples{

example("phenoFinder")

corFinder(esets2)

}
\author{
Levi Waldron, Markus Riester, Marcel Ramos
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/phenoDist.R
\name{phenoDist}
\alias{phenoDist}
\title{Calculate distance between two vectors, rows of one matrix/dataframe, or
rows of two matrices/dataframes.}
\usage{
phenoDist(x, y = NULL, bins = 10, vectorDistFun = vectorWeightedDist, ...)
}
\arguments{
\item{x}{A vector, matrix or dataframe}

\item{y}{NULL, a vector, matrix, or dataframe.  If x is a vector, y must
also be specified.}

\item{bins}{discretize continuous fields in the specified number of bins}

\item{vectorDistFun}{A function of two vectors that returns the distance
between those vectors.}

\item{\dots}{Extra arguments passed on to vectorDistFun}
}
\value{
a matrix of distances between pairs of rows of x (if y is
unspecified), or between all pairs of rows between x and y (if both are
provided).
}
\description{
This function does some simple looping to allow x and y to be various
combinations of vectors and matrices/dataframes.
}
\examples{

example("phenoFinder")

pdat1 <- pData(esets2[[1]])
pdat2 <- pData(esets2[[2]])

## Use phenoDist() to calculate a weighted distance matrix
distmat <- phenoDist(as.matrix(pdat1), as.matrix(pdat2))
## Note outliers with identical clinical data, these are probably the same patients:
graphics::boxplot(distmat)

\dontrun{
   library(curatedOvarianData)
   data(GSE32063_eset)
   data(GSE17260_eset)
   pdat1 <- pData(GSE32063_eset)
   pdat2 <- pData(GSE17260_eset)
   ## Curation of the alternative sample identifiers makes duplicates stand out more:
   pdat1$alt_sample_name <-
     paste(pdat1$sample_type,
           gsub("[^0-9]", "", pdat1$alt_sample_name),
           sep = "_")
   pdat2$alt_sample_name <-
     paste(pdat2$sample_type,
           gsub("[^0-9]", "", pdat2$alt_sample_name),
           sep = "_")
   ## Removal of columns that cannot possibly match also helps duplicated patients to stand out
   pdat1 <-
     pdat1[,!grepl("uncurated_author_metadata", colnames(pdat1))]
   pdat2 <-
     pdat2[,!grepl("uncurated_author_metadata", colnames(pdat2))]
   ## Use phenoDist() to calculate a weighted distance matrix
   distmat <- phenoDist(as.matrix(pdat1), as.matrix(pdat2))
   ## Note outliers with identical clinical data, these are probably the same patients:
   graphics::boxplot(distmat)
}

}
\author{
Levi Waldron, Markus Riester, Marcel Ramos
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/doppelgangR.R
\name{doppelgangR}
\alias{doppelgangR}
\title{doppelgangR}
\usage{
doppelgangR(
  esets,
  separator = ":",
  corFinder.args = list(separator = separator, use.ComBat = TRUE, method = "pearson"),
  phenoFinder.args = list(separator = separator, vectorDistFun = vectorWeightedDist),
  outlierFinder.expr.args = list(bonf.prob = 0.5, transFun = atanh, tail = "upper"),
  outlierFinder.pheno.args = list(normal.upper.thresh = 0.99, bonf.prob = NULL, tail =
    "upper"),
  smokingGunFinder.args = list(transFun = I),
  impute.knn.args = list(k = 10, rowmax = 0.5, colmax = 0.8, maxp = 1500, rng.seed =
    362436069),
  manual.smokingguns = NULL,
  automatic.smokingguns = FALSE,
  within.datasets.only = FALSE,
  intermediate.pruning = FALSE,
  cache.dir = "cache",
  BPPARAM = bpparam(),
  verbose = TRUE
)
}
\arguments{
\item{esets}{a list of ExpressionSets, containing the numeric and phenotypic
data to be analyzed.}

\item{separator}{a delimitor to use between dataset names and sample names}

\item{corFinder.args}{a list of arguments to be passed to the corFinder
function.}

\item{phenoFinder.args}{a list of arguments to be passed to the phenoFinder
function.  If NULL, samples with similar phenotypes will not be searched
for.}

\item{outlierFinder.expr.args}{a list of arguments to be passed to
outlierFinder when called for expression data}

\item{outlierFinder.pheno.args}{a list of arguments to be passed to
outlierFinder when called for phenotype data}

\item{smokingGunFinder.args}{a list of arguments to be passed to
smokingGunFinder}

\item{impute.knn.args}{a list of arguments to be passed to
impute::impute.knn.  Set to NULL to do no knn imputation.}

\item{manual.smokingguns}{a character vector of phenoData columns that, if
identical, will be considered evidence of duplication}

\item{automatic.smokingguns}{automatically look for "smoking guns."  If
TRUE, look for phenotype variables that are unique to each patient in
dataset 1, also unique to each patient in dataset 2, but contain exact
matches between datasets 1 and 2.}

\item{within.datasets.only}{If TRUE, only search within each dataset for
doppelgangers.}

\item{intermediate.pruning}{The default setting FALSE will result in output
with no missing values, but uses extra memory because all results from the
expression, phenotype, and smoking gun doppelganger searches must be saved
until the end.  Setting this to TRUE will save memory for very large
searches, but distance metrics will only be available if that value was
identified as a doppelganger (for example, phenotype doppelgangers will have
missing values for the expression and smoking gun similarity).}

\item{cache.dir}{The name of a directory in which to cache or look up
results to save re-calculating correlations.  Set to NULL for no caching.}

\item{BPPARAM}{Argument for BiocParallel::bplapply(), by default will use
all cores of a multi-core machine}

\item{verbose}{Print progress information}
}
\value{
Returns an object of S4-class "DoppelGang"
}
\description{
Identify samples with suspiciously high correlations and phenotype
similarities
}
\examples{

example("phenoFinder")

results2 <- doppelgangR(esets2, cache.dir = NULL)
results2
plot(results2)
summary(results2)

## Set phenoFinder.args=NULL to ignore similar phenotypes, and
## turn off ComBat batch correction:

\dontrun{
results2 <- doppelgangR(testesets,
corFinder.args=list(use.ComBat=FALSE), phenoFinder.args=NULL,
    cache.dir=NULL)
summary(results2)

library(curatedOvarianData)
data(GSE32062.GPL6480_eset)
data(GSE32063_eset)
data(GSE12470_eset)
data(GSE17260_eset)

testesets <- list(JapaneseA = GSE32062.GPL6480_eset,
    JapaneseB = GSE32063_eset,
    Yoshihara2009 = GSE12470_eset,
    Yoshihara2010 = GSE17260_eset)

## standardize the sample ids to improve matching
## based on clinical annotation

testesets <- lapply(testesets, function(X) {
  X$alt_sample_name <-
    paste(X$sample_type, gsub("[^0-9]", "", X$alt_sample_name), sep = "_")
  pData(X) <-
    pData(X)[,!grepl("uncurated_author_metadata", colnames(pData(X)))]
  X[, 1:20]  ##speed computations
})

(results1 <- doppelgangR(testesets, cache.dir = NULL))
plot(results1)
summary(results1)

}

}
\seealso{
\link{DoppelGang-class}
\link[BiocParallel]{BiocParallelParam-class}
}
\author{
Levi Waldron, Markus Riester, Marcel Ramos
}
